/**
 * vis-network
 * https://visjs.github.io/vis-network/
 *
 * A dynamic, browser-based visualization library.
 *
 * @version 7.10.0
 * @date    2020-07-11T12:33:22.079Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("component-emitter"),require("vis-util/esnext/umd/vis-util.js"),require("keycharm"),require("@egjs/hammerjs"),require("vis-data/esnext/umd/vis-data.js"),require("uuid"),require("timsort")):"function"==typeof define&&define.amd?define(["exports","component-emitter","vis-util/esnext/umd/vis-util.js","keycharm","@egjs/hammerjs","vis-data/esnext/umd/vis-data.js","uuid","timsort"],t):t((e=e||self).vis=e.vis||{},e.Emitter,e.vis,e.keycharm,e.Hammer,e.vis,e.uuid,e.timsort)}(this,(function(e,t,i,o,s,n,r,a){t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,o=o&&Object.prototype.hasOwnProperty.call(o,"default")?o.default:o,s=s&&Object.prototype.hasOwnProperty.call(s,"default")?s.default:s;var h="default"in a?a.default:a;function d(e,t,i,o){e.beginPath(),e.arc(t,i,o,0,2*Math.PI,!1),e.closePath()}function l(e,t,i,o,s,n){const r=Math.PI/180;o-2*n<0&&(n=o/2),s-2*n<0&&(n=s/2),e.beginPath(),e.moveTo(t+n,i),e.lineTo(t+o-n,i),e.arc(t+o-n,i+n,n,270*r,360*r,!1),e.lineTo(t+o,i+s-n),e.arc(t+o-n,i+s-n,n,0,90*r,!1),e.lineTo(t+n,i+s),e.arc(t+n,i+s-n,n,90*r,180*r,!1),e.lineTo(t,i+n),e.arc(t+n,i+n,n,180*r,270*r,!1),e.closePath()}function c(e,t,i,o,s){const n=o/2*.5522848,r=s/2*.5522848,a=t+o,h=i+s,d=t+o/2,l=i+s/2;e.beginPath(),e.moveTo(t,l),e.bezierCurveTo(t,l-r,d-n,i,d,i),e.bezierCurveTo(d+n,i,a,l-r,a,l),e.bezierCurveTo(a,l+r,d+n,h,d,h),e.bezierCurveTo(d-n,h,t,l+r,t,l),e.closePath()}function p(e,t,i,o,s){const n=s*(1/3),r=o/2*.5522848,a=n/2*.5522848,h=t+o,d=i+n,l=t+o/2,c=i+n/2,p=i+(s-n/2),u=i+s;e.beginPath(),e.moveTo(h,c),e.bezierCurveTo(h,c+a,l+r,d,l,d),e.bezierCurveTo(l-r,d,t,c+a,t,c),e.bezierCurveTo(t,c-a,l-r,i,l,i),e.bezierCurveTo(l+r,i,h,c-a,h,c),e.lineTo(h,p),e.bezierCurveTo(h,p+a,l+r,u,l,u),e.bezierCurveTo(l-r,u,t,p+a,t,p),e.lineTo(t,c)}function u(e,t,i,o,s,n){e.beginPath(),e.moveTo(t,i);const r=n.length,a=o-t,h=s-i,d=h/a;let l=Math.sqrt(a*a+h*h),c=0,p=!0,u=0,g=+n[0];for(;l>=.1;)g=+n[c++%r],g>l&&(g=l),u=Math.sqrt(g*g/(1+d*d)),u=a<0?-u:u,t+=u,i+=d*u,!0===p?e.lineTo(t,i):e.moveTo(t,i),l-=g,p=!p}const g={circle:d,dashedLine:u,database:p,diamond:function(e,t,i,o){e.beginPath(),e.lineTo(t,i+o),e.lineTo(t+o,i),e.lineTo(t,i-o),e.lineTo(t-o,i),e.closePath()},ellipse:c,ellipse_vis:c,hexagon:function(e,t,i,o){e.beginPath();const s=2*Math.PI/6;e.moveTo(t+o,i);for(let n=1;n<6;n++)e.lineTo(t+o*Math.cos(s*n),i+o*Math.sin(s*n));e.closePath()},roundRect:l,square:function(e,t,i,o){e.beginPath(),e.rect(t-o,i-o,2*o,2*o),e.closePath()},star:function(e,t,i,o){e.beginPath(),i+=.1*(o*=.82);for(let s=0;s<10;s++){const n=s%2==0?1.3*o:.5*o;e.lineTo(t+n*Math.sin(2*s*Math.PI/10),i-n*Math.cos(2*s*Math.PI/10))}e.closePath()},triangle:function(e,t,i,o){e.beginPath(),i+=.275*(o*=1.15);const s=2*o,n=s/2,r=Math.sqrt(3)/6*s,a=Math.sqrt(s*s-n*n);e.moveTo(t,i-(a-r)),e.lineTo(t+n,i+r),e.lineTo(t-n,i+r),e.lineTo(t,i-(a-r)),e.closePath()},triangleDown:function(e,t,i,o){e.beginPath(),i-=.275*(o*=1.15);const s=2*o,n=s/2,r=Math.sqrt(3)/6*s,a=Math.sqrt(s*s-n*n);e.moveTo(t,i+(a-r)),e.lineTo(t+n,i-r),e.lineTo(t-n,i-r),e.lineTo(t,i+(a-r)),e.closePath()}};function m(e){return E=e,function(){var e={};O=0,void(C=E.charAt(0)),R(),"strict"===k&&(e.strict=!0,R());"graph"!==k&&"digraph"!==k||(e.type=k,R());M===w&&(e.id=k,R());if("{"!=k)throw V("Angle bracket { expected");if(R(),A(e),"}"!=k)throw V("Angle bracket } expected");if(R(),""!==k)throw V("End of file expected");return R(),delete e.node,delete e.edge,delete e.graph,e}()}var b={fontsize:"font.size",fontcolor:"font.color",labelfontcolor:"font.color",fontname:"font.face",color:["color.border","color.background"],fillcolor:"color.background",tooltip:"title",labeltooltip:"title"},f=Object.create(b);f.color="color.color",f.style="dashes";var y=0,v=1,w=2,_=3,x={"{":!0,"}":!0,"[":!0,"]":!0,";":!0,"=":!0,",":!0,"->":!0,"--":!0},E="",O=0,C="",k="",M=y;function S(){O++,C=E.charAt(O)}function D(){return E.charAt(O+1)}var B=/[a-zA-Z_0-9.:#]/;function T(e){return B.test(e)}function P(e,t){if(e||(e={}),t)for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);return e}function z(e,t,i){for(var o=t.split("."),s=e;o.length;){var n=o.shift();o.length?(s[n]||(s[n]={}),s=s[n]):s[n]=i}}function F(e,t){for(var i,o,s=null,n=[e],r=e;r.parent;)n.push(r.parent),r=r.parent;if(r.nodes)for(i=0,o=r.nodes.length;i<o;i++)if(t.id===r.nodes[i].id){s=r.nodes[i];break}for(s||(s={id:t.id},e.node&&(s.attr=P(s.attr,e.node))),i=n.length-1;i>=0;i--){var a=n[i];a.nodes||(a.nodes=[]),-1===a.nodes.indexOf(s)&&a.nodes.push(s)}t.attr&&(s.attr=P(s.attr,t.attr))}function I(e,t){if(e.edges||(e.edges=[]),e.edges.push(t),e.edge){var i=P({},e.edge);t.attr=P(i,t.attr)}}function N(e,t,i,o,s){var n={from:t,to:i,type:o};return e.edge&&(n.attr=P({},e.edge)),n.attr=P(n.attr||{},s),null!=s&&s.hasOwnProperty("arrows")&&null!=s.arrows&&(n.arrows={to:{enabled:!0,type:s.arrows.type}},s.arrows=null),n}function R(){for(M=y,k="";" "===C||"\t"===C||"\n"===C||"\r"===C;)S();do{var e=!1;if("#"===C){for(var t=O-1;" "===E.charAt(t)||"\t"===E.charAt(t);)t--;if("\n"===E.charAt(t)||""===E.charAt(t)){for(;""!=C&&"\n"!=C;)S();e=!0}}if("/"===C&&"/"===D()){for(;""!=C&&"\n"!=C;)S();e=!0}if("/"===C&&"*"===D()){for(;""!=C;){if("*"===C&&"/"===D()){S(),S();break}S()}e=!0}for(;" "===C||"\t"===C||"\n"===C||"\r"===C;)S()}while(e);if(""!==C){var i=C+D();if(x[i])return M=v,k=i,S(),void S();if(x[C])return M=v,k=C,void S();if(T(C)||"-"===C){for(k+=C,S();T(C);)k+=C,S();return"false"===k?k=!1:"true"===k?k=!0:isNaN(Number(k))||(k=Number(k)),void(M=w)}if('"'===C){for(S();""!=C&&('"'!=C||'"'===C&&'"'===D());)'"'===C?(k+=C,S()):"\\"===C&&"n"===D()?(k+="\n",S()):k+=C,S();if('"'!=C)throw V('End of string " expected');return S(),void(M=w)}for(M=_;""!=C;)k+=C,S();throw new SyntaxError('Syntax error in part "'+q(k,30)+'"')}M=v}function A(e){for(;""!==k&&"}"!=k;)j(e),";"===k&&R()}function j(e){var t=H(e);if(t)L(e,t);else if(!function(e){if("node"===k)return R(),e.node=W(),"node";if("edge"===k)return R(),e.edge=W(),"edge";if("graph"===k)return R(),e.graph=W(),"graph";return null}(e)){if(M!=w)throw V("Identifier expected");var i=k;if(R(),"="===k){if(R(),M!=w)throw V("Identifier expected");e[i]=k,R()}else!function(e,t){var i={id:t},o=W();o&&(i.attr=o);F(e,i),L(e,t)}(e,i)}}function H(e){var t=null;if("subgraph"===k&&((t={}).type="subgraph",R(),M===w&&(t.id=k,R())),"{"===k){if(R(),t||(t={}),t.parent=e,t.node=e.node,t.edge=e.edge,t.graph=e.graph,A(t),"}"!=k)throw V("Angle bracket } expected");R(),delete t.node,delete t.edge,delete t.graph,delete t.parent,e.subgraphs||(e.subgraphs=[]),e.subgraphs.push(t)}return t}function L(e,t){for(;"->"===k||"--"===k;){var i,o=k;R();var s=H(e);if(s)i=s;else{if(M!=w)throw V("Identifier or subgraph expected");F(e,{id:i=k}),R()}I(e,N(e,t,i,o,W())),t=i}}function W(){for(var e,t,i=null,o={dashed:!0,solid:!1,dotted:[1,5]},s={dot:"circle",box:"box",crow:"crow",curve:"curve",icurve:"inv_curve",normal:"triangle",inv:"inv_triangle",diamond:"diamond",tee:"bar",vee:"vee"},n=new Array,r=new Array;"["===k;){for(R(),i={};""!==k&&"]"!=k;){if(M!=w)throw V("Attribute name expected");var a=k;if(R(),"="!=k)throw V("Equal sign = expected");if(R(),M!=w)throw V("Attribute value expected");var h=k;"style"===a&&(h=o[h]),"arrowhead"===a&&(a="arrows",h={to:{enabled:!0,type:s[h]}}),"arrowtail"===a&&(a="arrows",h={from:{enabled:!0,type:s[h]}}),n.push({attr:i,name:a,value:h}),r.push(a),R(),","==k&&R()}if("]"!=k)throw V("Bracket ] expected");R()}if(r.includes("dir")){var d={arrows:{}};for(e=0;e<n.length;e++)if("arrows"===n[e].name)if(null!=n[e].value.to)d.arrows.to=e;else{if(null==n[e].value.from)throw V("Invalid value of arrows");d.arrows.from=e}else"dir"===n[e].name&&(d.dir=e);var l,c,p=n[d.dir].value;if(!r.includes("arrows"))if("both"===p)n.push({attr:n[d.dir].attr,name:"arrows",value:{to:{enabled:!0}}}),d.arrows.to=n.length-1,n.push({attr:n[d.dir].attr,name:"arrows",value:{from:{enabled:!0}}}),d.arrows.from=n.length-1;else if("forward"===p)n.push({attr:n[d.dir].attr,name:"arrows",value:{to:{enabled:!0}}}),d.arrows.to=n.length-1;else if("back"===p)n.push({attr:n[d.dir].attr,name:"arrows",value:{from:{enabled:!0}}}),d.arrows.from=n.length-1;else{if("none"!==p)throw V('Invalid dir type "'+p+'"');n.push({attr:n[d.dir].attr,name:"arrows",value:""}),d.arrows.to=n.length-1}if("both"===p)d.arrows.to&&d.arrows.from?(c=n[d.arrows.to].value.to.type,l=n[d.arrows.from].value.from.type,n[d.arrows.to]={attr:n[d.arrows.to].attr,name:n[d.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}},n.splice(d.arrows.from,1)):d.arrows.to?(c=n[d.arrows.to].value.to.type,l="arrow",n[d.arrows.to]={attr:n[d.arrows.to].attr,name:n[d.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}):d.arrows.from&&(c="arrow",l=n[d.arrows.from].value.from.type,n[d.arrows.from]={attr:n[d.arrows.from].attr,name:n[d.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}});else if("back"===p)d.arrows.to&&d.arrows.from?(c="",l=n[d.arrows.from].value.from.type,n[d.arrows.from]={attr:n[d.arrows.from].attr,name:n[d.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}):d.arrows.to?(c="",l="arrow",d.arrows.from=d.arrows.to,n[d.arrows.from]={attr:n[d.arrows.from].attr,name:n[d.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}):d.arrows.from&&(c="",l=n[d.arrows.from].value.from.type,n[d.arrows.to]={attr:n[d.arrows.from].attr,name:n[d.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}),n[d.arrows.from]={attr:n[d.arrows.from].attr,name:n[d.arrows.from].name,value:{from:{enabled:!0,type:n[d.arrows.from].value.from.type}}};else if("none"===p){var u;n[u=d.arrows.to?d.arrows.to:d.arrows.from]={attr:n[u].attr,name:n[u].name,value:""}}else{if("forward"!==p)throw V('Invalid dir type "'+p+'"');d.arrows.to&&d.arrows.from||d.arrows.to?(c=n[d.arrows.to].value.to.type,l="",n[d.arrows.to]={attr:n[d.arrows.to].attr,name:n[d.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}):d.arrows.from&&(c="arrow",l="",d.arrows.to=d.arrows.from,n[d.arrows.to]={attr:n[d.arrows.to].attr,name:n[d.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}),n[d.arrows.to]={attr:n[d.arrows.to].attr,name:n[d.arrows.to].name,value:{to:{enabled:!0,type:n[d.arrows.to].value.to.type}}}}n.splice(d.dir,1)}if(r.includes("penwidth")){var g=[];for(t=n.length,e=0;e<t;e++)"width"!==n[e].name&&("penwidth"===n[e].name&&(n[e].name="width"),g.push(n[e]));n=g}for(t=n.length,e=0;e<t;e++)z(n[e].attr,n[e].name,n[e].value);return i}function V(e){return new SyntaxError(e+', got "'+q(k,30)+'" (char '+O+")")}function q(e,t){return e.length<=t?e:e.substr(0,27)+"..."}function U(e,t,i){for(var o=t.split("."),s=o.pop(),n=e,r=0;r<o.length;r++){var a=o[r];a in n||(n[a]={}),n=n[a]}return n[s]=i,e}function Y(e,t){var i={};for(var o in e)if(e.hasOwnProperty(o)){var s=t[o];Array.isArray(s)?s.forEach((function(t){U(i,t,e[o])})):U(i,"string"==typeof s?s:o,e[o])}return i}function X(e){var t=m(e),i={nodes:[],edges:[],options:{}};if(t.nodes&&t.nodes.forEach((function(e){var t={id:e.id,label:String(e.label||e.id)};P(t,Y(e.attr,b)),t.image&&(t.shape="image"),i.nodes.push(t)})),t.edges){var o=function(e){var t={from:e.from,to:e.to};return P(t,Y(e.attr,f)),null==t.arrows&&"->"===e.type&&(t.arrows="to"),t};t.edges.forEach((function(e){var t,s,n,r,a;t=e.from instanceof Object?e.from.nodes:{id:e.from},s=e.to instanceof Object?e.to.nodes:{id:e.to},e.from instanceof Object&&e.from.edges&&e.from.edges.forEach((function(e){var t=o(e);i.edges.push(t)})),n=t,r=s,a=function(t,s){var n=N(i,t.id,s.id,e.type,e.attr),r=o(n);i.edges.push(r)},Array.isArray(n)?n.forEach((function(e){Array.isArray(r)?r.forEach((function(t){a(e,t)})):a(e,r)})):Array.isArray(r)?r.forEach((function(e){a(n,e)})):a(n,r),e.to instanceof Object&&e.to.edges&&e.to.edges.forEach((function(e){var t=o(e);i.edges.push(t)}))}))}return t.attr&&(i.options=t.attr),i}var G=Object.freeze({__proto__:null,parseDOT:m,DOTToGraph:X});function K(e,t){const i={edges:{inheritColor:!1},nodes:{fixed:!1,parseColor:!1}};null!=t&&(null!=t.fixed&&(i.nodes.fixed=t.fixed),null!=t.parseColor&&(i.nodes.parseColor=t.parseColor),null!=t.inheritColor&&(i.edges.inheritColor=t.inheritColor));const o=e.edges.map(e=>{const t={from:e.source,id:e.id,to:e.target};return null!=e.attributes&&(t.attributes=e.attributes),null!=e.label&&(t.label=e.label),null!=e.attributes&&null!=e.attributes.title&&(t.title=e.attributes.title),"Directed"===e.type&&(t.arrows="to"),e.color&&!1===i.edges.inheritColor&&(t.color=e.color),t});return{nodes:e.nodes.map(e=>{const t={id:e.id,fixed:i.nodes.fixed&&null!=e.x&&null!=e.y};return null!=e.attributes&&(t.attributes=e.attributes),null!=e.label&&(t.label=e.label),null!=e.size&&(t.size=e.size),null!=e.attributes&&null!=e.attributes.title&&(t.title=e.attributes.title),null!=e.title&&(t.title=e.title),null!=e.x&&(t.x=e.x),null!=e.y&&(t.y=e.y),null!=e.color&&(!0===i.nodes.parseColor?t.color=e.color:t.color={background:e.color,border:e.color,highlight:{background:e.color,border:e.color},hover:{background:e.color,border:e.color}}),t}),edges:o}}var Z=Object.freeze({__proto__:null,parseGephi:K});var J=function(e,t,i){return e(i={path:t,exports:{},require:function(e,t){return function(){throw new Error("Dynamic requires are not currently supported by @rollup/plugin-commonjs")}(null==t&&i.path)}},i.exports),i.exports}((function(e){if("undefined"!=typeof window){var t=window.Hammer||s;e.exports=t}else e.exports=function(){return function(){const e=()=>{};return{on:e,off:e,destroy:e,emit:e,get:function(t){return{set:e}}}}()}}));function $(e){this.active=!1,this.dom={container:e},this.dom.overlay=document.createElement("div"),this.dom.overlay.className="vis-overlay",this.dom.container.appendChild(this.dom.overlay),this.hammer=J(this.dom.overlay),this.hammer.on("tap",this._onTapOverlay.bind(this));["tap","doubletap","press","pinch","pan","panstart","panmove","panend"].forEach(e=>{this.hammer.on(e,e=>{e.srcEvent.stopPropagation()})}),document&&document.body&&(this.onClick=t=>{(function(e,t){for(;e;){if(e===t)return!0;e=e.parentNode}return!1})(t.target,e)||this.deactivate()},document.body.addEventListener("click",this.onClick)),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=o(),this.escListener=this.deactivate.bind(this)}t($.prototype),$.current=null,$.prototype.destroy=function(){this.deactivate(),this.dom.overlay.parentNode.removeChild(this.dom.overlay),this.onClick&&document.body.removeEventListener("click",this.onClick),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=null,this.hammer.destroy(),this.hammer=null},$.prototype.activate=function(){$.current&&$.current.deactivate(),$.current=this,this.active=!0,this.dom.overlay.style.display="none",i.addClassName(this.dom.container,"vis-active"),this.emit("change"),this.emit("activate"),this.keycharm.bind("esc",this.escListener)},$.prototype.deactivate=function(){this.active=!1,this.dom.overlay.style.display="block",i.removeClassName(this.dom.container,"vis-active"),this.keycharm.unbind("esc",this.escListener),this.emit("change"),this.emit("deactivate")},$.prototype._onTapOverlay=function(e){this.activate(),e.srcEvent.stopPropagation()};var Q=Object.freeze({__proto__:null,en:{addDescription:"Click in an empty space to place a new node.",addEdge:"Add Edge",addNode:"Add Node",back:"Back",createEdgeError:"Cannot link edges to a cluster.",del:"Delete selected",deleteClusterError:"Clusters cannot be deleted.",edgeDescription:"Click on a node and drag the edge to another node to connect them.",edit:"Edit",editClusterError:"Clusters cannot be edited.",editEdge:"Edit Edge",editEdgeDescription:"Click on the control points and drag them to a node to connect to it.",editNode:"Edit Node"},de:{addDescription:"Klicke auf eine freie Stelle, um einen neuen Knoten zu plazieren.",addEdge:"Kante hinzufügen",addNode:"Knoten hinzufügen",back:"Zurück",createEdgeError:"Es ist nicht möglich, Kanten mit Clustern zu verbinden.",del:"Lösche Auswahl",deleteClusterError:"Cluster können nicht gelöscht werden.",edgeDescription:"Klicke auf einen Knoten und ziehe die Kante zu einem anderen Knoten, um diese zu verbinden.",edit:"Editieren",editClusterError:"Cluster können nicht editiert werden.",editEdge:"Kante editieren",editEdgeDescription:"Klicke auf die Verbindungspunkte und ziehe diese auf einen Knoten, um sie zu verbinden.",editNode:"Knoten editieren"},es:{addDescription:"Haga clic en un lugar vacío para colocar un nuevo nodo.",addEdge:"Añadir arista",addNode:"Añadir nodo",back:"Atrás",createEdgeError:"No se puede conectar una arista a un grupo.",del:"Eliminar selección",deleteClusterError:"No es posible eliminar grupos.",edgeDescription:"Haga clic en un nodo y arrastre la arista hacia otro nodo para conectarlos.",edit:"Editar",editClusterError:"No es posible editar grupos.",editEdge:"Editar arista",editEdgeDescription:"Haga clic en un punto de control y arrastrelo a un nodo para conectarlo.",editNode:"Editar nodo"},it:{addDescription:"Clicca per aggiungere un nuovo nodo",addEdge:"Aggiungi un vertice",addNode:"Aggiungi un nodo",back:"Indietro",createEdgeError:"Non si possono collegare vertici ad un cluster",del:"Cancella la selezione",deleteClusterError:"I cluster non possono essere cancellati",edgeDescription:"Clicca su un nodo e trascinalo ad un altro nodo per connetterli.",edit:"Modifica",editClusterError:"I clusters non possono essere modificati.",editEdge:"Modifica il vertice",editEdgeDescription:"Clicca sui Punti di controllo e trascinali ad un nodo per connetterli.",editNode:"Modifica il nodo"},nl:{addDescription:"Klik op een leeg gebied om een nieuwe node te maken.",addEdge:"Link toevoegen",addNode:"Node toevoegen",back:"Terug",createEdgeError:"Kan geen link maken naar een cluster.",del:"Selectie verwijderen",deleteClusterError:"Clusters kunnen niet worden verwijderd.",edgeDescription:"Klik op een node en sleep de link naar een andere node om ze te verbinden.",edit:"Wijzigen",editClusterError:"Clusters kunnen niet worden aangepast.",editEdge:"Link wijzigen",editEdgeDescription:"Klik op de verbindingspunten en sleep ze naar een node om daarmee te verbinden.",editNode:"Node wijzigen"},pt:{addDescription:"Clique em um espaço em branco para adicionar um novo nó",addEdge:"Adicionar aresta",addNode:"Adicionar nó",back:"Voltar",createEdgeError:"Não foi possível linkar arestas a um cluster.",del:"Remover selecionado",deleteClusterError:"Clusters não puderam ser removidos.",edgeDescription:"Clique em um nó e arraste a aresta até outro nó para conectá-los",edit:"Editar",editClusterError:"Clusters não puderam ser editados.",editEdge:"Editar aresta",editEdgeDescription:"Clique nos pontos de controle e os arraste para um nó para conectá-los",editNode:"Editar nó"},ru:{addDescription:"Кликните в свободное место, чтобы добавить новый узел.",addEdge:"Добавить ребро",addNode:"Добавить узел",back:"Назад",createEdgeError:"Невозможно соединить ребра в кластер.",del:"Удалить выбранное",deleteClusterError:"Кластеры не могут быть удалены",edgeDescription:"Кликните на узел и протяните ребро к другому узлу, чтобы соединить их.",edit:"Редактировать",editClusterError:"Кластеры недоступны для редактирования.",editEdge:"Редактировать ребро",editEdgeDescription:"Кликните на контрольные точки и перетащите их в узел, чтобы подключиться к нему.",editNode:"Редактировать узел"},cn:{addDescription:"单击空白处放置新节点。",addEdge:"添加连接线",addNode:"添加节点",back:"返回",createEdgeError:"无法将连接线连接到群集。",del:"删除选定",deleteClusterError:"无法删除群集。",edgeDescription:"单击某个节点并将该连接线拖动到另一个节点以连接它们。",edit:"编辑",editClusterError:"无法编辑群集。",editEdge:"编辑连接线",editEdgeDescription:"单击控制节点并将它们拖到节点上连接。",editNode:"编辑节点"},uk:{addDescription:"Kлікніть на вільне місце, щоб додати новий вузол.",addEdge:"Додати край",addNode:"Додати вузол",back:"Назад",createEdgeError:"Не можливо об'єднати краї в групу.",del:"Видалити обране",deleteClusterError:"Групи не можуть бути видалені.",edgeDescription:"Клікніть на вузол і перетягніть край до іншого вузла, щоб їх з'єднати.",edit:"Редагувати",editClusterError:"Групи недоступні для редагування.",editEdge:"Редагувати край",editEdgeDescription:"Клікніть на контрольні точки і перетягніть їх у вузол, щоб підключитися до нього.",editNode:"Редагувати вузол"},fr:{addDescription:"Cliquez dans un endroit vide pour placer un nœud.",addEdge:"Ajouter un lien",addNode:"Ajouter un nœud",back:"Retour",createEdgeError:"Impossible de créer un lien vers un cluster.",del:"Effacer la sélection",deleteClusterError:"Les clusters ne peuvent pas être effacés.",edgeDescription:"Cliquez sur un nœud et glissez le lien vers un autre nœud pour les connecter.",edit:"Éditer",editClusterError:"Les clusters ne peuvent pas être édités.",editEdge:"Éditer le lien",editEdgeDescription:"Cliquez sur les points de contrôle et glissez-les pour connecter un nœud.",editNode:"Éditer le nœud"},cs:{addDescription:"Kluknutím do prázdného prostoru můžete přidat nový vrchol.",addEdge:"Přidat hranu",addNode:"Přidat vrchol",back:"Zpět",createEdgeError:"Nelze připojit hranu ke shluku.",del:"Smazat výběr",deleteClusterError:"Nelze mazat shluky.",edgeDescription:"Přetažením z jednoho vrcholu do druhého můžete spojit tyto vrcholy novou hranou.",edit:"Upravit",editClusterError:"Nelze upravovat shluky.",editEdge:"Upravit hranu",editEdgeDescription:"Přetažením kontrolního vrcholu hrany ji můžete připojit k jinému vrcholu.",editNode:"Upravit vrchol"}});class ee{constructor(){this.NUM_ITERATIONS=4,this.image=new Image,this.canvas=document.createElement("canvas")}init(){if(!this.initialized()){this.src=this.image.src;var e=this.image.width,t=this.image.height;this.width=e,this.height=t;var i=Math.floor(t/2),o=Math.floor(t/4),s=Math.floor(t/8),n=Math.floor(t/16),r=Math.floor(e/2),a=Math.floor(e/4),h=Math.floor(e/8),d=Math.floor(e/16);this.canvas.width=3*a,this.canvas.height=i,this.coordinates=[[0,0,r,i],[r,0,a,o],[r,o,h,s],[5*h,o,d,n]],this._fillMipMap()}}initialized(){return void 0!==this.coordinates}_fillMipMap(){var e=this.canvas.getContext("2d"),t=this.coordinates[0];e.drawImage(this.image,t[0],t[1],t[2],t[3]);for(let t=1;t<this.NUM_ITERATIONS;t++){let i=this.coordinates[t-1],o=this.coordinates[t];e.drawImage(this.canvas,i[0],i[1],i[2],i[3],o[0],o[1],o[2],o[3])}}drawImageAtPosition(e,t,i,o,s,n){if(this.initialized())if(t>2){t*=.5;let r=0;for(;t>2&&r<this.NUM_ITERATIONS;)t*=.5,r+=1;r>=this.NUM_ITERATIONS&&(r=this.NUM_ITERATIONS-1);let a=this.coordinates[r];e.drawImage(this.canvas,a[0],a[1],a[2],a[3],i,o,s,n)}else e.drawImage(this.image,i,o,s,n)}}class te{constructor(e){this.images={},this.imageBroken={},this.callback=e}_tryloadBrokenUrl(e,t,i){void 0!==e&&void 0!==i&&(void 0!==t?(i.image.onerror=()=>{console.error("Could not load brokenImage:",t)},i.image.src=t):console.warn("No broken url image defined"))}_redrawWithImage(e){this.callback&&this.callback(e)}load(e,t){var i=this.images[e];if(i)return i;var o=new ee;return this.images[e]=o,o.image.onload=()=>{this._fixImageCoordinates(o.image),o.init(),this._redrawWithImage(o)},o.image.onerror=()=>{console.error("Could not load image:",e),this._tryloadBrokenUrl(e,t,o)},o.image.src=e,o}_fixImageCoordinates(e){0===e.width&&(document.body.appendChild(e),e.width=e.offsetWidth,e.height=e.offsetHeight,document.body.removeChild(e))}}class ie{constructor(){this.clear(),this.defaultIndex=0,this.groupsArray=[],this.groupIndex=0,this.defaultGroups=[{border:"#2B7CE9",background:"#97C2FC",highlight:{border:"#2B7CE9",background:"#D2E5FF"},hover:{border:"#2B7CE9",background:"#D2E5FF"}},{border:"#FFA500",background:"#FFFF00",highlight:{border:"#FFA500",background:"#FFFFA3"},hover:{border:"#FFA500",background:"#FFFFA3"}},{border:"#FA0A10",background:"#FB7E81",highlight:{border:"#FA0A10",background:"#FFAFB1"},hover:{border:"#FA0A10",background:"#FFAFB1"}},{border:"#41A906",background:"#7BE141",highlight:{border:"#41A906",background:"#A1EC76"},hover:{border:"#41A906",background:"#A1EC76"}},{border:"#E129F0",background:"#EB7DF4",highlight:{border:"#E129F0",background:"#F0B3F5"},hover:{border:"#E129F0",background:"#F0B3F5"}},{border:"#7C29F0",background:"#AD85E4",highlight:{border:"#7C29F0",background:"#D3BDF0"},hover:{border:"#7C29F0",background:"#D3BDF0"}},{border:"#C37F00",background:"#FFA807",highlight:{border:"#C37F00",background:"#FFCA66"},hover:{border:"#C37F00",background:"#FFCA66"}},{border:"#4220FB",background:"#6E6EFD",highlight:{border:"#4220FB",background:"#9B9BFD"},hover:{border:"#4220FB",background:"#9B9BFD"}},{border:"#FD5A77",background:"#FFC0CB",highlight:{border:"#FD5A77",background:"#FFD1D9"},hover:{border:"#FD5A77",background:"#FFD1D9"}},{border:"#4AD63A",background:"#C2FABC",highlight:{border:"#4AD63A",background:"#E6FFE3"},hover:{border:"#4AD63A",background:"#E6FFE3"}},{border:"#990000",background:"#EE0000",highlight:{border:"#BB0000",background:"#FF3333"},hover:{border:"#BB0000",background:"#FF3333"}},{border:"#FF6000",background:"#FF6000",highlight:{border:"#FF6000",background:"#FF6000"},hover:{border:"#FF6000",background:"#FF6000"}},{border:"#97C2FC",background:"#2B7CE9",highlight:{border:"#D2E5FF",background:"#2B7CE9"},hover:{border:"#D2E5FF",background:"#2B7CE9"}},{border:"#399605",background:"#255C03",highlight:{border:"#399605",background:"#255C03"},hover:{border:"#399605",background:"#255C03"}},{border:"#B70054",background:"#FF007E",highlight:{border:"#B70054",background:"#FF007E"},hover:{border:"#B70054",background:"#FF007E"}},{border:"#AD85E4",background:"#7C29F0",highlight:{border:"#D3BDF0",background:"#7C29F0"},hover:{border:"#D3BDF0",background:"#7C29F0"}},{border:"#4557FA",background:"#000EA1",highlight:{border:"#6E6EFD",background:"#000EA1"},hover:{border:"#6E6EFD",background:"#000EA1"}},{border:"#FFC0CB",background:"#FD5A77",highlight:{border:"#FFD1D9",background:"#FD5A77"},hover:{border:"#FFD1D9",background:"#FD5A77"}},{border:"#C2FABC",background:"#74D66A",highlight:{border:"#E6FFE3",background:"#74D66A"},hover:{border:"#E6FFE3",background:"#74D66A"}},{border:"#EE0000",background:"#990000",highlight:{border:"#FF3333",background:"#BB0000"},hover:{border:"#FF3333",background:"#BB0000"}}],this.options={},this.defaultOptions={useDefaultGroups:!0},Object.assign(this.options,this.defaultOptions)}setOptions(e){let t=["useDefaultGroups"];if(void 0!==e)for(let i in e)if(e.hasOwnProperty(i)&&-1===t.indexOf(i)){let t=e[i];this.add(i,t)}}clear(){this.groups={},this.groupsArray=[]}get(e,t=!0){let i=this.groups[e];if(void 0===i&&t)if(!1===this.options.useDefaultGroups&&this.groupsArray.length>0){let t=this.groupIndex%this.groupsArray.length;this.groupIndex++,i={},i.color=this.groups[this.groupsArray[t]],this.groups[e]=i}else{let t=this.defaultIndex%this.defaultGroups.length;this.defaultIndex++,i={},i.color=this.defaultGroups[t],this.groups[e]=i}return i}add(e,t){return this.groups[e]=t,this.groupsArray.push(e),t}}function oe(e,t){let o=["node","edge","label"],s=!0,n=i.topMost(t,"chosen");if("boolean"==typeof n)s=n;else if("object"==typeof n){if(-1===o.indexOf(e))throw new Error("choosify: subOption '"+e+"' should be one of '"+o.join("', '")+"'");let n=i.topMost(t,["chosen",e]);"boolean"!=typeof n&&"function"!=typeof n||(s=n)}return s}function se(e,t,i){if(e.width<=0||e.height<=0)return!1;if(void 0!==i){var o={x:t.x-i.x,y:t.y-i.y};if(0!==i.angle){var s=-i.angle;t={x:Math.cos(s)*o.x-Math.sin(s)*o.y,y:Math.sin(s)*o.x+Math.cos(s)*o.y}}else t=o}var n=e.x+e.width,r=e.y+e.width;return e.left<t.x&&n>t.x&&e.top<t.y&&r>t.y}function ne(e){return"string"==typeof e&&""!==e}function re(e,t,i,o){let s=o.x,n=o.y;if("function"==typeof o.distanceToBorder){const i=o.distanceToBorder(e,t),r=Math.sin(t)*i,a=Math.cos(t)*i;a===i?(s+=i,n=o.y):r===i?(s=o.x,n-=i):(s+=a,n-=r)}else o.shape.width>o.shape.height?(s=o.x+.5*o.shape.width,n=o.y-i):(s=o.x+i,n=o.y-.5*o.shape.height);return{x:s,y:n}}class ae{constructor(e){this.measureText=e,this.current=0,this.width=0,this.height=0,this.lines=[]}_add(e,t,i="normal"){void 0===this.lines[e]&&(this.lines[e]={width:0,height:0,blocks:[]});let o=t;void 0!==t&&""!==t||(o=" ");let s=this.measureText(o,i),n=Object.assign({},s.values);n.text=t,n.width=s.width,n.mod=i,void 0!==t&&""!==t||(n.width=0),this.lines[e].blocks.push(n),this.lines[e].width+=n.width}curWidth(){let e=this.lines[this.current];return void 0===e?0:e.width}append(e,t="normal"){this._add(this.current,e,t)}newLine(e,t="normal"){this._add(this.current,e,t),this.current++}determineLineHeights(){for(let e=0;e<this.lines.length;e++){let t=this.lines[e],i=0;if(void 0!==t.blocks)for(let e=0;e<t.blocks.length;e++){let o=t.blocks[e];i<o.height&&(i=o.height)}t.height=i}}determineLabelSize(){let e=0,t=0;for(let i=0;i<this.lines.length;i++){let o=this.lines[i];o.width>e&&(e=o.width),t+=o.height}this.width=e,this.height=t}removeEmptyBlocks(){let e=[];for(let t=0;t<this.lines.length;t++){let i=this.lines[t];if(0===i.blocks.length)continue;if(t===this.lines.length-1&&0===i.width)continue;let o,s={};Object.assign(s,i),s.blocks=[];let n=[];for(let e=0;e<i.blocks.length;e++){let t=i.blocks[e];0!==t.width?n.push(t):void 0===o&&(o=t)}0===n.length&&void 0!==o&&n.push(o),s.blocks=n,e.push(s)}return e}finalize(){this.determineLineHeights(),this.determineLabelSize();let e=this.removeEmptyBlocks();return{width:this.width,height:this.height,lines:e}}}var he={"<b>":/<b>/,"<i>":/<i>/,"<code>":/<code>/,"</b>":/<\/b>/,"</i>":/<\/i>/,"</code>":/<\/code>/,"*":/\*/,_:/\_/,"`":/`/,afterBold:/[^\*]/,afterItal:/[^_]/,afterMono:/[^`]/};class de{constructor(e){this.text=e,this.bold=!1,this.ital=!1,this.mono=!1,this.spacing=!1,this.position=0,this.buffer="",this.modStack=[],this.blocks=[]}mod(){return 0===this.modStack.length?"normal":this.modStack[0]}modName(){return 0===this.modStack.length?"normal":"mono"===this.modStack[0]?"mono":this.bold&&this.ital?"boldital":this.bold?"bold":this.ital?"ital":void 0}emitBlock(){this.spacing&&(this.add(" "),this.spacing=!1),this.buffer.length>0&&(this.blocks.push({text:this.buffer,mod:this.modName()}),this.buffer="")}add(e){" "===e&&(this.spacing=!0),this.spacing&&(this.buffer+=" ",this.spacing=!1)," "!=e&&(this.buffer+=e)}parseWS(e){return!!/[ \t]/.test(e)&&(this.mono?this.add(e):this.spacing=!0,!0)}setTag(e){this.emitBlock(),this[e]=!0,this.modStack.unshift(e)}unsetTag(e){this.emitBlock(),this[e]=!1,this.modStack.shift()}parseStartTag(e,t){return!(this.mono||this[e]||!this.match(t))&&(this.setTag(e),!0)}match(e,t=!0){let[i,o]=this.prepareRegExp(e),s=i.test(this.text.substr(this.position,o));return s&&t&&(this.position+=o-1),s}parseEndTag(e,t,i){let o=this.mod()===e;return o="mono"===e?o&&this.mono:o&&!this.mono,!(!o||!this.match(t))&&(void 0!==i?(this.position===this.text.length-1||this.match(i,!1))&&this.unsetTag(e):this.unsetTag(e),!0)}replace(e,t){return!!this.match(e)&&(this.add(t),this.position+=length-1,!0)}prepareRegExp(e){let t,i;if(e instanceof RegExp)i=e,t=1;else{var o=he[e];i=void 0!==o?o:new RegExp(e),t=e.length}return[i,t]}}class le{constructor(e,t,i,o){this.ctx=e,this.parent=t,this.selected=i,this.hover=o;this.lines=new ae((t,s)=>{if(void 0===t)return 0;let n=this.parent.getFormattingValues(e,i,o,s),r=0;if(""!==t){r=this.ctx.measureText(t).width}return{width:r,values:n}})}process(e){if(!ne(e))return this.lines.finalize();var t=this.parent.fontOptions;e=(e=e.replace(/\r\n/g,"\n")).replace(/\r/g,"\n");let i=String(e).split("\n"),o=i.length;if(t.multi)for(let e=0;e<o;e++){let o=this.splitBlocks(i[e],t.multi);if(void 0!==o)if(0!==o.length){if(t.maxWdt>0)for(let e=0;e<o.length;e++){let t=o[e].mod,i=o[e].text;this.splitStringIntoLines(i,t,!0)}else for(let e=0;e<o.length;e++){let t=o[e].mod,i=o[e].text;this.lines.append(i,t)}this.lines.newLine()}else this.lines.newLine("")}else if(t.maxWdt>0)for(let e=0;e<o;e++)this.splitStringIntoLines(i[e]);else for(let e=0;e<o;e++)this.lines.newLine(i[e]);return this.lines.finalize()}decodeMarkupSystem(e){let t="none";return"markdown"===e||"md"===e?t="markdown":!0!==e&&"html"!==e||(t="html"),t}splitHtmlBlocks(e){let t=new de(e),i=e=>{if(/&/.test(e)){return t.replace(t.text,"&lt;","<")||t.replace(t.text,"&amp;","&")||t.add("&"),!0}return!1};for(;t.position<t.text.length;){let e=t.text.charAt(t.position);t.parseWS(e)||/</.test(e)&&(t.parseStartTag("bold","<b>")||t.parseStartTag("ital","<i>")||t.parseStartTag("mono","<code>")||t.parseEndTag("bold","</b>")||t.parseEndTag("ital","</i>")||t.parseEndTag("mono","</code>"))||i(e)||t.add(e),t.position++}return t.emitBlock(),t.blocks}splitMarkdownBlocks(e){let t=new de(e),i=!0,o=e=>!!/\\/.test(e)&&(t.position<this.text.length+1&&(t.position++,e=this.text.charAt(t.position),/ \t/.test(e)?t.spacing=!0:(t.add(e),i=!1)),!0);for(;t.position<t.text.length;){let e=t.text.charAt(t.position);t.parseWS(e)||o(e)||(i||t.spacing)&&(t.parseStartTag("bold","*")||t.parseStartTag("ital","_")||t.parseStartTag("mono","`"))||t.parseEndTag("bold","*","afterBold")||t.parseEndTag("ital","_","afterItal")||t.parseEndTag("mono","`","afterMono")||(t.add(e),i=!1),t.position++}return t.emitBlock(),t.blocks}splitBlocks(e,t){let i=this.decodeMarkupSystem(t);return"none"===i?[{text:e,mod:"normal"}]:"markdown"===i?this.splitMarkdownBlocks(e):"html"===i?this.splitHtmlBlocks(e):void 0}overMaxWidth(e){let t=this.ctx.measureText(e).width;return this.lines.curWidth()+t>this.parent.fontOptions.maxWdt}getLongestFit(e){let t="",i=0;for(;i<e.length;){let o=t+(""===t?"":" ")+e[i];if(this.overMaxWidth(o))break;t=o,i++}return i}getLongestFitWord(e){let t=0;for(;t<e.length&&!this.overMaxWidth(e.slice(0,t));)t++;return t}splitStringIntoLines(e,t="normal",i=!1){this.parent.getFormattingValues(this.ctx,this.selected,this.hover,t);let o=(e=(e=e.replace(/^( +)/g,"$1\r")).replace(/([^\r][^ ]*)( +)/g,"$1\r$2\r")).split("\r");for(;o.length>0;){let e=this.getLongestFit(o);if(0===e){let e=o[0],i=this.getLongestFitWord(e);this.lines.newLine(e.slice(0,i),t),o[0]=e.slice(i)}else{let s=e;" "===o[e-1]?e--:" "===o[s]&&s++;let n=o.slice(0,e).join("");e==o.length&&i?this.lines.append(n,t):this.lines.newLine(n,t),o=o.slice(s)}}}}const ce=["bold","ital","boldital","mono"];class pe{constructor(e,t,i=!1){this.body=e,this.pointToSelf=!1,this.baseSize=void 0,this.fontOptions={},this.setOptions(t),this.size={top:0,left:0,width:0,height:0,yLine:0},this.isEdgeLabel=i}setOptions(e){if(this.elementOptions=e,this.initFontOptions(e.font),ne(e.label)?this.labelDirty=!0:e.label=void 0,void 0!==e.font&&null!==e.font)if("string"==typeof e.font)this.baseSize=this.fontOptions.size;else if("object"==typeof e.font){let t=e.font.size;void 0!==t&&(this.baseSize=t)}}initFontOptions(e){i.forEach(ce,e=>{this.fontOptions[e]={}}),pe.parseFontString(this.fontOptions,e)?this.fontOptions.vadjust=0:i.forEach(e,(e,t)=>{null!=e&&"object"!=typeof e&&(this.fontOptions[t]=e)})}static parseFontString(e,t){if(!t||"string"!=typeof t)return!1;let i=t.split(" ");return e.size=+i[0].replace("px",""),e.face=i[1],e.color=i[2],!0}constrain(e){let t={constrainWidth:!1,maxWdt:-1,minWdt:-1,constrainHeight:!1,minHgt:-1,valign:"middle"},o=i.topMost(e,"widthConstraint");if("number"==typeof o)t.maxWdt=Number(o),t.minWdt=Number(o);else if("object"==typeof o){let o=i.topMost(e,["widthConstraint","maximum"]);"number"==typeof o&&(t.maxWdt=Number(o));let s=i.topMost(e,["widthConstraint","minimum"]);"number"==typeof s&&(t.minWdt=Number(s))}let s=i.topMost(e,"heightConstraint");if("number"==typeof s)t.minHgt=Number(s);else if("object"==typeof s){let o=i.topMost(e,["heightConstraint","minimum"]);"number"==typeof o&&(t.minHgt=Number(o));let s=i.topMost(e,["heightConstraint","valign"]);"string"==typeof s&&("top"!==s&&"bottom"!==s||(t.valign=s))}return t}update(e,t){this.setOptions(e,!0),this.propagateFonts(t),i.deepExtend(this.fontOptions,this.constrain(t)),this.fontOptions.chooser=oe("label",t)}adjustSizes(e){let t=e?e.right+e.left:0;this.fontOptions.constrainWidth&&(this.fontOptions.maxWdt-=t,this.fontOptions.minWdt-=t);let i=e?e.top+e.bottom:0;this.fontOptions.constrainHeight&&(this.fontOptions.minHgt-=i)}addFontOptionsToPile(e,t){for(let i=0;i<t.length;++i)this.addFontToPile(e,t[i])}addFontToPile(e,t){if(void 0===t)return;if(void 0===t.font||null===t.font)return;let i=t.font;e.push(i)}getBasicOptions(e){let t={};for(let o=0;o<e.length;++o){let s=e[o],n={};pe.parseFontString(n,s)&&(s=n),i.forEach(s,(e,i)=>{void 0!==e&&(t.hasOwnProperty(i)||(-1!==ce.indexOf(i)?t[i]={}:t[i]=e))})}return t}getFontOption(e,t,i){let o;for(let s=0;s<e.length;++s){let n=e[s];if(n.hasOwnProperty(t)){if(o=n[t],null==o)continue;let e={};if(pe.parseFontString(e,o)&&(o=e),o.hasOwnProperty(i))return o[i]}}if(this.fontOptions.hasOwnProperty(i))return this.fontOptions[i];throw new Error("Did not find value for multi-font for property: '"+i+"'")}getFontOptions(e,t){let i={},o=["color","size","face","mod","vadjust"];for(let s=0;s<o.length;++s){let n=o[s];i[n]=this.getFontOption(e,t,n)}return i}propagateFonts(e){let t=[];this.addFontOptionsToPile(t,e),this.fontOptions=this.getBasicOptions(t);for(let e=0;e<ce.length;++e){let o=ce[e],s=this.fontOptions[o],n=this.getFontOptions(t,o);i.forEach(n,(e,t)=>{s[t]=e}),s.size=Number(s.size),s.vadjust=Number(s.vadjust)}}draw(e,t,i,o,s,n="middle"){if(void 0===this.elementOptions.label)return;let r=this.fontOptions.size*this.body.view.scale;this.elementOptions.label&&r<this.elementOptions.scaling.label.drawThreshold-1||(r>=this.elementOptions.scaling.label.maxVisible&&(r=Number(this.elementOptions.scaling.label.maxVisible)/this.body.view.scale),this.calculateLabelSize(e,o,s,t,i,n),this._drawBackground(e),this._drawText(e,t,this.size.yLine,n,r))}_drawBackground(e){if(void 0!==this.fontOptions.background&&"none"!==this.fontOptions.background){e.fillStyle=this.fontOptions.background;let t=this.getSize();e.fillRect(t.left,t.top,t.width,t.height)}}_drawText(e,t,i,o="middle",s){[t,i]=this._setAlignment(e,t,i,o),e.textAlign="left",t-=this.size.width/2,this.fontOptions.valign&&this.size.height>this.size.labelHeight&&("top"===this.fontOptions.valign&&(i-=(this.size.height-this.size.labelHeight)/2),"bottom"===this.fontOptions.valign&&(i+=(this.size.height-this.size.labelHeight)/2));for(let o=0;o<this.lineCount;o++){let n=this.lines[o];if(n&&n.blocks){let o=0;this.isEdgeLabel||"center"===this.fontOptions.align?o+=(this.size.width-n.width)/2:"right"===this.fontOptions.align&&(o+=this.size.width-n.width);for(let r=0;r<n.blocks.length;r++){let a=n.blocks[r];e.font=a.font;let[h,d]=this._getColor(a.color,s,a.strokeColor);a.strokeWidth>0&&(e.lineWidth=a.strokeWidth,e.strokeStyle=d,e.lineJoin="round"),e.fillStyle=h,a.strokeWidth>0&&e.strokeText(a.text,t+o,i+a.vadjust),e.fillText(a.text,t+o,i+a.vadjust),o+=a.width}i+=n.height}}}_setAlignment(e,t,i,o){if(this.isEdgeLabel&&"horizontal"!==this.fontOptions.align&&!1===this.pointToSelf){t=0,i=0;let o=2;"top"===this.fontOptions.align?(e.textBaseline="alphabetic",i-=2*o):"bottom"===this.fontOptions.align?(e.textBaseline="hanging",i+=2*o):e.textBaseline="middle"}else e.textBaseline=o;return[t,i]}_getColor(e,t,o){let s=e||"#000000",n=o||"#ffffff";if(t<=this.elementOptions.scaling.label.drawThreshold){let e=Math.max(0,Math.min(1,1-(this.elementOptions.scaling.label.drawThreshold-t)));s=i.overrideOpacity(s,e),n=i.overrideOpacity(n,e)}return[s,n]}getTextSize(e,t=!1,i=!1){return this._processLabel(e,t,i),{width:this.size.width,height:this.size.height,lineCount:this.lineCount}}getSize(){let e=this.size.left,t=this.size.top-1;if(this.isEdgeLabel){const i=.5*-this.size.width;switch(this.fontOptions.align){case"middle":e=i,t=.5*-this.size.height;break;case"top":e=i,t=-(this.size.height+2);break;case"bottom":e=i,t=2}}return{left:e,top:t,width:this.size.width,height:this.size.height}}calculateLabelSize(e,t,i,o=0,s=0,n="middle"){this._processLabel(e,t,i),this.size.left=o-.5*this.size.width,this.size.top=s-.5*this.size.height,this.size.yLine=s+.5*(1-this.lineCount)*this.fontOptions.size,"hanging"===n&&(this.size.top+=.5*this.fontOptions.size,this.size.top+=4,this.size.yLine+=4)}getFormattingValues(e,t,i,o){let s=function(e,t,i){return"normal"===t?"mod"===i?"":e[i]:void 0!==e[t][i]?e[t][i]:e[i]},n={color:s(this.fontOptions,o,"color"),size:s(this.fontOptions,o,"size"),face:s(this.fontOptions,o,"face"),mod:s(this.fontOptions,o,"mod"),vadjust:s(this.fontOptions,o,"vadjust"),strokeWidth:this.fontOptions.strokeWidth,strokeColor:this.fontOptions.strokeColor};(t||i)&&("normal"===o&&!0===this.fontOptions.chooser&&this.elementOptions.labelHighlightBold?n.mod="bold":"function"==typeof this.fontOptions.chooser&&this.fontOptions.chooser(n,this.elementOptions.id,t,i));let r="";return void 0!==n.mod&&""!==n.mod&&(r+=n.mod+" "),r+=n.size+"px "+n.face,e.font=r.replace(/"/g,""),n.font=e.font,n.height=n.size,n}differentState(e,t){return e!==this.selectedState||t!==this.hoverState}_processLabelText(e,t,i,o){return new le(e,this,t,i).process(o)}_processLabel(e,t,i){if(!1===this.labelDirty&&!this.differentState(t,i))return;let o=this._processLabelText(e,t,i,this.elementOptions.label);this.fontOptions.minWdt>0&&o.width<this.fontOptions.minWdt&&(o.width=this.fontOptions.minWdt),this.size.labelHeight=o.height,this.fontOptions.minHgt>0&&o.height<this.fontOptions.minHgt&&(o.height=this.fontOptions.minHgt),this.lines=o.lines,this.lineCount=o.lines.length,this.size.width=o.width,this.size.height=o.height,this.selectedState=t,this.hoverState=i,this.labelDirty=!1}visible(){if(0===this.size.width||0===this.size.height||void 0===this.elementOptions.label)return!1;return!(this.fontOptions.size*this.body.view.scale<this.elementOptions.scaling.label.drawThreshold-1)}}class ue{constructor(e,t,i){this.body=t,this.labelModule=i,this.setOptions(e),this.top=void 0,this.left=void 0,this.height=void 0,this.width=void 0,this.radius=void 0,this.margin=void 0,this.refreshNeeded=!0,this.boundingBox={top:0,left:0,right:0,bottom:0}}setOptions(e){this.options=e}_setMargins(e){this.margin={},this.options.margin&&("object"==typeof this.options.margin?(this.margin.top=this.options.margin.top,this.margin.right=this.options.margin.right,this.margin.bottom=this.options.margin.bottom,this.margin.left=this.options.margin.left):(this.margin.top=this.options.margin,this.margin.right=this.options.margin,this.margin.bottom=this.options.margin,this.margin.left=this.options.margin)),e.adjustSizes(this.margin)}_distanceToBorder(e,t){var i=this.options.borderWidth;return e&&this.resize(e),Math.min(Math.abs(this.width/2/Math.cos(t)),Math.abs(this.height/2/Math.sin(t)))+i}enableShadow(e,t){t.shadow&&(e.shadowColor=t.shadowColor,e.shadowBlur=t.shadowSize,e.shadowOffsetX=t.shadowX,e.shadowOffsetY=t.shadowY)}disableShadow(e,t){t.shadow&&(e.shadowColor="rgba(0,0,0,0)",e.shadowBlur=0,e.shadowOffsetX=0,e.shadowOffsetY=0)}enableBorderDashes(e,t){if(!1!==t.borderDashes)if(void 0!==e.setLineDash){let i=t.borderDashes;!0===i&&(i=[5,15]),e.setLineDash(i)}else console.warn("setLineDash is not supported in this browser. The dashed borders cannot be used."),this.options.shapeProperties.borderDashes=!1,t.borderDashes=!1}disableBorderDashes(e,t){!1!==t.borderDashes&&(void 0!==e.setLineDash?e.setLineDash([0]):(console.warn("setLineDash is not supported in this browser. The dashed borders cannot be used."),this.options.shapeProperties.borderDashes=!1,t.borderDashes=!1))}needsRefresh(e,t){return!0===this.refreshNeeded?(this.refreshNeeded=!1,!0):void 0===this.width||this.labelModule.differentState(e,t)}initContextForDraw(e,t){var i=t.borderWidth/this.body.view.scale;e.lineWidth=Math.min(this.width,i),e.strokeStyle=t.borderColor,e.fillStyle=t.color}performStroke(e,t){var i=t.borderWidth/this.body.view.scale;e.save(),i>0&&(this.enableBorderDashes(e,t),e.stroke(),this.disableBorderDashes(e,t)),e.restore()}performFill(e,t){e.save(),e.fillStyle=t.color,this.enableShadow(e,t),e.fill(),this.disableShadow(e,t),e.restore(),this.performStroke(e,t)}_addBoundingBoxMargin(e){this.boundingBox.left-=e,this.boundingBox.top-=e,this.boundingBox.bottom+=e,this.boundingBox.right+=e}_updateBoundingBox(e,t,i,o,s){void 0!==i&&this.resize(i,o,s),this.left=e-this.width/2,this.top=t-this.height/2,this.boundingBox.left=this.left,this.boundingBox.top=this.top,this.boundingBox.bottom=this.top+this.height,this.boundingBox.right=this.left+this.width}updateBoundingBox(e,t,i,o,s){this._updateBoundingBox(e,t,i,o,s)}getDimensionsFromLabel(e,t,i){this.textSize=this.labelModule.getTextSize(e,t,i);var o=this.textSize.width,s=this.textSize.height;return 0===o&&(o=14,s=14),{width:o,height:s}}}class ge extends ue{constructor(e,t,i){super(e,t,i),this._setMargins(i)}resize(e,t=this.selected,i=this.hover){if(this.needsRefresh(t,i)){var o=this.getDimensionsFromLabel(e,t,i);this.width=o.width+this.margin.right+this.margin.left,this.height=o.height+this.margin.top+this.margin.bottom,this.radius=this.width/2}}draw(e,t,i,o,s,n){this.resize(e,o,s),this.left=t-this.width/2,this.top=i-this.height/2,this.initContextForDraw(e,n),l(e,this.left,this.top,this.width,this.height,n.borderRadius),this.performFill(e,n),this.updateBoundingBox(t,i,e,o,s),this.labelModule.draw(e,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,o,s)}updateBoundingBox(e,t,i,o,s){this._updateBoundingBox(e,t,i,o,s);let n=this.options.shapeProperties.borderRadius;this._addBoundingBoxMargin(n)}distanceToBorder(e,t){e&&this.resize(e);let i=this.options.borderWidth;return Math.min(Math.abs(this.width/2/Math.cos(t)),Math.abs(this.height/2/Math.sin(t)))+i}}class me extends ue{constructor(e,t,i){super(e,t,i),this.labelOffset=0,this.selected=!1}setOptions(e,t,i){this.options=e,void 0===t&&void 0===i||this.setImages(t,i)}setImages(e,t){t&&this.selected?(this.imageObj=t,this.imageObjAlt=e):(this.imageObj=e,this.imageObjAlt=t)}switchImages(e){var t=e&&!this.selected||!e&&this.selected;if(this.selected=e,void 0!==this.imageObjAlt&&t){let e=this.imageObj;this.imageObj=this.imageObjAlt,this.imageObjAlt=e}}_getImagePadding(){var e={top:0,right:0,bottom:0,left:0};if(this.options.imagePadding){var t=this.options.imagePadding;"object"==typeof t?(e.top=t.top,e.right=t.right,e.bottom=t.bottom,e.left=t.left):(e.top=t,e.right=t,e.bottom=t,e.left=t)}return e}_resizeImage(){var e,t;if(!1===this.options.shapeProperties.useImageSize){var i=1,o=1;this.imageObj.width&&this.imageObj.height&&(this.imageObj.width>this.imageObj.height?i=this.imageObj.width/this.imageObj.height:o=this.imageObj.height/this.imageObj.width),e=2*this.options.size*i,t=2*this.options.size*o}else{var s=this._getImagePadding();e=this.imageObj.width+s.left+s.right,t=this.imageObj.height+s.top+s.bottom}this.width=e,this.height=t,this.radius=.5*this.width}_drawRawCircle(e,t,i,o){this.initContextForDraw(e,o),d(e,t,i,o.size),this.performFill(e,o)}_drawImageAtPosition(e,t){if(0!=this.imageObj.width){e.globalAlpha=void 0!==t.opacity?t.opacity:1,this.enableShadow(e,t);let a=1;!0===this.options.shapeProperties.interpolation&&(a=this.imageObj.width/this.width/this.body.view.scale);var i=this._getImagePadding(),o=this.left+i.left,s=this.top+i.top,n=this.width-i.left-i.right,r=this.height-i.top-i.bottom;this.imageObj.drawImageAtPosition(e,a,o,s,n,r),this.disableShadow(e,t)}}_drawImageLabel(e,t,i,o,s){var n,r=0;if(void 0!==this.height){r=.5*this.height;var a=this.labelModule.getTextSize(e,o,s);a.lineCount>=1&&(r+=a.height/2)}n=i+r,this.options.label&&(this.labelOffset=r),this.labelModule.draw(e,t,n,o,s,"hanging")}}class be extends me{constructor(e,t,i){super(e,t,i),this._setMargins(i)}resize(e,t=this.selected,i=this.hover){if(this.needsRefresh(t,i)){var o=this.getDimensionsFromLabel(e,t,i),s=Math.max(o.width+this.margin.right+this.margin.left,o.height+this.margin.top+this.margin.bottom);this.options.size=s/2,this.width=s,this.height=s,this.radius=this.width/2}}draw(e,t,i,o,s,n){this.resize(e,o,s),this.left=t-this.width/2,this.top=i-this.height/2,this._drawRawCircle(e,t,i,n),this.updateBoundingBox(t,i),this.labelModule.draw(e,this.left+this.textSize.width/2+this.margin.left,i,o,s)}updateBoundingBox(e,t){this.boundingBox.top=t-this.options.size,this.boundingBox.left=e-this.options.size,this.boundingBox.right=e+this.options.size,this.boundingBox.bottom=t+this.options.size}distanceToBorder(e,t){return e&&this.resize(e),.5*this.width}}class fe extends me{constructor(e,t,i,o,s){super(e,t,i),this.setImages(o,s)}resize(e,t=this.selected,i=this.hover){if(void 0===this.imageObj.src||void 0===this.imageObj.width||void 0===this.imageObj.height){var o=2*this.options.size;return this.width=o,this.height=o,void(this.radius=.5*this.width)}this.needsRefresh(t,i)&&this._resizeImage()}draw(e,t,i,o,s,n){this.switchImages(o),this.resize();let r=t,a=i;"top-left"===this.options.shapeProperties.coordinateOrigin?(this.left=t,this.top=i,r+=this.width/2,a+=this.height/2):(this.left=t-this.width/2,this.top=i-this.height/2),this._drawRawCircle(e,r,a,n),e.save(),e.clip(),this._drawImageAtPosition(e,n),e.restore(),this._drawImageLabel(e,r,a,o,s),this.updateBoundingBox(t,i)}updateBoundingBox(e,t){"top-left"===this.options.shapeProperties.coordinateOrigin?(this.boundingBox.top=t,this.boundingBox.left=e,this.boundingBox.right=e+2*this.options.size,this.boundingBox.bottom=t+2*this.options.size):(this.boundingBox.top=t-this.options.size,this.boundingBox.left=e-this.options.size,this.boundingBox.right=e+this.options.size,this.boundingBox.bottom=t+this.options.size),this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelOffset)}distanceToBorder(e,t){return e&&this.resize(e),.5*this.width}}class ye extends ue{constructor(e,t,i){super(e,t,i)}resize(e,t=this.selected,i=this.hover,o={size:this.options.size}){if(this.needsRefresh(t,i)){this.labelModule.getTextSize(e,t,i);var s=2*o.size;this.width=s,this.height=s,this.radius=.5*this.width}}_drawShape(e,t,i,o,s,n,r,a,h){var d;if(this.resize(e,n,r,a),this.left=o-this.width/2,this.top=s-this.height/2,"custom"===t?(e.save(),h({ctx:e,x:o,y:s,state:{selected:n,hover:r},style:{...a}}),e.restore()):(this.initContextForDraw(e,a),(d=t,Object.prototype.hasOwnProperty.call(g,d)?g[d]:function(e,...t){CanvasRenderingContext2D.prototype[d].call(e,t)})(e,o,s,a.size),this.performFill(e,a)),void 0!==this.options.icon&&void 0!==this.options.icon.code&&(e.font=(n?"bold ":"")+this.height/2+"px "+(this.options.icon.face||"FontAwesome"),e.fillStyle=this.options.icon.color||"black",e.textAlign="center",e.textBaseline="middle",e.fillText(this.options.icon.code,o,s)),void 0!==this.options.label){this.labelModule.calculateLabelSize(e,n,r,o,s,"hanging");let t=s+.5*this.height+.5*this.labelModule.size.height;this.labelModule.draw(e,o,t,n,r,"hanging")}this.updateBoundingBox(o,s)}updateBoundingBox(e,t){this.boundingBox.top=t-this.options.size,this.boundingBox.left=e-this.options.size,this.boundingBox.right=e+this.options.size,this.boundingBox.bottom=t+this.options.size,void 0!==this.options.label&&this.labelModule.size.width>0&&(this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelModule.size.height))}}class ve extends ye{constructor(e,t,i,o){super(e,t,i,o),this.ctxRenderer=o}draw(e,t,i,o,s,n){this._drawShape(e,"custom",4,t,i,o,s,n,this.ctxRenderer)}distanceToBorder(e,t){return this._distanceToBorder(e,t)}}class we extends ue{constructor(e,t,i){super(e,t,i),this._setMargins(i)}resize(e,t,i){if(this.needsRefresh(t,i)){var o=this.getDimensionsFromLabel(e,t,i).width+this.margin.right+this.margin.left;this.width=o,this.height=o,this.radius=this.width/2}}draw(e,t,i,o,s,n){this.resize(e,o,s),this.left=t-this.width/2,this.top=i-this.height/2,this.initContextForDraw(e,n),p(e,t-this.width/2,i-this.height/2,this.width,this.height),this.performFill(e,n),this.updateBoundingBox(t,i,e,o,s),this.labelModule.draw(e,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,o,s)}distanceToBorder(e,t){return this._distanceToBorder(e,t)}}class _e extends ye{constructor(e,t,i){super(e,t,i)}draw(e,t,i,o,s,n){this._drawShape(e,"diamond",4,t,i,o,s,n)}distanceToBorder(e,t){return this._distanceToBorder(e,t)}}class xe extends ye{constructor(e,t,i){super(e,t,i)}draw(e,t,i,o,s,n){this._drawShape(e,"circle",2,t,i,o,s,n)}distanceToBorder(e,t){return e&&this.resize(e),this.options.size}}class Ee extends ue{constructor(e,t,i){super(e,t,i)}resize(e,t=this.selected,i=this.hover){if(this.needsRefresh(t,i)){var o=this.getDimensionsFromLabel(e,t,i);this.height=2*o.height,this.width=o.width+o.height,this.radius=.5*this.width}}draw(e,t,i,o,s,n){this.resize(e,o,s),this.left=t-.5*this.width,this.top=i-.5*this.height,this.initContextForDraw(e,n),c(e,this.left,this.top,this.width,this.height),this.performFill(e,n),this.updateBoundingBox(t,i,e,o,s),this.labelModule.draw(e,t,i,o,s)}distanceToBorder(e,t){e&&this.resize(e);var i=.5*this.width,o=.5*this.height,s=Math.sin(t)*i,n=Math.cos(t)*o;return i*o/Math.sqrt(s*s+n*n)}}class Oe extends ue{constructor(e,t,i){super(e,t,i),this._setMargins(i)}resize(e,t,i){this.needsRefresh(t,i)&&(this.iconSize={width:Number(this.options.icon.size),height:Number(this.options.icon.size)},this.width=this.iconSize.width+this.margin.right+this.margin.left,this.height=this.iconSize.height+this.margin.top+this.margin.bottom,this.radius=.5*this.width)}draw(e,t,i,o,s,n){if(this.resize(e,o,s),this.options.icon.size=this.options.icon.size||50,this.left=t-this.width/2,this.top=i-this.height/2,this._icon(e,t,i,o,s,n),void 0!==this.options.label){this.labelModule.draw(e,this.left+this.iconSize.width/2+this.margin.left,i+this.height/2+5,o)}this.updateBoundingBox(t,i)}updateBoundingBox(e,t){if(this.boundingBox.top=t-.5*this.options.icon.size,this.boundingBox.left=e-.5*this.options.icon.size,this.boundingBox.right=e+.5*this.options.icon.size,this.boundingBox.bottom=t+.5*this.options.icon.size,void 0!==this.options.label&&this.labelModule.size.width>0){this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelModule.size.height+5)}}_icon(e,t,i,o,s,n){let r=Number(this.options.icon.size);void 0!==this.options.icon.code?(e.font=[null!=this.options.icon.weight?this.options.icon.weight:o?"bold":"",(null!=this.options.icon.weight&&o?5:0)+r+"px",this.options.icon.face].join(" "),e.fillStyle=this.options.icon.color||"black",e.textAlign="center",e.textBaseline="middle",this.enableShadow(e,n),e.fillText(this.options.icon.code,t,i),this.disableShadow(e,n)):console.error("When using the icon shape, you need to define the code in the icon options object. This can be done per node or globally.")}distanceToBorder(e,t){return this._distanceToBorder(e,t)}}class Ce extends me{constructor(e,t,i,o,s){super(e,t,i),this.setImages(o,s)}resize(e,t=this.selected,i=this.hover){if(void 0===this.imageObj.src||void 0===this.imageObj.width||void 0===this.imageObj.height){var o=2*this.options.size;return this.width=o,void(this.height=o)}this.needsRefresh(t,i)&&this._resizeImage()}draw(e,t,o,s,n,r){e.save(),this.switchImages(s),this.resize();let a=t,h=o;if("top-left"===this.options.shapeProperties.coordinateOrigin?(this.left=t,this.top=o,a+=this.width/2,h+=this.height/2):(this.left=t-this.width/2,this.top=o-this.height/2),!0===this.options.shapeProperties.useBorderWithImage){var d=this.options.borderWidth,l=this.options.borderWidthSelected||2*this.options.borderWidth,c=(s?l:d)/this.body.view.scale;e.lineWidth=Math.min(this.width,c),e.beginPath();let t=s?this.options.color.highlight.border:n?this.options.color.hover.border:this.options.color.border,o=s?this.options.color.highlight.background:n?this.options.color.hover.background:this.options.color.background;void 0!==r.opacity&&(t=i.overrideOpacity(t,r.opacity),o=i.overrideOpacity(o,r.opacity)),e.strokeStyle=t,e.fillStyle=o,e.rect(this.left-.5*e.lineWidth,this.top-.5*e.lineWidth,this.width+e.lineWidth,this.height+e.lineWidth),e.fill(),this.performStroke(e,r),e.closePath()}this._drawImageAtPosition(e,r),this._drawImageLabel(e,a,h,s,n),this.updateBoundingBox(t,o),e.restore()}updateBoundingBox(e,t){this.resize(),"top-left"===this.options.shapeProperties.coordinateOrigin?(this.left=e,this.top=t):(this.left=e-this.width/2,this.top=t-this.height/2),this.boundingBox.left=this.left,this.boundingBox.top=this.top,this.boundingBox.bottom=this.top+this.height,this.boundingBox.right=this.left+this.width,void 0!==this.options.label&&this.labelModule.size.width>0&&(this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelOffset))}distanceToBorder(e,t){return this._distanceToBorder(e,t)}}class ke extends ye{constructor(e,t,i){super(e,t,i)}draw(e,t,i,o,s,n){this._drawShape(e,"square",2,t,i,o,s,n)}distanceToBorder(e,t){return this._distanceToBorder(e,t)}}class Me extends ye{constructor(e,t,i){super(e,t,i)}draw(e,t,i,o,s,n){this._drawShape(e,"hexagon",4,t,i,o,s,n)}distanceToBorder(e,t){return this._distanceToBorder(e,t)}}class Se extends ye{constructor(e,t,i){super(e,t,i)}draw(e,t,i,o,s,n){this._drawShape(e,"star",4,t,i,o,s,n)}distanceToBorder(e,t){return this._distanceToBorder(e,t)}}class De extends ue{constructor(e,t,i){super(e,t,i),this._setMargins(i)}resize(e,t,i){this.needsRefresh(t,i)&&(this.textSize=this.labelModule.getTextSize(e,t,i),this.width=this.textSize.width+this.margin.right+this.margin.left,this.height=this.textSize.height+this.margin.top+this.margin.bottom,this.radius=.5*this.width)}draw(e,t,i,o,s,n){this.resize(e,o,s),this.left=t-this.width/2,this.top=i-this.height/2,this.enableShadow(e,n),this.labelModule.draw(e,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,o,s),this.disableShadow(e,n),this.updateBoundingBox(t,i,e,o,s)}distanceToBorder(e,t){return this._distanceToBorder(e,t)}}class Be extends ye{constructor(e,t,i){super(e,t,i)}draw(e,t,i,o,s,n){this._drawShape(e,"triangle",3,t,i,o,s,n)}distanceToBorder(e,t){return this._distanceToBorder(e,t)}}class Te extends ye{constructor(e,t,i){super(e,t,i)}draw(e,t,i,o,s,n){this._drawShape(e,"triangleDown",3,t,i,o,s,n)}distanceToBorder(e,t){return this._distanceToBorder(e,t)}}let Pe,ze=!1,Fe="background: #FFeeee; color: #dd0000";class Ie{constructor(){}static validate(e,t,i){ze=!1,Pe=t;let o=t;return void 0!==i&&(o=t[i]),Ie.parse(e,o,[]),ze}static parse(e,t,i){for(let o in e)e.hasOwnProperty(o)&&Ie.check(o,e,t,i)}static check(e,t,i,o){if(void 0===i[e]&&void 0===i.__any__)return void Ie.getSuggestion(e,i,o);let s=e,n=!0;void 0===i[e]&&void 0!==i.__any__&&(s="__any__",n="object"===Ie.getType(t[e]));let r=i[s];n&&void 0!==r.__type__&&(r=r.__type__),Ie.checkFields(e,t,i,s,r,o)}static checkFields(e,t,o,s,n,r){let a=function(t){console.log("%c"+t+Ie.printLocation(r,e),Fe)},h=Ie.getType(t[e]),d=n[h];void 0!==d?"array"===Ie.getType(d)&&-1===d.indexOf(t[e])?(a('Invalid option detected in "'+e+'". Allowed values are:'+Ie.print(d)+' not "'+t[e]+'". '),ze=!0):"object"===h&&"__any__"!==s&&(r=i.copyAndExtendArray(r,e),Ie.parse(t[e],o[s],r)):void 0===n.any&&(a('Invalid type received for "'+e+'". Expected: '+Ie.print(Object.keys(n))+". Received ["+h+'] "'+t[e]+'"'),ze=!0)}static getType(e){var t=typeof e;return"object"===t?null===e?"null":e instanceof Boolean?"boolean":e instanceof Number?"number":e instanceof String?"string":Array.isArray(e)?"array":e instanceof Date?"date":void 0!==e.nodeType?"dom":!0===e._isAMomentObject?"moment":"object":"number"===t?"number":"boolean"===t?"boolean":"string"===t?"string":void 0===t?"undefined":t}static getSuggestion(e,t,i){let o,s=Ie.findInOptions(e,t,i,!1),n=Ie.findInOptions(e,Pe,[],!0);o=void 0!==s.indexMatch?" in "+Ie.printLocation(s.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+s.indexMatch+'"?\n\n':n.distance<=4&&s.distance>n.distance?" in "+Ie.printLocation(s.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+Ie.printLocation(n.path,n.closestMatch,""):s.distance<=8?'. Did you mean "'+s.closestMatch+'"?'+Ie.printLocation(s.path,e):". Did you mean one of these: "+Ie.print(Object.keys(t))+Ie.printLocation(i,e),console.log('%cUnknown option detected: "'+e+'"'+o,Fe),ze=!0}static findInOptions(e,t,o,s=!1){let n=1e9,r="",a=[],h=e.toLowerCase(),d=void 0;for(let l in t){let c;if(void 0!==t[l].__type__&&!0===s){let s=Ie.findInOptions(e,t[l],i.copyAndExtendArray(o,l));n>s.distance&&(r=s.closestMatch,a=s.path,n=s.distance,d=s.indexMatch)}else-1!==l.toLowerCase().indexOf(h)&&(d=l),c=Ie.levenshteinDistance(e,l),n>c&&(r=l,a=i.copyArray(o),n=c)}return{closestMatch:r,path:a,distance:n,indexMatch:d}}static printLocation(e,t,i="Problem value found at: \n"){let o="\n\n"+i+"options = {\n";for(let t=0;t<e.length;t++){for(let e=0;e<t+1;e++)o+="  ";o+=e[t]+": {\n"}for(let t=0;t<e.length+1;t++)o+="  ";o+=t+"\n";for(let t=0;t<e.length+1;t++){for(let i=0;i<e.length-t;i++)o+="  ";o+="}\n"}return o+"\n\n"}static print(e){return JSON.stringify(e).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}static levenshteinDistance(e,t){if(0===e.length)return t.length;if(0===t.length)return e.length;var i,o,s=[];for(i=0;i<=t.length;i++)s[i]=[i];for(o=0;o<=e.length;o++)s[0][o]=o;for(i=1;i<=t.length;i++)for(o=1;o<=e.length;o++)t.charAt(i-1)==e.charAt(o-1)?s[i][o]=s[i-1][o-1]:s[i][o]=Math.min(s[i-1][o-1]+1,Math.min(s[i][o-1]+1,s[i-1][o]+1));return s[t.length][e.length]}}class Ne{constructor(e,t,o,s,n,r){this.options=i.bridgeObject(n),this.globalOptions=n,this.defaultOptions=r,this.body=t,this.edges=[],this.id=void 0,this.imagelist=o,this.grouplist=s,this.x=void 0,this.y=void 0,this.baseSize=this.options.size,this.baseFontSize=this.options.font.size,this.predefinedPosition=!1,this.selected=!1,this.hover=!1,this.labelModule=new pe(this.body,this.options,!1),this.setOptions(e)}attachEdge(e){-1===this.edges.indexOf(e)&&this.edges.push(e)}detachEdge(e){var t=this.edges.indexOf(e);-1!=t&&this.edges.splice(t,1)}setOptions(e){let t=this.options.shape;if(!e)return;if(void 0!==e.color&&(this._localColor=e.color),void 0!==e.id&&(this.id=e.id),void 0===this.id)throw new Error("Node must have an id");Ne.checkMass(e,this.id),void 0!==e.x&&(null===e.x?(this.x=void 0,this.predefinedPosition=!1):(this.x=parseInt(e.x),this.predefinedPosition=!0)),void 0!==e.y&&(null===e.y?(this.y=void 0,this.predefinedPosition=!1):(this.y=parseInt(e.y),this.predefinedPosition=!0)),void 0!==e.size&&(this.baseSize=e.size),void 0!==e.value&&(e.value=parseFloat(e.value)),Ne.parseOptions(this.options,e,!0,this.globalOptions,this.grouplist);let i=[e,this.options,this.defaultOptions];return this.chooser=oe("node",i),this._load_images(),this.updateLabelModule(e),void 0!==e.opacity&&Ne.checkOpacity(e.opacity)&&(this.options.opacity=e.opacity),this.updateShape(t),void 0!==e.hidden||void 0!==e.physics}_load_images(){if(("circularImage"===this.options.shape||"image"===this.options.shape)&&void 0===this.options.image)throw new Error("Option image must be defined for node type '"+this.options.shape+"'");if(void 0!==this.options.image){if(void 0===this.imagelist)throw new Error("Internal Error: No images provided");if("string"==typeof this.options.image)this.imageObj=this.imagelist.load(this.options.image,this.options.brokenImage,this.id);else{if(void 0===this.options.image.unselected)throw new Error("No unselected image provided");this.imageObj=this.imagelist.load(this.options.image.unselected,this.options.brokenImage,this.id),void 0!==this.options.image.selected?this.imageObjAlt=this.imagelist.load(this.options.image.selected,this.options.brokenImage,this.id):this.imageObjAlt=void 0}}}static checkOpacity(e){return 0<=e&&e<=1}static checkCoordinateOrigin(e){return void 0===e||"center"===e||"top-left"===e}static updateGroupOptions(e,t,o){if(void 0===o)return;var s=e.group;if(void 0!==t&&void 0!==t.group&&s!==t.group)throw new Error("updateGroupOptions: group values in options don't match.");if(!("number"==typeof s||"string"==typeof s&&""!=s))return;var n=o.get(s);void 0!==n.opacity&&void 0===t.opacity&&(Ne.checkOpacity(n.opacity)||(console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+n.opacity),n.opacity=void 0));const r=Object.getOwnPropertyNames(t).filter(e=>null!=t[e]);r.push("font"),i.selectiveNotDeepExtend(r,e,n),e.color=i.parseColor(e.color)}static parseOptions(e,t,o=!1,s={},n){if(i.selectiveNotDeepExtend(["color","fixed","shadow"],e,t,o),Ne.checkMass(t),void 0!==e.opacity&&(Ne.checkOpacity(e.opacity)||(console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+e.opacity),e.opacity=void 0)),void 0!==t.opacity&&(Ne.checkOpacity(t.opacity)||(console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+t.opacity),t.opacity=void 0)),t.shapeProperties&&!Ne.checkCoordinateOrigin(t.shapeProperties.coordinateOrigin)&&console.error("Invalid option for node coordinateOrigin, found: "+t.shapeProperties.coordinateOrigin),i.mergeOptions(e,t,"shadow",s),void 0!==t.color&&null!==t.color){let o=i.parseColor(t.color);i.fillIfDefined(e.color,o)}else!0===o&&null===t.color&&(e.color=i.bridgeObject(s.color));void 0!==t.fixed&&null!==t.fixed&&("boolean"==typeof t.fixed?(e.fixed.x=t.fixed,e.fixed.y=t.fixed):(void 0!==t.fixed.x&&"boolean"==typeof t.fixed.x&&(e.fixed.x=t.fixed.x),void 0!==t.fixed.y&&"boolean"==typeof t.fixed.y&&(e.fixed.y=t.fixed.y))),!0===o&&null===t.font&&(e.font=i.bridgeObject(s.font)),Ne.updateGroupOptions(e,t,n),void 0!==t.scaling&&i.mergeOptions(e.scaling,t.scaling,"label",s.scaling)}getFormattingValues(){let e={color:this.options.color.background,opacity:this.options.opacity,borderWidth:this.options.borderWidth,borderColor:this.options.color.border,size:this.options.size,borderDashes:this.options.shapeProperties.borderDashes,borderRadius:this.options.shapeProperties.borderRadius,shadow:this.options.shadow.enabled,shadowColor:this.options.shadow.color,shadowSize:this.options.shadow.size,shadowX:this.options.shadow.x,shadowY:this.options.shadow.y};if(this.selected||this.hover?!0===this.chooser?this.selected?(e.borderWidth*=2,e.color=this.options.color.highlight.background,e.borderColor=this.options.color.highlight.border,e.shadow=this.options.shadow.enabled):this.hover&&(e.color=this.options.color.hover.background,e.borderColor=this.options.color.hover.border,e.shadow=this.options.shadow.enabled):"function"==typeof this.chooser&&(this.chooser(e,this.options.id,this.selected,this.hover),!1===e.shadow&&(e.shadowColor===this.options.shadow.color&&e.shadowSize===this.options.shadow.size&&e.shadowX===this.options.shadow.x&&e.shadowY===this.options.shadow.y||(e.shadow=!0))):e.shadow=this.options.shadow.enabled,void 0!==this.options.opacity){const t=this.options.opacity;e.borderColor=i.overrideOpacity(e.borderColor,t),e.color=i.overrideOpacity(e.color,t),e.shadowColor=i.overrideOpacity(e.shadowColor,t)}return e}updateLabelModule(e){void 0!==this.options.label&&null!==this.options.label||(this.options.label=""),Ne.updateGroupOptions(this.options,{...e,color:e&&e.color||this._localColor||void 0},this.grouplist);var t=this.grouplist.get(this.options.group,!1);let i=[e,this.options,t,this.globalOptions,this.defaultOptions];this.labelModule.update(this.options,i),void 0!==this.labelModule.baseSize&&(this.baseFontSize=this.labelModule.baseSize)}updateShape(e){if(e===this.options.shape&&this.shape)this.shape.setOptions(this.options,this.imageObj,this.imageObjAlt);else switch(this.options.shape){case"box":this.shape=new ge(this.options,this.body,this.labelModule);break;case"circle":this.shape=new be(this.options,this.body,this.labelModule);break;case"circularImage":this.shape=new fe(this.options,this.body,this.labelModule,this.imageObj,this.imageObjAlt);break;case"custom":this.shape=new ve(this.options,this.body,this.labelModule,this.options.ctxRenderer);break;case"database":this.shape=new we(this.options,this.body,this.labelModule);break;case"diamond":this.shape=new _e(this.options,this.body,this.labelModule);break;case"dot":this.shape=new xe(this.options,this.body,this.labelModule);break;case"ellipse":this.shape=new Ee(this.options,this.body,this.labelModule);break;case"icon":this.shape=new Oe(this.options,this.body,this.labelModule);break;case"image":this.shape=new Ce(this.options,this.body,this.labelModule,this.imageObj,this.imageObjAlt);break;case"square":this.shape=new ke(this.options,this.body,this.labelModule);break;case"hexagon":this.shape=new Me(this.options,this.body,this.labelModule);break;case"star":this.shape=new Se(this.options,this.body,this.labelModule);break;case"text":this.shape=new De(this.options,this.body,this.labelModule);break;case"triangle":this.shape=new Be(this.options,this.body,this.labelModule);break;case"triangleDown":this.shape=new Te(this.options,this.body,this.labelModule);break;default:this.shape=new Ee(this.options,this.body,this.labelModule)}this.needsRefresh()}select(){this.selected=!0,this.needsRefresh()}unselect(){this.selected=!1,this.needsRefresh()}needsRefresh(){this.shape.refreshNeeded=!0}getTitle(){return this.options.title}distanceToBorder(e,t){return this.shape.distanceToBorder(e,t)}isFixed(){return this.options.fixed.x&&this.options.fixed.y}isSelected(){return this.selected}getValue(){return this.options.value}getLabelSize(){return this.labelModule.size()}setValueRange(e,t,i){if(void 0!==this.options.value){var o=this.options.scaling.customScalingFunction(e,t,i,this.options.value),s=this.options.scaling.max-this.options.scaling.min;if(!0===this.options.scaling.label.enabled){var n=this.options.scaling.label.max-this.options.scaling.label.min;this.options.font.size=this.options.scaling.label.min+o*n}this.options.size=this.options.scaling.min+o*s}else this.options.size=this.baseSize,this.options.font.size=this.baseFontSize;this.updateLabelModule()}draw(e){let t=this.getFormattingValues();this.shape.draw(e,this.x,this.y,this.selected,this.hover,t)}updateBoundingBox(e){this.shape.updateBoundingBox(this.x,this.y,e)}resize(e){let t=this.getFormattingValues();this.shape.resize(e,this.selected,this.hover,t)}getItemsOnPoint(e){var t=[];return this.labelModule.visible()&&se(this.labelModule.getSize(),e)&&t.push({nodeId:this.id,labelId:0}),se(this.shape.boundingBox,e)&&t.push({nodeId:this.id}),t}isOverlappingWith(e){return this.shape.left<e.right&&this.shape.left+this.shape.width>e.left&&this.shape.top<e.bottom&&this.shape.top+this.shape.height>e.top}isBoundingBoxOverlappingWith(e){return this.shape.boundingBox.left<e.right&&this.shape.boundingBox.right>e.left&&this.shape.boundingBox.top<e.bottom&&this.shape.boundingBox.bottom>e.top}static checkMass(e,t){if(void 0!==e.mass&&e.mass<=0){let i="";void 0!==t&&(i=" in node id: "+t),console.log("%cNegative or zero mass disallowed"+i+", setting mass to 1.",Fe),e.mass=1}}}class Re{constructor(e,t,o,s){if(this.body=e,this.images=t,this.groups=o,this.layoutEngine=s,this.body.functions.createNode=this.create.bind(this),this.nodesListeners={add:(e,t)=>{this.add(t.items)},update:(e,t)=>{this.update(t.items,t.data,t.oldData)},remove:(e,t)=>{this.remove(t.items)}},this.defaultOptions={borderWidth:1,borderWidthSelected:2,brokenImage:void 0,color:{border:"#2B7CE9",background:"#97C2FC",highlight:{border:"#2B7CE9",background:"#D2E5FF"},hover:{border:"#2B7CE9",background:"#D2E5FF"}},opacity:void 0,fixed:{x:!1,y:!1},font:{color:"#343434",size:14,face:"arial",background:"none",strokeWidth:0,strokeColor:"#ffffff",align:"center",vadjust:0,multi:!1,bold:{mod:"bold"},boldital:{mod:"bold italic"},ital:{mod:"italic"},mono:{mod:"",size:15,face:"monospace",vadjust:2}},group:void 0,hidden:!1,icon:{face:"FontAwesome",code:void 0,size:50,color:"#2B7CE9"},image:void 0,imagePadding:{top:0,right:0,bottom:0,left:0},label:void 0,labelHighlightBold:!0,level:void 0,margin:{top:5,right:5,bottom:5,left:5},mass:1,physics:!0,scaling:{min:10,max:30,label:{enabled:!1,min:14,max:30,maxVisible:30,drawThreshold:5},customScalingFunction:function(e,t,i,o){if(t===e)return.5;{let i=1/(t-e);return Math.max(0,(o-e)*i)}}},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:10,x:5,y:5},shape:"ellipse",shapeProperties:{borderDashes:!1,borderRadius:6,interpolation:!0,useImageSize:!1,useBorderWithImage:!1,coordinateOrigin:"center"},size:25,title:void 0,value:void 0,x:void 0,y:void 0},this.defaultOptions.mass<=0)throw"Internal error: mass in defaultOptions of NodesHandler may not be zero or negative";this.options=i.bridgeObject(this.defaultOptions),this.bindEventListeners()}bindEventListeners(){this.body.emitter.on("refreshNodes",this.refresh.bind(this)),this.body.emitter.on("refresh",this.refresh.bind(this)),this.body.emitter.on("destroy",()=>{i.forEach(this.nodesListeners,(e,t)=>{this.body.data.nodes&&this.body.data.nodes.off(t,e)}),delete this.body.functions.createNode,delete this.nodesListeners.add,delete this.nodesListeners.update,delete this.nodesListeners.remove,delete this.nodesListeners})}setOptions(e){if(void 0!==e){if(Ne.parseOptions(this.options,e),void 0!==e.opacity&&(Number.isNaN(e.opacity)||!Number.isFinite(e.opacity)||e.opacity<0||e.opacity>1?console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+e.opacity):this.options.opacity=e.opacity),void 0!==e.shape)for(let e in this.body.nodes)this.body.nodes.hasOwnProperty(e)&&this.body.nodes[e].updateShape();if(void 0!==e.font||void 0!==e.widthConstraint||void 0!==e.heightConstraint)for(let e of Object.keys(this.body.nodes))this.body.nodes[e].updateLabelModule(),this.body.nodes[e].needsRefresh();if(void 0!==e.size)for(let e in this.body.nodes)this.body.nodes.hasOwnProperty(e)&&this.body.nodes[e].needsRefresh();void 0===e.hidden&&void 0===e.physics||this.body.emitter.emit("_dataChanged")}}setData(e,t=!1){let o=this.body.data.nodes;if(e instanceof n.DataSet||e instanceof n.DataView)this.body.data.nodes=e;else if(Array.isArray(e))this.body.data.nodes=new n.DataSet,this.body.data.nodes.add(e);else{if(e)throw new TypeError("Array or DataSet expected");this.body.data.nodes=new n.DataSet}if(o&&i.forEach(this.nodesListeners,(function(e,t){o.off(t,e)})),this.body.nodes={},this.body.data.nodes){let e=this;i.forEach(this.nodesListeners,(function(t,i){e.body.data.nodes.on(i,t)}));let t=this.body.data.nodes.getIds();this.add(t,!0)}!1===t&&this.body.emitter.emit("_dataChanged")}add(e,t=!1){let i,o=[];for(let t=0;t<e.length;t++){i=e[t];let s=this.body.data.nodes.get(i),n=this.create(s);o.push(n),this.body.nodes[i]=n}this.layoutEngine.positionInitially(o),!1===t&&this.body.emitter.emit("_dataChanged")}update(e,t,i){let o=this.body.nodes,s=!1;for(let i=0;i<e.length;i++){let n=e[i],r=o[n],a=t[i];void 0!==r?r.setOptions(a)&&(s=!0):(s=!0,r=this.create(a),o[n]=r)}s||void 0===i||(s=t.some((function(e,t){let o=i[t];return o&&o.level!==e.level}))),!0===s?this.body.emitter.emit("_dataChanged"):this.body.emitter.emit("_dataUpdated")}remove(e){let t=this.body.nodes;for(let i=0;i<e.length;i++){delete t[e[i]]}this.body.emitter.emit("_dataChanged")}create(e,t=Ne){return new t(e,this.body,this.images,this.groups,this.options,this.defaultOptions)}refresh(e=!1){i.forEach(this.body.nodes,(t,i)=>{let o=this.body.data.nodes.get(i);void 0!==o&&(!0===e&&t.setOptions({x:null,y:null}),t.setOptions({fixed:!1}),t.setOptions(o))})}getPositions(e){let t={};if(void 0!==e){if(!0===Array.isArray(e)){for(let i=0;i<e.length;i++)if(void 0!==this.body.nodes[e[i]]){let o=this.body.nodes[e[i]];t[e[i]]={x:Math.round(o.x),y:Math.round(o.y)}}}else if(void 0!==this.body.nodes[e]){let i=this.body.nodes[e];t[e]={x:Math.round(i.x),y:Math.round(i.y)}}}else for(let e=0;e<this.body.nodeIndices.length;e++){let i=this.body.nodes[this.body.nodeIndices[e]];t[this.body.nodeIndices[e]]={x:Math.round(i.x),y:Math.round(i.y)}}return t}getPosition(e){if(null==e)throw new TypeError("No id was specified for getPosition method.");if(null==this.body.nodes[e])throw new ReferenceError("NodeId provided for getPosition does not exist. Provided: "+e);return{x:Math.round(this.body.nodes[e].x),y:Math.round(this.body.nodes[e].y)}}storePositions(){const e=[],t=this.body.data.nodes.getDataSet();for(const i of t.get()){const t=i.id,o=this.body.nodes[t],s=Math.round(o.x),n=Math.round(o.y);i.x===s&&i.y===n||e.push({id:t,x:s,y:n})}t.update(e)}getBoundingBox(e){if(void 0!==this.body.nodes[e])return this.body.nodes[e].shape.boundingBox}getConnectedNodes(e,t){let i=[];if(void 0!==this.body.nodes[e]){let o=this.body.nodes[e],s={};for(let e=0;e<o.edges.length;e++){let n=o.edges[e];"to"!==t&&n.toId==o.id?void 0===s[n.fromId]&&(i.push(n.fromId),s[n.fromId]=!0):"from"!==t&&n.fromId==o.id&&void 0===s[n.toId]&&(i.push(n.toId),s[n.toId]=!0)}}return i}getConnectedEdges(e){let t=[];if(void 0!==this.body.nodes[e]){let i=this.body.nodes[e];for(let e=0;e<i.edges.length;e++)t.push(i.edges[e].id)}else console.log("NodeId provided for getConnectedEdges does not exist. Provided: ",e);return t}moveNode(e,t,i){void 0!==this.body.nodes[e]?(this.body.nodes[e].x=Number(t),this.body.nodes[e].y=Number(i),setTimeout(()=>{this.body.emitter.emit("startSimulation")},0)):console.log("Node id supplied to moveNode does not exist. Provided: ",e)}}class Ae{static transform(e,t){Array.isArray(e)||(e=[e]);const i=t.point.x,o=t.point.y,s=t.angle,n=t.length;for(let t=0;t<e.length;++t){const r=e[t],a=r.x*Math.cos(s)-r.y*Math.sin(s),h=r.x*Math.sin(s)+r.y*Math.cos(s);r.x=i+n*a,r.y=o+n*h}}static drawPath(e,t){e.beginPath(),e.moveTo(t[0].x,t[0].y);for(let i=1;i<t.length;++i)e.lineTo(t[i].x,t[i].y);e.closePath()}}class je extends Ae{static draw(e,t){if(t.image){e.save(),e.translate(t.point.x,t.point.y),e.rotate(Math.PI/2+t.angle);const i=null!=t.imageWidth?t.imageWidth:t.image.width,o=null!=t.imageHeight?t.imageHeight:t.image.height;t.image.drawImageAtPosition(e,1,-i/2,0,i,o),e.restore()}return!1}}class He extends Ae{static draw(e,t){const i=[{x:0,y:0},{x:-1,y:.3},{x:-.9,y:0},{x:-1,y:-.3}];return Ae.transform(i,t),Ae.drawPath(e,i),!0}}class Le{static draw(e,t){let i;switch(t.type&&(i=t.type.toLowerCase()),i){case"image":return je.draw(e,t);case"circle":return class{static draw(e,t){const i={x:-.4,y:0};return Ae.transform(i,t),d(e,i.x,i.y,.4*t.length),!0}}.draw(e,t);case"box":return class{static draw(e,t){const i=[{x:0,y:.3},{x:0,y:-.3},{x:-.6,y:-.3},{x:-.6,y:.3}];return Ae.transform(i,t),Ae.drawPath(e,i),!0}}.draw(e,t);case"crow":return class{static draw(e,t){const i=[{x:-1,y:0},{x:0,y:.3},{x:-.4,y:0},{x:0,y:-.3}];return Ae.transform(i,t),Ae.drawPath(e,i),!0}}.draw(e,t);case"curve":return class{static draw(e,t){const i={x:-.4,y:0};Ae.transform(i,t),e.strokeStyle=e.fillStyle,e.fillStyle="rgba(0, 0, 0, 0)";const o=Math.PI,s=t.angle-o/2,n=t.angle+o/2;return e.beginPath(),e.arc(i.x,i.y,.4*t.length,s,n,!1),e.stroke(),!0}}.draw(e,t);case"diamond":return class{static draw(e,t){const i=[{x:0,y:0},{x:-.5,y:-.3},{x:-1,y:0},{x:-.5,y:.3}];return Ae.transform(i,t),Ae.drawPath(e,i),!0}}.draw(e,t);case"inv_curve":return class{static draw(e,t){const i={x:-.3,y:0};Ae.transform(i,t),e.strokeStyle=e.fillStyle,e.fillStyle="rgba(0, 0, 0, 0)";const o=Math.PI,s=t.angle+o/2,n=t.angle+3*o/2;return e.beginPath(),e.arc(i.x,i.y,.4*t.length,s,n,!1),e.stroke(),!0}}.draw(e,t);case"triangle":return class{static draw(e,t){const i=[{x:.02,y:0},{x:-1,y:.3},{x:-1,y:-.3}];return Ae.transform(i,t),Ae.drawPath(e,i),!0}}.draw(e,t);case"inv_triangle":return class{static draw(e,t){const i=[{x:0,y:.3},{x:0,y:-.3},{x:-1,y:0}];return Ae.transform(i,t),Ae.drawPath(e,i),!0}}.draw(e,t);case"bar":return class{static draw(e,t){const i=[{x:0,y:.5},{x:0,y:-.5},{x:-.15,y:-.5},{x:-.15,y:.5}];return Ae.transform(i,t),Ae.drawPath(e,i),!0}}.draw(e,t);case"vee":return class{static draw(e,t){const i=[{x:-1,y:.3},{x:-.5,y:0},{x:-1,y:-.3},{x:0,y:0}];return Ae.transform(i,t),Ae.drawPath(e,i),!0}}.draw(e,t);case"arrow":default:return He.draw(e,t)}}}class We{constructor(e,t,i){this._body=t,this._labelModule=i,this.color={},this.colorDirty=!0,this.hoverWidth=1.5,this.selectionWidth=2,this.setOptions(e),this.fromPoint=this.from,this.toPoint=this.to}connect(){this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to]}cleanup(){return!1}setOptions(e){this.options=e,this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],this.id=this.options.id}drawLine(e,t,i,o,s=this.getViaNode()){e.strokeStyle=this.getColor(e,t),e.lineWidth=t.width,!1!==t.dashes?this._drawDashedLine(e,t,s):this._drawLine(e,t,s)}_drawLine(e,t,i,o,s){if(this.from!=this.to)this._line(e,t,i,o,s);else{const[i,o,s]=this._getCircleData(e);this._circle(e,t,i,o,s)}}_drawDashedLine(e,t,i,o,s){e.lineCap="round";const n=Array.isArray(t.dashes)?t.dashes:[5,5];if(void 0!==e.setLineDash){if(e.save(),e.setLineDash(n),e.lineDashOffset=0,this.from!=this.to)this._line(e,t,i);else{const[i,o,s]=this._getCircleData(e);this._circle(e,t,i,o,s)}e.setLineDash([0]),e.lineDashOffset=0,e.restore()}else{if(this.from!=this.to)u(e,this.from.x,this.from.y,this.to.x,this.to.y,n);else{const[i,o,s]=this._getCircleData(e);this._circle(e,t,i,o,s)}this.enableShadow(e,t),e.stroke(),this.disableShadow(e,t)}}findBorderPosition(e,t,i){return this.from!=this.to?this._findBorderPosition(e,t,i):this._findBorderPositionCircle(e,t,i)}findBorderPositions(e){if(this.from!=this.to)return{from:this._findBorderPosition(this.from,e),to:this._findBorderPosition(this.to,e)};{const[t,i]=this._getCircleData(e).slice(0,2);return{from:this._findBorderPositionCircle(this.from,e,{x:t,y:i,low:.25,high:.6,direction:-1}),to:this._findBorderPositionCircle(this.from,e,{x:t,y:i,low:.6,high:.8,direction:1})}}}_getCircleData(e){const t=this.options.selfReference.size;void 0!==e&&void 0===this.from.shape.width&&this.from.shape.resize(e);const i=re(e,this.options.selfReference.angle,t,this.from);return[i.x,i.y,t]}_pointOnCircle(e,t,i,o){const s=2*o*Math.PI;return{x:e+i*Math.cos(s),y:t-i*Math.sin(s)}}_findBorderPositionCircle(e,t,i){const o=i.x,s=i.y;let n=i.low,r=i.high;const a=i.direction,h=this.options.selfReference.size;let d,l=.5*(n+r),c=0;!0===this.options.arrowStrikethrough&&(-1===a?c=this.options.endPointOffset.from:1===a&&(c=this.options.endPointOffset.to));let p=0;do{l=.5*(n+r),d=this._pointOnCircle(o,s,h,l);const i=Math.atan2(e.y-d.y,e.x-d.x),u=e.distanceToBorder(t,i)+c-Math.sqrt(Math.pow(d.x-e.x,2)+Math.pow(d.y-e.y,2));if(Math.abs(u)<.05)break;u>0?a>0?n=l:r=l:a>0?r=l:n=l,++p}while(n<=r&&p<10);return{...d,t:l}}getLineWidth(e,t){return!0===e?Math.max(this.selectionWidth,.3/this._body.view.scale):!0===t?Math.max(this.hoverWidth,.3/this._body.view.scale):Math.max(this.options.width,.3/this._body.view.scale)}getColor(e,t){if(!1!==t.inheritsColor){if("both"===t.inheritsColor&&this.from.id!==this.to.id){const o=e.createLinearGradient(this.from.x,this.from.y,this.to.x,this.to.y);let s=this.from.options.color.highlight.border,n=this.to.options.color.highlight.border;return!1===this.from.selected&&!1===this.to.selected?(s=i.overrideOpacity(this.from.options.color.border,t.opacity),n=i.overrideOpacity(this.to.options.color.border,t.opacity)):!0===this.from.selected&&!1===this.to.selected?n=this.to.options.color.border:!1===this.from.selected&&!0===this.to.selected&&(s=this.from.options.color.border),o.addColorStop(0,s),o.addColorStop(1,n),o}return"to"===t.inheritsColor?i.overrideOpacity(this.to.options.color.border,t.opacity):i.overrideOpacity(this.from.options.color.border,t.opacity)}return i.overrideOpacity(t.color,t.opacity)}_circle(e,t,i,o,s){this.enableShadow(e,t);let n=0,r=2*Math.PI;if(!this.options.selfReference.renderBehindTheNode){const t=this.options.selfReference.angle,s=this.options.selfReference.angle+Math.PI,a=this._findBorderPositionCircle(this.from,e,{x:i,y:o,low:t,high:s,direction:-1}),h=this._findBorderPositionCircle(this.from,e,{x:i,y:o,low:t,high:s,direction:1});n=Math.atan2(a.y-o,a.x-i),r=Math.atan2(h.y-o,h.x-i)}e.beginPath(),e.arc(i,o,s,n,r,!1),e.stroke(),this.disableShadow(e,t)}getDistanceToEdge(e,t,i,o,s,n){if(this.from!=this.to)return this._getDistanceToEdge(e,t,i,o,s,n);{const[e,t,i]=this._getCircleData(void 0),o=e-s,r=t-n;return Math.abs(Math.sqrt(o*o+r*r)-i)}}_getDistanceToLine(e,t,i,o,s,n){const r=i-e,a=o-t;let h=((s-e)*r+(n-t)*a)/(r*r+a*a);h>1?h=1:h<0&&(h=0);const d=e+h*r-s,l=t+h*a-n;return Math.sqrt(d*d+l*l)}getArrowData(e,t,i,o,s,n){let r,a,h,d,l,c,p,u=n.width;"from"===t?(h=this.from,d=this.to,l=n.fromArrowScale<0,c=Math.abs(n.fromArrowScale),p=n.fromArrowType):"to"===t?(h=this.to,d=this.from,l=n.toArrowScale<0,c=Math.abs(n.toArrowScale),p=n.toArrowType):(h=this.to,d=this.from,l=n.middleArrowScale<0,c=Math.abs(n.middleArrowScale),p=n.middleArrowType);const g=15*c+3*u;if(h!=d){const o=g/Math.hypot(h.x-d.x,h.y-d.y);if("middle"!==t)if(!0===this.options.smooth.enabled){const s=this._findBorderPosition(h,e,{via:i}),n=this.getPoint(s.t+o*("from"===t?1:-1),i);r=Math.atan2(s.y-n.y,s.x-n.x),a=s}else r=Math.atan2(h.y-d.y,h.x-d.x),a=this._findBorderPosition(h,e);else{const e=(l?-o:o)/2,t=this.getPoint(.5+e,i),s=this.getPoint(.5-e,i);r=Math.atan2(t.y-s.y,t.x-s.x),a=this.getPoint(.5,i)}}else{const[i,o,s]=this._getCircleData(e);if("from"===t){const t=this.options.selfReference.angle,s=this.options.selfReference.angle+Math.PI,n=this._findBorderPositionCircle(this.from,e,{x:i,y:o,low:t,high:s,direction:-1});r=-2*n.t*Math.PI+1.5*Math.PI+.1*Math.PI,a=n}else if("to"===t){const t=this.options.selfReference.angle,s=this.options.selfReference.angle+Math.PI,n=this._findBorderPositionCircle(this.from,e,{x:i,y:o,low:t,high:s,direction:1});r=-2*n.t*Math.PI+1.5*Math.PI-1.1*Math.PI,a=n}else{const e=this.options.selfReference.angle/(2*Math.PI);a=this._pointOnCircle(i,o,s,e),r=-2*e*Math.PI+1.5*Math.PI+.1*Math.PI}}return{point:a,core:{x:a.x-.9*g*Math.cos(r),y:a.y-.9*g*Math.sin(r)},angle:r,length:g,type:p}}drawArrowHead(e,t,i,o,s){e.strokeStyle=this.getColor(e,t),e.fillStyle=e.strokeStyle,e.lineWidth=t.width;Le.draw(e,s)&&(this.enableShadow(e,t),e.fill(),this.disableShadow(e,t))}enableShadow(e,t){!0===t.shadow&&(e.shadowColor=t.shadowColor,e.shadowBlur=t.shadowSize,e.shadowOffsetX=t.shadowX,e.shadowOffsetY=t.shadowY)}disableShadow(e,t){!0===t.shadow&&(e.shadowColor="rgba(0,0,0,0)",e.shadowBlur=0,e.shadowOffsetX=0,e.shadowOffsetY=0)}drawBackground(e,t){if(!1!==t.background){const i={strokeStyle:e.strokeStyle,lineWidth:e.lineWidth,dashes:e.dashes};e.strokeStyle=t.backgroundColor,e.lineWidth=t.backgroundSize,this.setStrokeDashed(e,t.backgroundDashes),e.stroke(),e.strokeStyle=i.strokeStyle,e.lineWidth=i.lineWidth,e.dashes=i.dashes,this.setStrokeDashed(e,t.dashes)}}setStrokeDashed(e,t){if(!1!==t)if(void 0!==e.setLineDash){const i=Array.isArray(t)?t:[5,5];e.setLineDash(i)}else console.warn("setLineDash is not supported in this browser. The dashed stroke cannot be used.");else void 0!==e.setLineDash?e.setLineDash([]):console.warn("setLineDash is not supported in this browser. The dashed stroke cannot be used.")}}class Ve extends We{constructor(e,t,i){super(e,t,i)}_findBorderPositionBezier(e,t,i=this._getViaCoordinates()){let o,s,n=!1,r=1,a=0,h=this.to,d=this.options.endPointOffset?this.options.endPointOffset.to:0;e.id===this.from.id&&(h=this.from,n=!0,d=this.options.endPointOffset?this.options.endPointOffset.from:0),!1===this.options.arrowStrikethrough&&(d=0);let l=0;do{s=.5*(a+r),o=this.getPoint(s,i);const e=Math.atan2(h.y-o.y,h.x-o.x),c=h.distanceToBorder(t,e)+d-Math.sqrt(Math.pow(o.x-h.x,2)+Math.pow(o.y-h.y,2));if(Math.abs(c)<.2)break;c<0?!1===n?a=s:r=s:!1===n?r=s:a=s,++l}while(a<=r&&l<10);return{...o,t:s}}_getDistanceToBezierEdge(e,t,i,o,s,n,r){let a,h,d,l,c,p=1e9,u=e,g=t;for(h=1;h<10;h++)d=.1*h,l=Math.pow(1-d,2)*e+2*d*(1-d)*r.x+Math.pow(d,2)*i,c=Math.pow(1-d,2)*t+2*d*(1-d)*r.y+Math.pow(d,2)*o,h>0&&(a=this._getDistanceToLine(u,g,l,c,s,n),p=a<p?a:p),u=l,g=c;return p}_bezierCurve(e,t,i,o){e.beginPath(),e.moveTo(this.fromPoint.x,this.fromPoint.y),null!=i&&null!=i.x?null!=o&&null!=o.x?e.bezierCurveTo(i.x,i.y,o.x,o.y,this.toPoint.x,this.toPoint.y):e.quadraticCurveTo(i.x,i.y,this.toPoint.x,this.toPoint.y):e.lineTo(this.toPoint.x,this.toPoint.y),this.drawBackground(e,t),this.enableShadow(e,t),e.stroke(),this.disableShadow(e,t)}getViaNode(){return this._getViaCoordinates()}}class qe extends Ve{constructor(e,t,i){super(e,t,i),this.via=this.via,this._boundFunction=()=>{this.positionBezierNode()},this._body.emitter.on("_repositionBezierNodes",this._boundFunction)}setOptions(e){super.setOptions(e);let t=!1;this.options.physics!==e.physics&&(t=!0),this.options=e,this.id=this.options.id,this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],this.setupSupportNode(),this.connect(),!0===t&&(this.via.setOptions({physics:this.options.physics}),this.positionBezierNode())}connect(){this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],void 0===this.from||void 0===this.to||!1===this.options.physics||this.from.id===this.to.id?this.via.setOptions({physics:!1}):this.via.setOptions({physics:!0})}cleanup(){return this._body.emitter.off("_repositionBezierNodes",this._boundFunction),void 0!==this.via&&(delete this._body.nodes[this.via.id],this.via=void 0,!0)}setupSupportNode(){if(void 0===this.via){const e="edgeId:"+this.id,t=this._body.functions.createNode({id:e,shape:"circle",physics:!0,hidden:!0});this._body.nodes[e]=t,this.via=t,this.via.parentEdgeId=this.id,this.positionBezierNode()}}positionBezierNode(){void 0!==this.via&&void 0!==this.from&&void 0!==this.to?(this.via.x=.5*(this.from.x+this.to.x),this.via.y=.5*(this.from.y+this.to.y)):void 0!==this.via&&(this.via.x=0,this.via.y=0)}_line(e,t,i){this._bezierCurve(e,t,i)}_getViaCoordinates(){return this.via}getViaNode(){return this.via}getPoint(e,t=this.via){if(this.from===this.to){const[t,i,o]=this._getCircleData(),s=2*Math.PI*(1-e);return{x:t+o*Math.sin(s),y:i+o-o*(1-Math.cos(s))}}return{x:Math.pow(1-e,2)*this.fromPoint.x+2*e*(1-e)*t.x+Math.pow(e,2)*this.toPoint.x,y:Math.pow(1-e,2)*this.fromPoint.y+2*e*(1-e)*t.y+Math.pow(e,2)*this.toPoint.y}}_findBorderPosition(e,t){return this._findBorderPositionBezier(e,t,this.via)}_getDistanceToEdge(e,t,i,o,s,n){return this._getDistanceToBezierEdge(e,t,i,o,s,n,this.via)}}class Ue extends Ve{constructor(e,t,i){super(e,t,i)}_line(e,t,i){this._bezierCurve(e,t,i)}getViaNode(){return this._getViaCoordinates()}_getViaCoordinates(){const e=this.options.smooth.roundness,t=this.options.smooth.type;let i=Math.abs(this.from.x-this.to.x),o=Math.abs(this.from.y-this.to.y);if("discrete"===t||"diagonalCross"===t){let s,n;s=n=i<=o?e*o:e*i,this.from.x>this.to.x&&(s=-s),this.from.y>=this.to.y&&(n=-n);let r=this.from.x+s,a=this.from.y+n;return"discrete"===t&&(i<=o?r=i<e*o?this.from.x:r:a=o<e*i?this.from.y:a),{x:r,y:a}}if("straightCross"===t){let t=(1-e)*i,s=(1-e)*o;return i<=o?(t=0,this.from.y<this.to.y&&(s=-s)):(this.from.x<this.to.x&&(t=-t),s=0),{x:this.to.x+t,y:this.to.y+s}}if("horizontal"===t){let t=(1-e)*i;return this.from.x<this.to.x&&(t=-t),{x:this.to.x+t,y:this.from.y}}if("vertical"===t){let t=(1-e)*o;return this.from.y<this.to.y&&(t=-t),{x:this.from.x,y:this.to.y+t}}if("curvedCW"===t){i=this.to.x-this.from.x,o=this.from.y-this.to.y;const t=Math.sqrt(i*i+o*o),s=Math.PI,n=(Math.atan2(o,i)+(.5*e+.5)*s)%(2*s);return{x:this.from.x+(.5*e+.5)*t*Math.sin(n),y:this.from.y+(.5*e+.5)*t*Math.cos(n)}}if("curvedCCW"===t){i=this.to.x-this.from.x,o=this.from.y-this.to.y;const t=Math.sqrt(i*i+o*o),s=Math.PI,n=(Math.atan2(o,i)+(.5*-e+.5)*s)%(2*s);return{x:this.from.x+(.5*e+.5)*t*Math.sin(n),y:this.from.y+(.5*e+.5)*t*Math.cos(n)}}{let t,s;t=s=i<=o?e*o:e*i,this.from.x>this.to.x&&(t=-t),this.from.y>=this.to.y&&(s=-s);let n=this.from.x+t,r=this.from.y+s;return i<=o?n=this.from.x<=this.to.x?this.to.x<n?this.to.x:n:this.to.x>n?this.to.x:n:r=this.from.y>=this.to.y?this.to.y>r?this.to.y:r:this.to.y<r?this.to.y:r,{x:n,y:r}}}_findBorderPosition(e,t,i={}){return this._findBorderPositionBezier(e,t,i.via)}_getDistanceToEdge(e,t,i,o,s,n,r=this._getViaCoordinates()){return this._getDistanceToBezierEdge(e,t,i,o,s,n,r)}getPoint(e,t=this._getViaCoordinates()){const i=e;return{x:Math.pow(1-i,2)*this.fromPoint.x+2*i*(1-i)*t.x+Math.pow(i,2)*this.toPoint.x,y:Math.pow(1-i,2)*this.fromPoint.y+2*i*(1-i)*t.y+Math.pow(i,2)*this.toPoint.y}}}class Ye extends Ve{constructor(e,t,i){super(e,t,i)}_getDistanceToBezierEdge2(e,t,i,o,s,n,r,a){let h=1e9,d=e,l=t;const c=[0,0,0,0];for(let p=1;p<10;p++){const u=.1*p;c[0]=Math.pow(1-u,3),c[1]=3*u*Math.pow(1-u,2),c[2]=3*Math.pow(u,2)*(1-u),c[3]=Math.pow(u,3);const g=c[0]*e+c[1]*r.x+c[2]*a.x+c[3]*i,m=c[0]*t+c[1]*r.y+c[2]*a.y+c[3]*o;if(p>0){const e=this._getDistanceToLine(d,l,g,m,s,n);h=e<h?e:h}d=g,l=m}return h}}class Xe extends Ye{constructor(e,t,i){super(e,t,i)}_line(e,t,i){let o=i[0],s=i[1];this._bezierCurve(e,t,o,s)}_getViaCoordinates(){const e=this.from.x-this.to.x,t=this.from.y-this.to.y;let i,o,s,n;const r=this.options.smooth.roundness;return(Math.abs(e)>Math.abs(t)||!0===this.options.smooth.forceDirection||"horizontal"===this.options.smooth.forceDirection)&&"vertical"!==this.options.smooth.forceDirection?(o=this.from.y,n=this.to.y,i=this.from.x-r*e,s=this.to.x+r*e):(o=this.from.y-r*t,n=this.to.y+r*t,i=this.from.x,s=this.to.x),[{x:i,y:o},{x:s,y:n}]}getViaNode(){return this._getViaCoordinates()}_findBorderPosition(e,t){return this._findBorderPositionBezier(e,t)}_getDistanceToEdge(e,t,i,o,s,n,[r,a]=this._getViaCoordinates()){return this._getDistanceToBezierEdge2(e,t,i,o,s,n,r,a)}getPoint(e,[t,i]=this._getViaCoordinates()){const o=e,s=[Math.pow(1-o,3),3*o*Math.pow(1-o,2),3*Math.pow(o,2)*(1-o),Math.pow(o,3)];return{x:s[0]*this.fromPoint.x+s[1]*t.x+s[2]*i.x+s[3]*this.toPoint.x,y:s[0]*this.fromPoint.y+s[1]*t.y+s[2]*i.y+s[3]*this.toPoint.y}}}class Ge extends We{constructor(e,t,i){super(e,t,i)}_line(e,t){e.beginPath(),e.moveTo(this.fromPoint.x,this.fromPoint.y),e.lineTo(this.toPoint.x,this.toPoint.y),this.enableShadow(e,t),e.stroke(),this.disableShadow(e,t)}getViaNode(){}getPoint(e){return{x:(1-e)*this.fromPoint.x+e*this.toPoint.x,y:(1-e)*this.fromPoint.y+e*this.toPoint.y}}_findBorderPosition(e,t){let i=this.to,o=this.from;e.id===this.from.id&&(i=this.from,o=this.to);const s=Math.atan2(i.y-o.y,i.x-o.x),n=i.x-o.x,r=i.y-o.y,a=Math.sqrt(n*n+r*r),h=(a-e.distanceToBorder(t,s))/a;return{x:(1-h)*o.x+h*i.x,y:(1-h)*o.y+h*i.y,t:0}}_getDistanceToEdge(e,t,i,o,s,n){return this._getDistanceToLine(e,t,i,o,s,n)}}class Ke{constructor(e,t,o,s,n){if(void 0===t)throw new Error("No body provided");this.options=i.bridgeObject(s),this.globalOptions=s,this.defaultOptions=n,this.body=t,this.imagelist=o,this.id=void 0,this.fromId=void 0,this.toId=void 0,this.selected=!1,this.hover=!1,this.labelDirty=!0,this.baseWidth=this.options.width,this.baseFontSize=this.options.font.size,this.from=void 0,this.to=void 0,this.edgeType=void 0,this.connected=!1,this.labelModule=new pe(this.body,this.options,!0),this.setOptions(e)}setOptions(e){if(!e)return;let t=void 0!==e.physics&&this.options.physics!==e.physics||void 0!==e.hidden&&(this.options.hidden||!1)!==(e.hidden||!1)||void 0!==e.from&&this.options.from!==e.from||void 0!==e.to&&this.options.to!==e.to;Ke.parseOptions(this.options,e,!0,this.globalOptions),void 0!==e.id&&(this.id=e.id),void 0!==e.from&&(this.fromId=e.from),void 0!==e.to&&(this.toId=e.to),void 0!==e.title&&(this.title=e.title),void 0!==e.value&&(e.value=parseFloat(e.value));let i=[e,this.options,this.defaultOptions];return this.chooser=oe("edge",i),this.updateLabelModule(e),t=this.updateEdgeType()||t,this._setInteractionWidths(),this.connect(),t}static parseOptions(e,t,o=!1,s={},n=!1){if(i.selectiveDeepExtend(["endPointOffset","arrowStrikethrough","id","from","hidden","hoverWidth","labelHighlightBold","length","line","opacity","physics","scaling","selectionWidth","selfReferenceSize","selfReference","to","title","value","width","font","chosen","widthConstraint"],e,t,o),void 0!==t.endPointOffset&&void 0!==t.endPointOffset.from&&(Number.isFinite(t.endPointOffset.from)?e.endPointOffset.from=t.endPointOffset.from:(e.endPointOffset.from=void 0!==s.endPointOffset.from?s.endPointOffset.from:0,console.error("endPointOffset.from is not a valid number"))),void 0!==t.endPointOffset&&void 0!==t.endPointOffset.to&&(Number.isFinite(t.endPointOffset.to)?e.endPointOffset.to=t.endPointOffset.to:(e.endPointOffset.to=void 0!==s.endPointOffset.to?s.endPointOffset.to:0,console.error("endPointOffset.to is not a valid number"))),ne(t.label)?e.label=t.label:ne(e.label)||(e.label=void 0),i.mergeOptions(e,t,"smooth",s),i.mergeOptions(e,t,"shadow",s),i.mergeOptions(e,t,"background",s),void 0!==t.dashes&&null!==t.dashes?e.dashes=t.dashes:!0===o&&null===t.dashes&&(e.dashes=Object.create(s.dashes)),void 0!==t.scaling&&null!==t.scaling?(void 0!==t.scaling.min&&(e.scaling.min=t.scaling.min),void 0!==t.scaling.max&&(e.scaling.max=t.scaling.max),i.mergeOptions(e.scaling,t.scaling,"label",s.scaling)):!0===o&&null===t.scaling&&(e.scaling=Object.create(s.scaling)),void 0!==t.arrows&&null!==t.arrows)if("string"==typeof t.arrows){let i=t.arrows.toLowerCase();e.arrows.to.enabled=-1!=i.indexOf("to"),e.arrows.middle.enabled=-1!=i.indexOf("middle"),e.arrows.from.enabled=-1!=i.indexOf("from")}else{if("object"!=typeof t.arrows)throw new Error("The arrow newOptions can only be an object or a string. Refer to the documentation. You used:"+JSON.stringify(t.arrows));i.mergeOptions(e.arrows,t.arrows,"to",s.arrows),i.mergeOptions(e.arrows,t.arrows,"middle",s.arrows),i.mergeOptions(e.arrows,t.arrows,"from",s.arrows)}else!0===o&&null===t.arrows&&(e.arrows=Object.create(s.arrows));if(void 0!==t.color&&null!==t.color){const a=i.isString(t.color)?{color:t.color,highlight:t.color,hover:t.color,inherit:!1,opacity:1}:t.color;let h=e.color;if(n)i.deepExtend(h,s.color,!1,o);else for(var r in h)h.hasOwnProperty(r)&&delete h[r];if(i.isString(h))h.color=h,h.highlight=h,h.hover=h,h.inherit=!1,void 0===a.opacity&&(h.opacity=1);else{let e=!1;void 0!==a.color&&(h.color=a.color,e=!0),void 0!==a.highlight&&(h.highlight=a.highlight,e=!0),void 0!==a.hover&&(h.hover=a.hover,e=!0),void 0!==a.inherit&&(h.inherit=a.inherit),void 0!==a.opacity&&(h.opacity=Math.min(1,Math.max(0,a.opacity))),!0===e?h.inherit=!1:void 0===h.inherit&&(h.inherit="from")}}else!0===o&&null===t.color&&(e.color=i.bridgeObject(s.color));!0===o&&null===t.font&&(e.font=i.bridgeObject(s.font)),t.hasOwnProperty("selfReferenceSize")&&(console.log("The selfReferenceSize property has been deprecated. Please use selfReference property instead. The selfReference can be set like thise selfReference:{size:30, angle:Math.PI / 4}"),e.selfReference.size=t.selfReferenceSize)}getFormattingValues(){let e=!0===this.options.arrows.to||!0===this.options.arrows.to.enabled,t=!0===this.options.arrows.from||!0===this.options.arrows.from.enabled,i=!0===this.options.arrows.middle||!0===this.options.arrows.middle.enabled,o=this.options.color.inherit,s={toArrow:e,toArrowScale:this.options.arrows.to.scaleFactor,toArrowType:this.options.arrows.to.type,toArrowSrc:this.options.arrows.to.src,toArrowImageWidth:this.options.arrows.to.imageWidth,toArrowImageHeight:this.options.arrows.to.imageHeight,middleArrow:i,middleArrowScale:this.options.arrows.middle.scaleFactor,middleArrowType:this.options.arrows.middle.type,middleArrowSrc:this.options.arrows.middle.src,middleArrowImageWidth:this.options.arrows.middle.imageWidth,middleArrowImageHeight:this.options.arrows.middle.imageHeight,fromArrow:t,fromArrowScale:this.options.arrows.from.scaleFactor,fromArrowType:this.options.arrows.from.type,fromArrowSrc:this.options.arrows.from.src,fromArrowImageWidth:this.options.arrows.from.imageWidth,fromArrowImageHeight:this.options.arrows.from.imageHeight,arrowStrikethrough:this.options.arrowStrikethrough,color:o?void 0:this.options.color.color,inheritsColor:o,opacity:this.options.color.opacity,hidden:this.options.hidden,length:this.options.length,shadow:this.options.shadow.enabled,shadowColor:this.options.shadow.color,shadowSize:this.options.shadow.size,shadowX:this.options.shadow.x,shadowY:this.options.shadow.y,dashes:this.options.dashes,width:this.options.width,background:this.options.background.enabled,backgroundColor:this.options.background.color,backgroundSize:this.options.background.size,backgroundDashes:this.options.background.dashes};if(this.selected||this.hover)if(!0===this.chooser){if(this.selected){let e=this.options.selectionWidth;"function"==typeof e?s.width=e(s.width):"number"==typeof e&&(s.width+=e),s.width=Math.max(s.width,.3/this.body.view.scale),s.color=this.options.color.highlight,s.shadow=this.options.shadow.enabled}else if(this.hover){let e=this.options.hoverWidth;"function"==typeof e?s.width=e(s.width):"number"==typeof e&&(s.width+=e),s.width=Math.max(s.width,.3/this.body.view.scale),s.color=this.options.color.hover,s.shadow=this.options.shadow.enabled}}else"function"==typeof this.chooser&&(this.chooser(s,this.options.id,this.selected,this.hover),void 0!==s.color&&(s.inheritsColor=!1),!1===s.shadow&&(s.shadowColor===this.options.shadow.color&&s.shadowSize===this.options.shadow.size&&s.shadowX===this.options.shadow.x&&s.shadowY===this.options.shadow.y||(s.shadow=!0)));else s.shadow=this.options.shadow.enabled,s.width=Math.max(s.width,.3/this.body.view.scale);return s}updateLabelModule(e){let t=[e,this.options,this.globalOptions,this.defaultOptions];this.labelModule.update(this.options,t),void 0!==this.labelModule.baseSize&&(this.baseFontSize=this.labelModule.baseSize)}updateEdgeType(){let e=this.options.smooth,t=!1,i=!0;return void 0!==this.edgeType&&((this.edgeType instanceof qe&&!0===e.enabled&&"dynamic"===e.type||this.edgeType instanceof Xe&&!0===e.enabled&&"cubicBezier"===e.type||this.edgeType instanceof Ue&&!0===e.enabled&&"dynamic"!==e.type&&"cubicBezier"!==e.type||this.edgeType instanceof Ge&&!1===e.type.enabled)&&(i=!1),!0===i&&(t=this.cleanup())),!0===i?!0===e.enabled?"dynamic"===e.type?(t=!0,this.edgeType=new qe(this.options,this.body,this.labelModule)):"cubicBezier"===e.type?this.edgeType=new Xe(this.options,this.body,this.labelModule):this.edgeType=new Ue(this.options,this.body,this.labelModule):this.edgeType=new Ge(this.options,this.body,this.labelModule):this.edgeType.setOptions(this.options),t}connect(){this.disconnect(),this.from=this.body.nodes[this.fromId]||void 0,this.to=this.body.nodes[this.toId]||void 0,this.connected=void 0!==this.from&&void 0!==this.to,!0===this.connected?(this.from.attachEdge(this),this.to.attachEdge(this)):(this.from&&this.from.detachEdge(this),this.to&&this.to.detachEdge(this)),this.edgeType.connect()}disconnect(){this.from&&(this.from.detachEdge(this),this.from=void 0),this.to&&(this.to.detachEdge(this),this.to=void 0),this.connected=!1}getTitle(){return this.title}isSelected(){return this.selected}getValue(){return this.options.value}setValueRange(e,t,i){if(void 0!==this.options.value){var o=this.options.scaling.customScalingFunction(e,t,i,this.options.value),s=this.options.scaling.max-this.options.scaling.min;if(!0===this.options.scaling.label.enabled){var n=this.options.scaling.label.max-this.options.scaling.label.min;this.options.font.size=this.options.scaling.label.min+o*n}this.options.width=this.options.scaling.min+o*s}else this.options.width=this.baseWidth,this.options.font.size=this.baseFontSize;this._setInteractionWidths(),this.updateLabelModule()}_setInteractionWidths(){"function"==typeof this.options.hoverWidth?this.edgeType.hoverWidth=this.options.hoverWidth(this.options.width):this.edgeType.hoverWidth=this.options.hoverWidth+this.options.width,"function"==typeof this.options.selectionWidth?this.edgeType.selectionWidth=this.options.selectionWidth(this.options.width):this.edgeType.selectionWidth=this.options.selectionWidth+this.options.width}draw(e){const t=this.getFormattingValues();if(t.hidden)return;const i=this.edgeType.getViaNode();this.edgeType.drawLine(e,t,this.selected,this.hover,i),this.drawLabel(e,i)}drawArrows(e){const t=this.getFormattingValues();if(t.hidden)return;const i=this.edgeType.getViaNode(),o={};this.edgeType.fromPoint=this.edgeType.from,this.edgeType.toPoint=this.edgeType.to,t.fromArrow&&(o.from=this.edgeType.getArrowData(e,"from",i,this.selected,this.hover,t),!1===t.arrowStrikethrough&&(this.edgeType.fromPoint=o.from.core),t.fromArrowSrc&&(o.from.image=this.imagelist.load(t.fromArrowSrc)),t.fromArrowImageWidth&&(o.from.imageWidth=t.fromArrowImageWidth),t.fromArrowImageHeight&&(o.from.imageHeight=t.fromArrowImageHeight)),t.toArrow&&(o.to=this.edgeType.getArrowData(e,"to",i,this.selected,this.hover,t),!1===t.arrowStrikethrough&&(this.edgeType.toPoint=o.to.core),t.toArrowSrc&&(o.to.image=this.imagelist.load(t.toArrowSrc)),t.toArrowImageWidth&&(o.to.imageWidth=t.toArrowImageWidth),t.toArrowImageHeight&&(o.to.imageHeight=t.toArrowImageHeight)),t.middleArrow&&(o.middle=this.edgeType.getArrowData(e,"middle",i,this.selected,this.hover,t),t.middleArrowSrc&&(o.middle.image=this.imagelist.load(t.middleArrowSrc)),t.middleArrowImageWidth&&(o.middle.imageWidth=t.middleArrowImageWidth),t.middleArrowImageHeight&&(o.middle.imageHeight=t.middleArrowImageHeight)),t.fromArrow&&this.edgeType.drawArrowHead(e,t,this.selected,this.hover,o.from),t.middleArrow&&this.edgeType.drawArrowHead(e,t,this.selected,this.hover,o.middle),t.toArrow&&this.edgeType.drawArrowHead(e,t,this.selected,this.hover,o.to)}drawLabel(e,t){if(void 0!==this.options.label){var i=this.from,o=this.to;if(this.labelModule.differentState(this.selected,this.hover)&&this.labelModule.getTextSize(e,this.selected,this.hover),i.id!=o.id){this.labelModule.pointToSelf=!1;var s=this.edgeType.getPoint(.5,t);e.save();let i=this._getRotation(e);0!=i.angle&&(e.translate(i.x,i.y),e.rotate(i.angle)),this.labelModule.draw(e,s.x,s.y,this.selected,this.hover),e.restore()}else{this.labelModule.pointToSelf=!0;const t=re(e,this.options.selfReference.angle,this.options.selfReference.size,i);s=this._pointOnCircle(t.x,t.y,this.options.selfReference.size,this.options.selfReference.angle),this.labelModule.draw(e,s.x,s.y,this.selected,this.hover)}}}getItemsOnPoint(e){var t=[];if(this.labelModule.visible()){let i=this._getRotation();se(this.labelModule.getSize(),e,i)&&t.push({edgeId:this.id,labelId:0})}let i={left:e.x,top:e.y};return this.isOverlappingWith(i)&&t.push({edgeId:this.id}),t}isOverlappingWith(e){if(this.connected){var t=this.from.x,i=this.from.y,o=this.to.x,s=this.to.y,n=e.left,r=e.top;return this.edgeType.getDistanceToEdge(t,i,o,s,n,r)<10}return!1}_getRotation(e){let t=this.edgeType.getViaNode(),i=this.edgeType.getPoint(.5,t);void 0!==e&&this.labelModule.calculateLabelSize(e,this.selected,this.hover,i.x,i.y);let o={x:i.x,y:this.labelModule.size.yLine,angle:0};if(!this.labelModule.visible())return o;if("horizontal"===this.options.font.align)return o;var s=this.from.y-this.to.y,n=this.from.x-this.to.x,r=Math.atan2(s,n);return(r<-1&&n<0||r>0&&n<0)&&(r+=Math.PI),o.angle=r,o}_pointOnCircle(e,t,i,o){return{x:e+i*Math.cos(o),y:t-i*Math.sin(o)}}select(){this.selected=!0}unselect(){this.selected=!1}cleanup(){return this.edgeType.cleanup()}remove(){this.cleanup(),this.disconnect(),delete this.body.edges[this.id]}endPointsValid(){return void 0!==this.body.nodes[this.fromId]&&void 0!==this.body.nodes[this.toId]}}class Ze{constructor(e,t,o){this.body=e,this.images=t,this.groups=o,this.body.functions.createEdge=this.create.bind(this),this.edgesListeners={add:(e,t)=>{this.add(t.items)},update:(e,t)=>{this.update(t.items)},remove:(e,t)=>{this.remove(t.items)}},this.options={},this.defaultOptions={arrows:{to:{enabled:!1,scaleFactor:1,type:"arrow"},middle:{enabled:!1,scaleFactor:1,type:"arrow"},from:{enabled:!1,scaleFactor:1,type:"arrow"}},endPointOffset:{from:0,to:0},arrowStrikethrough:!0,color:{color:"#848484",highlight:"#848484",hover:"#848484",inherit:"from",opacity:1},dashes:!1,font:{color:"#343434",size:14,face:"arial",background:"none",strokeWidth:2,strokeColor:"#ffffff",align:"horizontal",multi:!1,vadjust:0,bold:{mod:"bold"},boldital:{mod:"bold italic"},ital:{mod:"italic"},mono:{mod:"",size:15,face:"courier new",vadjust:2}},hidden:!1,hoverWidth:1.5,label:void 0,labelHighlightBold:!0,length:void 0,physics:!0,scaling:{min:1,max:15,label:{enabled:!0,min:14,max:30,maxVisible:30,drawThreshold:5},customScalingFunction:function(e,t,i,o){if(t===e)return.5;var s=1/(t-e);return Math.max(0,(o-e)*s)}},selectionWidth:1.5,selfReference:{size:20,angle:Math.PI/4,renderBehindTheNode:!0},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:10,x:5,y:5},background:{enabled:!1,color:"rgba(111,111,111,1)",size:10,dashes:!1},smooth:{enabled:!0,type:"dynamic",forceDirection:"none",roundness:.5},title:void 0,width:1,value:void 0},i.deepExtend(this.options,this.defaultOptions),this.bindEventListeners()}bindEventListeners(){this.body.emitter.on("_forceDisableDynamicCurves",(e,t=!0)=>{"dynamic"===e&&(e="continuous");let i=!1;for(let t in this.body.edges)if(this.body.edges.hasOwnProperty(t)){let o=this.body.edges[t];const s=this.body.data.edges.get(t);if(null!=s){let t=s.smooth;void 0!==t&&!0===t.enabled&&"dynamic"===t.type&&(void 0===e?o.setOptions({smooth:!1}):o.setOptions({smooth:{type:e}}),i=!0)}}!0===t&&!0===i&&this.body.emitter.emit("_dataChanged")}),this.body.emitter.on("_dataUpdated",()=>{this.reconnectEdges()}),this.body.emitter.on("refreshEdges",this.refresh.bind(this)),this.body.emitter.on("refresh",this.refresh.bind(this)),this.body.emitter.on("destroy",()=>{i.forEach(this.edgesListeners,(e,t)=>{this.body.data.edges&&this.body.data.edges.off(t,e)}),delete this.body.functions.createEdge,delete this.edgesListeners.add,delete this.edgesListeners.update,delete this.edgesListeners.remove,delete this.edgesListeners})}setOptions(e){if(void 0!==e){Ke.parseOptions(this.options,e,!0,this.defaultOptions,!0);let t=!1;if(void 0!==e.smooth)for(let e in this.body.edges)this.body.edges.hasOwnProperty(e)&&(t=this.body.edges[e].updateEdgeType()||t);if(void 0!==e.font)for(let e in this.body.edges)this.body.edges.hasOwnProperty(e)&&this.body.edges[e].updateLabelModule();void 0===e.hidden&&void 0===e.physics&&!0!==t||this.body.emitter.emit("_dataChanged")}}setData(e,t=!1){var o=this.body.data.edges;if(e instanceof n.DataSet||e instanceof n.DataView)this.body.data.edges=e;else if(Array.isArray(e))this.body.data.edges=new n.DataSet,this.body.data.edges.add(e);else{if(e)throw new TypeError("Array or DataSet expected");this.body.data.edges=new n.DataSet}if(o&&i.forEach(this.edgesListeners,(e,t)=>{o.off(t,e)}),this.body.edges={},this.body.data.edges){i.forEach(this.edgesListeners,(e,t)=>{this.body.data.edges.on(t,e)});var s=this.body.data.edges.getIds();this.add(s,!0)}this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),!1===t&&this.body.emitter.emit("_dataChanged")}add(e,t=!1){var i=this.body.edges,o=this.body.data.edges;for(let t=0;t<e.length;t++){var s=e[t],n=i[s];n&&n.disconnect();var r=o.get(s,{showInternalIds:!0});i[s]=this.create(r)}this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),!1===t&&this.body.emitter.emit("_dataChanged")}update(e){for(var t=this.body.edges,i=this.body.data.edges,o=!1,s=0;s<e.length;s++){var n=e[s],r=i.get(n),a=t[n];void 0!==a?(a.disconnect(),o=a.setOptions(r)||o,a.connect()):(this.body.edges[n]=this.create(r),o=!0)}!0===o?(this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),this.body.emitter.emit("_dataChanged")):this.body.emitter.emit("_dataUpdated")}remove(e,t=!0){if(0!==e.length){var o=this.body.edges;i.forEach(e,e=>{var t=o[e];void 0!==t&&t.remove()}),t&&this.body.emitter.emit("_dataChanged")}}refresh(){i.forEach(this.body.edges,(e,t)=>{const i=this.body.data.edges.get(t);void 0!==i&&e.setOptions(i)})}create(e){return new Ke(e,this.body,this.images,this.options,this.defaultOptions)}reconnectEdges(){var e,t=this.body.nodes,i=this.body.edges;for(e in t)t.hasOwnProperty(e)&&(t[e].edges=[]);for(e in i)if(i.hasOwnProperty(e)){var o=i[e];o.from=null,o.to=null,o.connect()}}getConnectedNodes(e){let t=[];if(void 0!==this.body.edges[e]){let i=this.body.edges[e];void 0!==i.fromId&&t.push(i.fromId),void 0!==i.toId&&t.push(i.toId)}return t}_updateState(){this._addMissingEdges(),this._removeInvalidEdges()}_removeInvalidEdges(){let e=[];i.forEach(this.body.edges,(t,i)=>{let o=this.body.nodes[t.toId],s=this.body.nodes[t.fromId];void 0!==o&&!0===o.isCluster||void 0!==s&&!0===s.isCluster||void 0!==o&&void 0!==s||e.push(i)}),this.remove(e,!1)}_addMissingEdges(){let e=this.body.data.edges;if(null==e)return;let t=this.body.edges,i=[];e.forEach((e,o)=>{void 0===t[o]&&i.push(o)}),this.add(i,!0)}}class Je{constructor(e,t,o){this.body=e,this.physicsBody=t,this.barnesHutTree,this.setOptions(o),this._rng=i.Alea("BARNES HUT SOLVER")}setOptions(e){this.options=e,this.thetaInversed=1/this.options.theta,this.overlapAvoidanceFactor=1-Math.max(0,Math.min(1,this.options.avoidOverlap))}solve(){if(0!==this.options.gravitationalConstant&&this.physicsBody.physicsNodeIndices.length>0){let e,t=this.body.nodes,i=this.physicsBody.physicsNodeIndices,o=i.length,s=this._formBarnesHutTree(t,i);this.barnesHutTree=s;for(let n=0;n<o;n++)e=t[i[n]],e.options.mass>0&&this._getForceContributions(s.root,e)}}_getForceContributions(e,t){this._getForceContribution(e.children.NW,t),this._getForceContribution(e.children.NE,t),this._getForceContribution(e.children.SW,t),this._getForceContribution(e.children.SE,t)}_getForceContribution(e,t){if(e.childrenCount>0){let i,o,s;i=e.centerOfMass.x-t.x,o=e.centerOfMass.y-t.y,s=Math.sqrt(i*i+o*o),s*e.calcSize>this.thetaInversed?this._calculateForces(s,i,o,t,e):4===e.childrenCount?this._getForceContributions(e,t):e.children.data.id!=t.id&&this._calculateForces(s,i,o,t,e)}}_calculateForces(e,t,i,o,s){0===e&&(t=e=.1),this.overlapAvoidanceFactor<1&&o.shape.radius&&(e=Math.max(.1+this.overlapAvoidanceFactor*o.shape.radius,e-o.shape.radius));let n=this.options.gravitationalConstant*s.mass*o.options.mass/Math.pow(e,3),r=t*n,a=i*n;this.physicsBody.forces[o.id].x+=r,this.physicsBody.forces[o.id].y+=a}_formBarnesHutTree(e,t){let i,o=t.length,s=e[t[0]].x,n=e[t[0]].y,r=e[t[0]].x,a=e[t[0]].y;for(let i=1;i<o;i++){let o=e[t[i]],h=o.x,d=o.y;o.options.mass>0&&(h<s&&(s=h),h>r&&(r=h),d<n&&(n=d),d>a&&(a=d))}let h=Math.abs(r-s)-Math.abs(a-n);h>0?(n-=.5*h,a+=.5*h):(s+=.5*h,r-=.5*h);let d=Math.max(1e-5,Math.abs(r-s)),l=.5*d,c=.5*(s+r),p=.5*(n+a),u={root:{centerOfMass:{x:0,y:0},mass:0,range:{minX:c-l,maxX:c+l,minY:p-l,maxY:p+l},size:d,calcSize:1/d,children:{data:null},maxWidth:0,level:0,childrenCount:4}};this._splitBranch(u.root);for(let s=0;s<o;s++)i=e[t[s]],i.options.mass>0&&this._placeInTree(u.root,i);return u}_updateBranchMass(e,t){let i=e.centerOfMass,o=e.mass+t.options.mass,s=1/o;i.x=i.x*e.mass+t.x*t.options.mass,i.x*=s,i.y=i.y*e.mass+t.y*t.options.mass,i.y*=s,e.mass=o;let n=Math.max(Math.max(t.height,t.radius),t.width);e.maxWidth=e.maxWidth<n?n:e.maxWidth}_placeInTree(e,t,i){1==i&&void 0!==i||this._updateBranchMass(e,t);let o,s=e.children.NW.range;o=s.maxX>t.x?s.maxY>t.y?"NW":"SW":s.maxY>t.y?"NE":"SE",this._placeInRegion(e,t,o)}_placeInRegion(e,t,i){let o=e.children[i];switch(o.childrenCount){case 0:o.children.data=t,o.childrenCount=1,this._updateBranchMass(o,t);break;case 1:o.children.data.x===t.x&&o.children.data.y===t.y?(t.x+=this._rng(),t.y+=this._rng()):(this._splitBranch(o),this._placeInTree(o,t));break;case 4:this._placeInTree(o,t)}}_splitBranch(e){let t=null;1===e.childrenCount&&(t=e.children.data,e.mass=0,e.centerOfMass.x=0,e.centerOfMass.y=0),e.childrenCount=4,e.children.data=null,this._insertRegion(e,"NW"),this._insertRegion(e,"NE"),this._insertRegion(e,"SW"),this._insertRegion(e,"SE"),null!=t&&this._placeInTree(e,t)}_insertRegion(e,t){let i,o,s,n,r=.5*e.size;switch(t){case"NW":i=e.range.minX,o=e.range.minX+r,s=e.range.minY,n=e.range.minY+r;break;case"NE":i=e.range.minX+r,o=e.range.maxX,s=e.range.minY,n=e.range.minY+r;break;case"SW":i=e.range.minX,o=e.range.minX+r,s=e.range.minY+r,n=e.range.maxY;break;case"SE":i=e.range.minX+r,o=e.range.maxX,s=e.range.minY+r,n=e.range.maxY}e.children[t]={centerOfMass:{x:0,y:0},mass:0,range:{minX:i,maxX:o,minY:s,maxY:n},size:.5*e.size,calcSize:2*e.calcSize,children:{data:null},maxWidth:0,level:e.level+1,childrenCount:0}}_debug(e,t){void 0!==this.barnesHutTree&&(e.lineWidth=1,this._drawBranch(this.barnesHutTree.root,e,t))}_drawBranch(e,t,i){void 0===i&&(i="#FF0000"),4===e.childrenCount&&(this._drawBranch(e.children.NW,t),this._drawBranch(e.children.NE,t),this._drawBranch(e.children.SE,t),this._drawBranch(e.children.SW,t)),t.strokeStyle=i,t.beginPath(),t.moveTo(e.range.minX,e.range.minY),t.lineTo(e.range.maxX,e.range.minY),t.stroke(),t.beginPath(),t.moveTo(e.range.maxX,e.range.minY),t.lineTo(e.range.maxX,e.range.maxY),t.stroke(),t.beginPath(),t.moveTo(e.range.maxX,e.range.maxY),t.lineTo(e.range.minX,e.range.maxY),t.stroke(),t.beginPath(),t.moveTo(e.range.minX,e.range.maxY),t.lineTo(e.range.minX,e.range.minY),t.stroke()}}class $e{constructor(e,t,o){this._rng=i.Alea("REPULSION SOLVER"),this.body=e,this.physicsBody=t,this.setOptions(o)}setOptions(e){this.options=e}solve(){var e,t,i,o,s,n,r,a,h=this.body.nodes,d=this.physicsBody.physicsNodeIndices,l=this.physicsBody.forces,c=this.options.nodeDistance,p=-2/3/c;for(let u=0;u<d.length-1;u++){r=h[d[u]];for(let g=u+1;g<d.length;g++)e=(a=h[d[g]]).x-r.x,t=a.y-r.y,0===(i=Math.sqrt(e*e+t*t))&&(e=i=.1*this._rng()),i<2*c&&(n=i<.5*c?1:p*i+4/3,o=e*(n/=i),s=t*n,l[r.id].x-=o,l[r.id].y-=s,l[a.id].x+=o,l[a.id].y+=s)}}}class Qe{constructor(e,t,i){this.body=e,this.physicsBody=t,this.setOptions(i)}setOptions(e){this.options=e,this.overlapAvoidanceFactor=Math.max(0,Math.min(1,this.options.avoidOverlap||0))}solve(){var e=this.body.nodes,t=this.physicsBody.physicsNodeIndices,i=this.physicsBody.forces,o=this.options.nodeDistance;for(let s=0;s<t.length-1;s++){const n=e[t[s]];for(let r=s+1;r<t.length;r++){const s=e[t[r]];if(n.level===s.level){const e=o+this.overlapAvoidanceFactor*((n.shape.radius||0)/2+(s.shape.radius||0)/2),t=s.x-n.x,r=s.y-n.y,a=Math.sqrt(t*t+r*r),h=.05;let d;d=a<e?-Math.pow(h*a,2)+Math.pow(h*e,2):0,0!==a&&(d/=a);const l=t*d,c=r*d;i[n.id].x-=l,i[n.id].y-=c,i[s.id].x+=l,i[s.id].y+=c}}}}}class et{constructor(e,t,i){this.body=e,this.physicsBody=t,this.setOptions(i)}setOptions(e){this.options=e}solve(){let e,t,i,o,s,n=this.physicsBody.physicsEdgeIndices,r=this.body.edges;for(let a=0;a<n.length;a++)t=r[n[a]],!0===t.connected&&t.toId!==t.fromId&&void 0!==this.body.nodes[t.toId]&&void 0!==this.body.nodes[t.fromId]&&(void 0!==t.edgeType.via?(e=void 0===t.options.length?this.options.springLength:t.options.length,i=t.to,o=t.edgeType.via,s=t.from,this._calculateSpringForce(i,o,.5*e),this._calculateSpringForce(o,s,.5*e)):(e=void 0===t.options.length?1.5*this.options.springLength:t.options.length,this._calculateSpringForce(t.from,t.to,e)))}_calculateSpringForce(e,t,i){let o=e.x-t.x,s=e.y-t.y,n=Math.max(Math.sqrt(o*o+s*s),.01),r=this.options.springConstant*(i-n)/n,a=o*r,h=s*r;void 0!==this.physicsBody.forces[e.id]&&(this.physicsBody.forces[e.id].x+=a,this.physicsBody.forces[e.id].y+=h),void 0!==this.physicsBody.forces[t.id]&&(this.physicsBody.forces[t.id].x-=a,this.physicsBody.forces[t.id].y-=h)}}class tt{constructor(e,t,i){this.body=e,this.physicsBody=t,this.setOptions(i)}setOptions(e){this.options=e}solve(){var e,t,i,o,s,n,r,a,h,d,l=this.body.edges,c=this.physicsBody.physicsEdgeIndices,p=this.physicsBody.physicsNodeIndices,u=this.physicsBody.forces;for(let e=0;e<p.length;e++){let t=p[e];u[t].springFx=0,u[t].springFy=0}for(let h=0;h<c.length;h++)!0===(t=l[c[h]]).connected&&(e=void 0===t.options.length?this.options.springLength:t.options.length,i=t.from.x-t.to.x,o=t.from.y-t.to.y,a=0===(a=Math.sqrt(i*i+o*o))?.01:a,s=i*(r=this.options.springConstant*(e-a)/a),n=o*r,t.to.level!=t.from.level?(void 0!==u[t.toId]&&(u[t.toId].springFx-=s,u[t.toId].springFy-=n),void 0!==u[t.fromId]&&(u[t.fromId].springFx+=s,u[t.fromId].springFy+=n)):(void 0!==u[t.toId]&&(u[t.toId].x-=.5*s,u[t.toId].y-=.5*n),void 0!==u[t.fromId]&&(u[t.fromId].x+=.5*s,u[t.fromId].y+=.5*n)));r=1;for(let e=0;e<p.length;e++){let t=p[e];h=Math.min(r,Math.max(-r,u[t].springFx)),d=Math.min(r,Math.max(-r,u[t].springFy)),u[t].x+=h,u[t].y+=d}var g=0,m=0;for(let e=0;e<p.length;e++){let t=p[e];g+=u[t].x,m+=u[t].y}var b=g/p.length,f=m/p.length;for(let e=0;e<p.length;e++){let t=p[e];u[t].x-=b,u[t].y-=f}}}class it{constructor(e,t,i){this.body=e,this.physicsBody=t,this.setOptions(i)}setOptions(e){this.options=e}solve(){let e,t,i,o,s=this.body.nodes,n=this.physicsBody.physicsNodeIndices,r=this.physicsBody.forces;for(let a=0;a<n.length;a++){o=s[n[a]],e=-o.x,t=-o.y,i=Math.sqrt(e*e+t*t),this._calculateForces(i,e,t,r,o)}}_calculateForces(e,t,i,o,s){let n=0===e?0:this.options.centralGravity/e;o[s.id].x=t*n,o[s.id].y=i*n}}class ot extends Je{constructor(e,t,o){super(e,t,o),this._rng=i.Alea("FORCE ATLAS 2 BASED REPULSION SOLVER")}_calculateForces(e,t,i,o,s){0===e&&(t=e=.1*this._rng()),this.overlapAvoidanceFactor<1&&o.shape.radius&&(e=Math.max(.1+this.overlapAvoidanceFactor*o.shape.radius,e-o.shape.radius));let n=o.edges.length+1,r=this.options.gravitationalConstant*s.mass*o.options.mass*n/Math.pow(e,2),a=t*r,h=i*r;this.physicsBody.forces[o.id].x+=a,this.physicsBody.forces[o.id].y+=h}}class st extends it{constructor(e,t,i){super(e,t,i)}_calculateForces(e,t,i,o,s){if(e>0){let e=s.edges.length+1,n=this.options.centralGravity*e*s.options.mass;o[s.id].x=t*n,o[s.id].y=i*n}}}class nt{constructor(e){this.body=e,this.physicsBody={physicsNodeIndices:[],physicsEdgeIndices:[],forces:{},velocities:{}},this.physicsEnabled=!0,this.simulationInterval=1e3/60,this.requiresTimeout=!0,this.previousStates={},this.referenceState={},this.freezeCache={},this.renderTimer=void 0,this.adaptiveTimestep=!1,this.adaptiveTimestepEnabled=!1,this.adaptiveCounter=0,this.adaptiveInterval=3,this.stabilized=!1,this.startedStabilization=!1,this.stabilizationIterations=0,this.ready=!1,this.options={},this.defaultOptions={enabled:!0,barnesHut:{theta:.5,gravitationalConstant:-2e3,centralGravity:.3,springLength:95,springConstant:.04,damping:.09,avoidOverlap:0},forceAtlas2Based:{theta:.5,gravitationalConstant:-50,centralGravity:.01,springConstant:.08,springLength:100,damping:.4,avoidOverlap:0},repulsion:{centralGravity:.2,springLength:200,springConstant:.05,nodeDistance:100,damping:.09,avoidOverlap:0},hierarchicalRepulsion:{centralGravity:0,springLength:100,springConstant:.01,nodeDistance:120,damping:.09},maxVelocity:50,minVelocity:.75,solver:"barnesHut",stabilization:{enabled:!0,iterations:1e3,updateInterval:50,onlyDynamicEdges:!1,fit:!0},timestep:.5,adaptiveTimestep:!0,wind:{x:0,y:0}},Object.assign(this.options,this.defaultOptions),this.timestep=.5,this.layoutFailed=!1,this.bindEventListeners()}bindEventListeners(){this.body.emitter.on("initPhysics",()=>{this.initPhysics()}),this.body.emitter.on("_layoutFailed",()=>{this.layoutFailed=!0}),this.body.emitter.on("resetPhysics",()=>{this.stopSimulation(),this.ready=!1}),this.body.emitter.on("disablePhysics",()=>{this.physicsEnabled=!1,this.stopSimulation()}),this.body.emitter.on("restorePhysics",()=>{this.setOptions(this.options),!0===this.ready&&this.startSimulation()}),this.body.emitter.on("startSimulation",()=>{!0===this.ready&&this.startSimulation()}),this.body.emitter.on("stopSimulation",()=>{this.stopSimulation()}),this.body.emitter.on("destroy",()=>{this.stopSimulation(!1),this.body.emitter.off()}),this.body.emitter.on("_dataChanged",()=>{this.updatePhysicsData()})}setOptions(e){if(void 0!==e)if(!1===e)this.options.enabled=!1,this.physicsEnabled=!1,this.stopSimulation();else if(!0===e)this.options.enabled=!0,this.physicsEnabled=!0,this.startSimulation();else{this.physicsEnabled=!0,i.selectiveNotDeepExtend(["stabilization"],this.options,e),i.mergeOptions(this.options,e,"stabilization"),void 0===e.enabled&&(this.options.enabled=!0),!1===this.options.enabled&&(this.physicsEnabled=!1,this.stopSimulation());const t=this.options.wind;t&&(("number"!=typeof t.x||Number.isNaN(t.x))&&(t.x=0),("number"!=typeof t.y||Number.isNaN(t.y))&&(t.y=0)),this.timestep=this.options.timestep}this.init()}init(){var e;"forceAtlas2Based"===this.options.solver?(e=this.options.forceAtlas2Based,this.nodesSolver=new ot(this.body,this.physicsBody,e),this.edgesSolver=new et(this.body,this.physicsBody,e),this.gravitySolver=new st(this.body,this.physicsBody,e)):"repulsion"===this.options.solver?(e=this.options.repulsion,this.nodesSolver=new $e(this.body,this.physicsBody,e),this.edgesSolver=new et(this.body,this.physicsBody,e),this.gravitySolver=new it(this.body,this.physicsBody,e)):"hierarchicalRepulsion"===this.options.solver?(e=this.options.hierarchicalRepulsion,this.nodesSolver=new Qe(this.body,this.physicsBody,e),this.edgesSolver=new tt(this.body,this.physicsBody,e),this.gravitySolver=new it(this.body,this.physicsBody,e)):(e=this.options.barnesHut,this.nodesSolver=new Je(this.body,this.physicsBody,e),this.edgesSolver=new et(this.body,this.physicsBody,e),this.gravitySolver=new it(this.body,this.physicsBody,e)),this.modelOptions=e}initPhysics(){!0===this.physicsEnabled&&!0===this.options.enabled?!0===this.options.stabilization.enabled?this.stabilize():(this.stabilized=!1,this.ready=!0,this.body.emitter.emit("fit",{},this.layoutFailed),this.startSimulation()):(this.ready=!0,this.body.emitter.emit("fit"))}startSimulation(){!0===this.physicsEnabled&&!0===this.options.enabled?(this.stabilized=!1,this.adaptiveTimestep=!1,this.body.emitter.emit("_resizeNodes"),void 0===this.viewFunction&&(this.viewFunction=this.simulationStep.bind(this),this.body.emitter.on("initRedraw",this.viewFunction),this.body.emitter.emit("_startRendering"))):this.body.emitter.emit("_redraw")}stopSimulation(e=!0){this.stabilized=!0,!0===e&&this._emitStabilized(),void 0!==this.viewFunction&&(this.body.emitter.off("initRedraw",this.viewFunction),this.viewFunction=void 0,!0===e&&this.body.emitter.emit("_stopRendering"))}simulationStep(){var e=Date.now();this.physicsTick(),(Date.now()-e<.4*this.simulationInterval||!0===this.runDoubleSpeed)&&!1===this.stabilized&&(this.physicsTick(),this.runDoubleSpeed=!0),!0===this.stabilized&&this.stopSimulation()}_emitStabilized(e=this.stabilizationIterations){(this.stabilizationIterations>1||!0===this.startedStabilization)&&setTimeout(()=>{this.body.emitter.emit("stabilized",{iterations:e}),this.startedStabilization=!1,this.stabilizationIterations=0},0)}physicsStep(){this.gravitySolver.solve(),this.nodesSolver.solve(),this.edgesSolver.solve(),this.moveNodes()}adjustTimeStep(){!0===this._evaluateStepQuality()?this.timestep=1.2*this.timestep:this.timestep/1.2<this.options.timestep?this.timestep=this.options.timestep:(this.adaptiveCounter=-1,this.timestep=Math.max(this.options.timestep,this.timestep/1.2))}physicsTick(){if(this._startStabilizing(),!0!==this.stabilized){if(!0===this.adaptiveTimestep&&!0===this.adaptiveTimestepEnabled){this.adaptiveCounter%this.adaptiveInterval==0?(this.timestep=2*this.timestep,this.physicsStep(),this.revert(),this.timestep=.5*this.timestep,this.physicsStep(),this.physicsStep(),this.adjustTimeStep()):this.physicsStep(),this.adaptiveCounter+=1}else this.timestep=this.options.timestep,this.physicsStep();!0===this.stabilized&&this.revert(),this.stabilizationIterations++}}updatePhysicsData(){this.physicsBody.forces={},this.physicsBody.physicsNodeIndices=[],this.physicsBody.physicsEdgeIndices=[];let e=this.body.nodes,t=this.body.edges;for(let t in e)e.hasOwnProperty(t)&&!0===e[t].options.physics&&this.physicsBody.physicsNodeIndices.push(e[t].id);for(let e in t)t.hasOwnProperty(e)&&!0===t[e].options.physics&&this.physicsBody.physicsEdgeIndices.push(t[e].id);for(let e=0;e<this.physicsBody.physicsNodeIndices.length;e++){let t=this.physicsBody.physicsNodeIndices[e];this.physicsBody.forces[t]={x:0,y:0},void 0===this.physicsBody.velocities[t]&&(this.physicsBody.velocities[t]={x:0,y:0})}for(let t in this.physicsBody.velocities)void 0===e[t]&&delete this.physicsBody.velocities[t]}revert(){var e=Object.keys(this.previousStates),t=this.body.nodes,i=this.physicsBody.velocities;this.referenceState={};for(let o=0;o<e.length;o++){let s=e[o];void 0!==t[s]?!0===t[s].options.physics&&(this.referenceState[s]={positions:{x:t[s].x,y:t[s].y}},i[s].x=this.previousStates[s].vx,i[s].y=this.previousStates[s].vy,t[s].x=this.previousStates[s].x,t[s].y=this.previousStates[s].y):delete this.previousStates[s]}}_evaluateStepQuality(){let e,t,i,o=this.body.nodes,s=this.referenceState;for(let n in this.referenceState)if(this.referenceState.hasOwnProperty(n)&&void 0!==o[n]&&(e=o[n].x-s[n].positions.x,t=o[n].y-s[n].positions.y,i=Math.sqrt(Math.pow(e,2)+Math.pow(t,2)),i>.3))return!1;return!0}moveNodes(){var e=this.physicsBody.physicsNodeIndices,t=0,i=0;for(let o=0;o<e.length;o++){let s=e[o],n=this._performStep(s);t=Math.max(t,n),i+=n}this.adaptiveTimestepEnabled=i/e.length<5,this.stabilized=t<this.options.minVelocity}calculateComponentVelocity(e,t,i){e+=(t-this.modelOptions.damping*e)/i*this.timestep;let o=this.options.maxVelocity||1e9;return Math.abs(e)>o&&(e=e>0?o:-o),e}_performStep(e){let t=this.body.nodes[e],i=this.physicsBody.forces[e];this.options.wind&&(i.x+=this.options.wind.x,i.y+=this.options.wind.y);let o=this.physicsBody.velocities[e];return this.previousStates[e]={x:t.x,y:t.y,vx:o.x,vy:o.y},!1===t.options.fixed.x?(o.x=this.calculateComponentVelocity(o.x,i.x,t.options.mass),t.x+=o.x*this.timestep):(i.x=0,o.x=0),!1===t.options.fixed.y?(o.y=this.calculateComponentVelocity(o.y,i.y,t.options.mass),t.y+=o.y*this.timestep):(i.y=0,o.y=0),Math.sqrt(Math.pow(o.x,2)+Math.pow(o.y,2))}_freezeNodes(){var e=this.body.nodes;for(var t in e)if(e.hasOwnProperty(t)&&e[t].x&&e[t].y){let i=e[t].options.fixed;this.freezeCache[t]={x:i.x,y:i.y},i.x=!0,i.y=!0}}_restoreFrozenNodes(){var e=this.body.nodes;for(var t in e)e.hasOwnProperty(t)&&void 0!==this.freezeCache[t]&&(e[t].options.fixed.x=this.freezeCache[t].x,e[t].options.fixed.y=this.freezeCache[t].y);this.freezeCache={}}stabilize(e=this.options.stabilization.iterations){"number"!=typeof e&&(e=this.options.stabilization.iterations,console.log("The stabilize method needs a numeric amount of iterations. Switching to default: ",e)),0!==this.physicsBody.physicsNodeIndices.length?(this.adaptiveTimestep=this.options.adaptiveTimestep,this.body.emitter.emit("_resizeNodes"),this.stopSimulation(),this.stabilized=!1,this.body.emitter.emit("_blockRedraw"),this.targetIterations=e,!0===this.options.stabilization.onlyDynamicEdges&&this._freezeNodes(),this.stabilizationIterations=0,setTimeout(()=>this._stabilizationBatch(),0)):this.ready=!0}_startStabilizing(){return!0!==this.startedStabilization&&(this.body.emitter.emit("startStabilizing"),this.startedStabilization=!0,!0)}_stabilizationBatch(){var e=()=>!1===this.stabilized&&this.stabilizationIterations<this.targetIterations,t=()=>{this.body.emitter.emit("stabilizationProgress",{iterations:this.stabilizationIterations,total:this.targetIterations})};this._startStabilizing()&&t();for(var i=0;e()&&i<this.options.stabilization.updateInterval;)this.physicsTick(),i++;t(),e()?setTimeout(this._stabilizationBatch.bind(this),0):this._finalizeStabilization()}_finalizeStabilization(){this.body.emitter.emit("_allowRedraw"),!0===this.options.stabilization.fit&&this.body.emitter.emit("fit"),!0===this.options.stabilization.onlyDynamicEdges&&this._restoreFrozenNodes(),this.body.emitter.emit("stabilizationIterationsDone"),this.body.emitter.emit("_requestRedraw"),!0===this.stabilized?this._emitStabilized():this.startSimulation(),this.ready=!0}_drawForces(e){for(var t=0;t<this.physicsBody.physicsNodeIndices.length;t++){let o=this.physicsBody.physicsNodeIndices[t],s=this.body.nodes[o],n=this.physicsBody.forces[o],r=20,a=.03,h=Math.sqrt(Math.pow(n.x,2)+Math.pow(n.x,2)),d=Math.min(Math.max(5,h),15),l=3*d,c=i.HSVToHex((180-180*Math.min(1,Math.max(0,a*h)))/360,1,1),p={x:s.x+r*n.x,y:s.y+r*n.y};e.lineWidth=d,e.strokeStyle=c,e.beginPath(),e.moveTo(s.x,s.y),e.lineTo(p.x,p.y),e.stroke();let u=Math.atan2(n.y,n.x);e.fillStyle=c,Le.draw(e,{type:"arrow",point:p,angle:u,length:l}),e.fill()}}}class rt{constructor(){}static getRange(e,t=[]){var i,o=1e9,s=-1e9,n=1e9,r=-1e9;if(t.length>0)for(var a=0;a<t.length;a++)n>(i=e[t[a]]).shape.boundingBox.left&&(n=i.shape.boundingBox.left),r<i.shape.boundingBox.right&&(r=i.shape.boundingBox.right),o>i.shape.boundingBox.top&&(o=i.shape.boundingBox.top),s<i.shape.boundingBox.bottom&&(s=i.shape.boundingBox.bottom);return 1e9===n&&-1e9===r&&1e9===o&&-1e9===s&&(o=0,s=0,n=0,r=0),{minX:n,maxX:r,minY:o,maxY:s}}static getRangeCore(e,t=[]){var i,o=1e9,s=-1e9,n=1e9,r=-1e9;if(t.length>0)for(var a=0;a<t.length;a++)n>(i=e[t[a]]).x&&(n=i.x),r<i.x&&(r=i.x),o>i.y&&(o=i.y),s<i.y&&(s=i.y);return 1e9===n&&-1e9===r&&1e9===o&&-1e9===s&&(o=0,s=0,n=0,r=0),{minX:n,maxX:r,minY:o,maxY:s}}static findCenter(e){return{x:.5*(e.maxX+e.minX),y:.5*(e.maxY+e.minY)}}static cloneOptions(e,t){let o={};return void 0===t||"node"===t?(i.deepExtend(o,e.options,!0),o.x=e.x,o.y=e.y,o.amountOfConnections=e.edges.length):i.deepExtend(o,e.options,!0),o}}class at extends Ne{constructor(e,t,i,o,s,n){super(e,t,i,o,s,n),this.isCluster=!0,this.containedNodes={},this.containedEdges={}}_openChildCluster(e){let t=this.body.nodes[e];if(void 0===this.containedNodes[e])throw new Error("node with id: "+e+" not in current cluster");if(!t.isCluster)throw new Error("node with id: "+e+" is not a cluster");delete this.containedNodes[e],i.forEach(t.edges,e=>{delete this.containedEdges[e.id]}),i.forEach(t.containedNodes,(e,t)=>{this.containedNodes[t]=e}),t.containedNodes={},i.forEach(t.containedEdges,(e,t)=>{this.containedEdges[t]=e}),t.containedEdges={},i.forEach(t.edges,e=>{i.forEach(this.edges,t=>{let o=t.clusteringEdgeReplacingIds.indexOf(e.id);-1!==o&&(i.forEach(e.clusteringEdgeReplacingIds,e=>{t.clusteringEdgeReplacingIds.push(e),this.body.edges[e].edgeReplacedById=t.id}),t.clusteringEdgeReplacingIds.splice(o,1))})}),t.edges=[]}}class ht{constructor(e){this.body=e,this.clusteredNodes={},this.clusteredEdges={},this.options={},this.defaultOptions={},Object.assign(this.options,this.defaultOptions),this.body.emitter.on("_resetData",()=>{this.clusteredNodes={},this.clusteredEdges={}})}clusterByHubsize(e,t){void 0===e?e=this._getHubSize():"object"==typeof e&&(t=this._checkOptions(e),e=this._getHubSize());let i=[];for(let t=0;t<this.body.nodeIndices.length;t++){let o=this.body.nodes[this.body.nodeIndices[t]];o.edges.length>=e&&i.push(o.id)}for(let e=0;e<i.length;e++)this.clusterByConnection(i[e],t,!0);this.body.emitter.emit("_dataChanged")}cluster(e={},t=!0){if(void 0===e.joinCondition)throw new Error("Cannot call clusterByNodeData without a joinCondition function in the options.");e=this._checkOptions(e);let o={},s={};i.forEach(this.body.nodes,(t,n)=>{t.options&&!0===e.joinCondition(t.options)&&(o[n]=t,i.forEach(t.edges,e=>{void 0===this.clusteredEdges[e.id]&&(s[e.id]=e)}))}),this._cluster(o,s,e,t)}clusterByEdgeCount(e,t,i=!0){t=this._checkOptions(t);let o,s,n,r=[],a={};for(let i=0;i<this.body.nodeIndices.length;i++){let l={},c={},p=this.body.nodeIndices[i],u=this.body.nodes[p];if(void 0===a[p]){n=0,s=[];for(let e=0;e<u.edges.length;e++)o=u.edges[e],void 0===this.clusteredEdges[o.id]&&(o.toId!==o.fromId&&n++,s.push(o));if(n===e){var h=function(e){if(void 0===t.joinCondition||null===t.joinCondition)return!0;let i=rt.cloneOptions(e);return t.joinCondition(i)};let e=!0;for(let t=0;t<s.length;t++){o=s[t];let i=this._getConnectedId(o,p);if(!h(u)){e=!1;break}c[o.id]=o,l[p]=u,l[i]=this.body.nodes[i],a[p]=!0}if(Object.keys(l).length>0&&Object.keys(c).length>0&&!0===e){var d=function(){for(let t=0;t<r.length;++t)for(var e in l)if(void 0!==r[t].nodes[e])return r[t]}();if(void 0!==d){for(let e in l)void 0===d.nodes[e]&&(d.nodes[e]=l[e]);for(let e in c)void 0===d.edges[e]&&(d.edges[e]=c[e])}else r.push({nodes:l,edges:c})}}}}for(let e=0;e<r.length;e++)this._cluster(r[e].nodes,r[e].edges,t,!1);!0===i&&this.body.emitter.emit("_dataChanged")}clusterOutliers(e,t=!0){this.clusterByEdgeCount(1,e,t)}clusterBridges(e,t=!0){this.clusterByEdgeCount(2,e,t)}clusterByConnection(e,t,i=!0){if(void 0===e)throw new Error("No nodeId supplied to clusterByConnection!");if(void 0===this.body.nodes[e])throw new Error("The nodeId given to clusterByConnection does not exist!");let o=this.body.nodes[e];void 0===(t=this._checkOptions(t,o)).clusterNodeProperties.x&&(t.clusterNodeProperties.x=o.x),void 0===t.clusterNodeProperties.y&&(t.clusterNodeProperties.y=o.y),void 0===t.clusterNodeProperties.fixed&&(t.clusterNodeProperties.fixed={},t.clusterNodeProperties.fixed.x=o.options.fixed.x,t.clusterNodeProperties.fixed.y=o.options.fixed.y);let s={},n={},r=o.id,a=rt.cloneOptions(o);s[r]=o;for(let e=0;e<o.edges.length;e++){let i=o.edges[e];if(void 0===this.clusteredEdges[i.id]){let e=this._getConnectedId(i,r);if(void 0===this.clusteredNodes[e])if(e!==r)if(void 0===t.joinCondition)n[i.id]=i,s[e]=this.body.nodes[e];else{let o=rt.cloneOptions(this.body.nodes[e]);!0===t.joinCondition(a,o)&&(n[i.id]=i,s[e]=this.body.nodes[e])}else n[i.id]=i}}var h=Object.keys(s).map((function(e){return s[e].id}));for(d in s)if(s.hasOwnProperty(d))for(var d=s[d],l=0;l<d.edges.length;l++){var c=d.edges[l];h.indexOf(this._getConnectedId(c,d.id))>-1&&(n[c.id]=c)}this._cluster(s,n,t,i)}_createClusterEdges(e,t,i,o){let s,n,r,a,h,d,l=Object.keys(e),c=[];for(let o=0;o<l.length;o++){n=l[o],r=e[n];for(let o=0;o<r.edges.length;o++)s=r.edges[o],void 0===this.clusteredEdges[s.id]&&(s.toId==s.fromId?t[s.id]=s:s.toId==n?(a=i.id,h=s.fromId,d=h):(a=s.toId,h=i.id,d=a),void 0===e[d]&&c.push({edge:s,fromId:h,toId:a}))}var p=[],u=function(e){for(let t=0;t<p.length;t++){let i=p[t],o=e.fromId===i.fromId&&e.toId===i.toId,s=e.fromId===i.toId&&e.toId===i.fromId;if(o||s)return i}return null};for(let e=0;e<c.length;e++){let t=c[e],i=t.edge,s=u(t);null===s?(s=this._createClusteredEdge(t.fromId,t.toId,i,o),p.push(s)):s.clusteringEdgeReplacingIds.push(i.id),this.body.edges[i.id].edgeReplacedById=s.id,this._backupEdgeOptions(i),i.setOptions({physics:!1})}}_checkOptions(e={}){return void 0===e.clusterEdgeProperties&&(e.clusterEdgeProperties={}),void 0===e.clusterNodeProperties&&(e.clusterNodeProperties={}),e}_cluster(e,t,o,s=!0){var n=[];for(let t in e)e.hasOwnProperty(t)&&void 0!==this.clusteredNodes[t]&&n.push(t);for(var a=0;a<n.length;++a)delete e[n[a]];if(0==Object.keys(e).length)return;if(1==Object.keys(e).length&&1!=o.clusterNodeProperties.allowSingleNodeCluster)return;let h=i.deepExtend({},o.clusterNodeProperties);if(void 0!==o.processProperties){let i=[];for(let t in e)if(e.hasOwnProperty(t)){let o=rt.cloneOptions(e[t]);i.push(o)}let s=[];for(let e in t)if(t.hasOwnProperty(e)&&"clusterEdge:"!==e.substr(0,12)){let i=rt.cloneOptions(t[e],"edge");s.push(i)}if(h=o.processProperties(h,i,s),!h)throw new Error("The processProperties function does not return properties!")}void 0===h.id&&(h.id="cluster:"+r.v4());let d=h.id;void 0===h.label&&(h.label="cluster");let l=void 0;void 0===h.x&&(l=this._getClusterPosition(e),h.x=l.x),void 0===h.y&&(void 0===l&&(l=this._getClusterPosition(e)),h.y=l.y),h.id=d;let c=this.body.functions.createNode(h,at);c.containedNodes=e,c.containedEdges=t,c.clusterEdgeProperties=o.clusterEdgeProperties,this.body.nodes[h.id]=c,this._clusterEdges(e,t,h,o.clusterEdgeProperties),h.id=void 0,!0===s&&this.body.emitter.emit("_dataChanged")}_backupEdgeOptions(e){void 0===this.clusteredEdges[e.id]&&(this.clusteredEdges[e.id]={physics:e.options.physics})}_restoreEdge(e){let t=this.clusteredEdges[e.id];void 0!==t&&(e.setOptions({physics:t.physics}),delete this.clusteredEdges[e.id])}isCluster(e){return void 0!==this.body.nodes[e]?!0===this.body.nodes[e].isCluster:(console.log("Node does not exist."),!1)}_getClusterPosition(e){let t,i=Object.keys(e),o=e[i[0]].x,s=e[i[0]].x,n=e[i[0]].y,r=e[i[0]].y;for(let a=1;a<i.length;a++)t=e[i[a]],o=t.x<o?t.x:o,s=t.x>s?t.x:s,n=t.y<n?t.y:n,r=t.y>r?t.y:r;return{x:.5*(o+s),y:.5*(n+r)}}openCluster(e,t,o=!0){if(void 0===e)throw new Error("No clusterNodeId supplied to openCluster.");let s=this.body.nodes[e];if(void 0===s)throw new Error("The clusterNodeId supplied to openCluster does not exist.");if(!0!==s.isCluster||void 0===s.containedNodes||void 0===s.containedEdges)throw new Error("The node:"+e+" is not a valid cluster.");let n=this.findNode(e),r=n.indexOf(e)-1;if(r>=0){let t=n[r];return this.body.nodes[t]._openChildCluster(e),delete this.body.nodes[e],void(!0===o&&this.body.emitter.emit("_dataChanged"))}let a=s.containedNodes,h=s.containedEdges;if(void 0!==t&&void 0!==t.releaseFunction&&"function"==typeof t.releaseFunction){let e={},i={x:s.x,y:s.y};for(let t in a)if(a.hasOwnProperty(t)){let i=this.body.nodes[t];e[t]={x:i.x,y:i.y}}let o=t.releaseFunction(i,e);for(let e in a)if(a.hasOwnProperty(e)){let t=this.body.nodes[e];void 0!==o[e]&&(t.x=void 0===o[e].x?s.x:o[e].x,t.y=void 0===o[e].y?s.y:o[e].y)}}else i.forEach(a,(function(e){!1===e.options.fixed.x&&(e.x=s.x),!1===e.options.fixed.y&&(e.y=s.y)}));for(let e in a)if(a.hasOwnProperty(e)){let t=this.body.nodes[e];t.vx=s.vx,t.vy=s.vy,t.setOptions({physics:!0}),delete this.clusteredNodes[e]}let d=[];for(let e=0;e<s.edges.length;e++)d.push(s.edges[e]);for(let t=0;t<d.length;t++){let i=d[t],o=this._getConnectedId(i,e),s=this.clusteredNodes[o];for(let e=0;e<i.clusteringEdgeReplacingIds.length;e++){let t=i.clusteringEdgeReplacingIds[e],n=this.body.edges[t];if(void 0!==n)if(void 0!==s){let e=this.body.nodes[s.clusterId];e.containedEdges[n.id]=n,delete h[n.id];let t=n.fromId,i=n.toId;n.toId==o?i=s.clusterId:t=s.clusterId,this._createClusteredEdge(t,i,n,e.clusterEdgeProperties,{hidden:!1,physics:!0})}else this._restoreEdge(n)}i.remove()}for(let e in h)h.hasOwnProperty(e)&&this._restoreEdge(h[e]);delete this.body.nodes[e],!0===o&&this.body.emitter.emit("_dataChanged")}getNodesInCluster(e){let t=[];if(!0===this.isCluster(e)){let i=this.body.nodes[e].containedNodes;for(let e in i)i.hasOwnProperty(e)&&t.push(this.body.nodes[e].id)}return t}findNode(e){let t,i=[],o=0;for(;void 0!==this.clusteredNodes[e]&&o<100;){if(t=this.body.nodes[e],void 0===t)return[];i.push(t.id),e=this.clusteredNodes[e].clusterId,o++}return t=this.body.nodes[e],void 0===t?[]:(i.push(t.id),i.reverse(),i)}updateClusteredNode(e,t){if(void 0===e)throw new Error("No clusteredNodeId supplied to updateClusteredNode.");if(void 0===t)throw new Error("No newOptions supplied to updateClusteredNode.");if(void 0===this.body.nodes[e])throw new Error("The clusteredNodeId supplied to updateClusteredNode does not exist.");this.body.nodes[e].setOptions(t),this.body.emitter.emit("_dataChanged")}updateEdge(e,t){if(void 0===e)throw new Error("No startEdgeId supplied to updateEdge.");if(void 0===t)throw new Error("No newOptions supplied to updateEdge.");if(void 0===this.body.edges[e])throw new Error("The startEdgeId supplied to updateEdge does not exist.");let i=this.getClusteredEdges(e);for(let e=0;e<i.length;e++){this.body.edges[i[e]].setOptions(t)}this.body.emitter.emit("_dataChanged")}getClusteredEdges(e){let t=[],i=0;for(;void 0!==e&&void 0!==this.body.edges[e]&&i<100;)t.push(this.body.edges[e].id),e=this.body.edges[e].edgeReplacedById,i++;return t.reverse(),t}getBaseEdge(e){return this.getBaseEdges(e)[0]}getBaseEdges(e){let t=[e],i=[],o=[],s=0;for(;t.length>0&&s<100;){let e=t.pop();if(void 0===e)continue;let n=this.body.edges[e];if(void 0===n)continue;s++;let r=n.clusteringEdgeReplacingIds;if(void 0===r)o.push(e);else for(let e=0;e<r.length;++e){let o=r[e];-1===t.indexOf(r)&&-1===i.indexOf(r)&&t.push(o)}i.push(e)}return o}_getConnectedId(e,t){return e.toId!=t?e.toId:(e.fromId,e.fromId)}_getHubSize(){let e=0,t=0,i=0,o=0;for(let s=0;s<this.body.nodeIndices.length;s++){let n=this.body.nodes[this.body.nodeIndices[s]];n.edges.length>o&&(o=n.edges.length),e+=n.edges.length,t+=Math.pow(n.edges.length,2),i+=1}e/=i,t/=i;let s=t-Math.pow(e,2),n=Math.sqrt(s),r=Math.floor(e+2*n);return r>o&&(r=o),r}_createClusteredEdge(e,t,o,s,n){let a=rt.cloneOptions(o,"edge");i.deepExtend(a,s),a.from=e,a.to=t,a.id="clusterEdge:"+r.v4(),void 0!==n&&i.deepExtend(a,n);let h=this.body.functions.createEdge(a);return h.clusteringEdgeReplacingIds=[o.id],h.connect(),this.body.edges[h.id]=h,h}_clusterEdges(e,t,i,o){if(t instanceof Ke){let e=t,i={};i[e.id]=e,t=i}if(e instanceof Ne){let t=e,i={};i[t.id]=t,e=i}if(null==i)throw new Error("_clusterEdges: parameter clusterNode required");void 0===o&&(o=i.clusterEdgeProperties),this._createClusterEdges(e,t,i,o);for(let e in t)if(t.hasOwnProperty(e)&&void 0!==this.body.edges[e]){let t=this.body.edges[e];this._backupEdgeOptions(t),t.setOptions({physics:!1})}for(let t in e)e.hasOwnProperty(t)&&(this.clusteredNodes[t]={clusterId:i.id,node:this.body.nodes[t]},this.body.nodes[t].setOptions({physics:!1}))}_getClusterNodeForNode(e){if(void 0===e)return;let t=this.clusteredNodes[e];if(void 0===t)return;let i=t.clusterId;return void 0!==i?this.body.nodes[i]:void 0}_filter(e,t){let o=[];return i.forEach(e,e=>{t(e)&&o.push(e)}),o}_updateState(){let e,t=[],o={},s=e=>{i.forEach(this.body.nodes,t=>{!0===t.isCluster&&e(t)})};for(e in this.clusteredNodes){if(!this.clusteredNodes.hasOwnProperty(e))continue;void 0===this.body.nodes[e]&&t.push(e)}s((function(e){for(let i=0;i<t.length;i++)delete e.containedNodes[t[i]]}));for(let e=0;e<t.length;e++)delete this.clusteredNodes[t[e]];i.forEach(this.clusteredEdges,e=>{let t=this.body.edges[e];void 0!==t&&t.endPointsValid()||(o[e]=e)}),s((function(e){i.forEach(e.containedEdges,(e,t)=>{e.endPointsValid()||o[t]||(o[t]=t)})})),i.forEach(this.body.edges,(e,t)=>{let s=!0,n=e.clusteringEdgeReplacingIds;if(void 0!==n){let e=0;i.forEach(n,t=>{let i=this.body.edges[t];void 0!==i&&i.endPointsValid()&&(e+=1)}),s=e>0}e.endPointsValid()&&s||(o[t]=t)}),s(e=>{i.forEach(o,t=>{delete e.containedEdges[t],i.forEach(e.edges,(i,s)=>{i.id!==t?i.clusteringEdgeReplacingIds=this._filter(i.clusteringEdgeReplacingIds,(function(e){return!o[e]})):e.edges[s]=null}),e.edges=this._filter(e.edges,(function(e){return null!==e}))})}),i.forEach(o,e=>{delete this.clusteredEdges[e]}),i.forEach(o,e=>{delete this.body.edges[e]});let n=Object.keys(this.body.edges);i.forEach(n,e=>{let t=this.body.edges[e],i=this._isClusteredNode(t.fromId)||this._isClusteredNode(t.toId);if(i!==this._isClusteredEdge(t.id))if(i){let e=this._getClusterNodeForNode(t.fromId);void 0!==e&&this._clusterEdges(this.body.nodes[t.fromId],t,e);let i=this._getClusterNodeForNode(t.toId);void 0!==i&&this._clusterEdges(this.body.nodes[t.toId],t,i)}else delete this._clusterEdges[e],this._restoreEdge(t)});for(var r=!1,a=!0;a;){let e=[];s((function(t){let i=Object.keys(t.containedNodes).length,o=!0===t.options.allowSingleNodeCluster;(o&&i<1||!o&&i<2)&&e.push(t.id)}));for(let t=0;t<e.length;++t)this.openCluster(e[t],{},!1);a=e.length>0,r=r||a}r&&this._updateState()}_isClusteredNode(e){return void 0!==this.clusteredNodes[e]}_isClusteredEdge(e){return void 0!==this.clusteredEdges[e]}}class dt{constructor(e,t){var i;void 0!==window&&(i=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame),window.requestAnimationFrame=void 0===i?function(e){e()}:i,this.body=e,this.canvas=t,this.redrawRequested=!1,this.renderTimer=void 0,this.requiresTimeout=!0,this.renderingActive=!1,this.renderRequests=0,this.allowRedraw=!0,this.dragging=!1,this.zooming=!1,this.options={},this.defaultOptions={hideEdgesOnDrag:!1,hideEdgesOnZoom:!1,hideNodesOnDrag:!1},Object.assign(this.options,this.defaultOptions),this._determineBrowserMethod(),this.bindEventListeners()}bindEventListeners(){this.body.emitter.on("dragStart",()=>{this.dragging=!0}),this.body.emitter.on("dragEnd",()=>{this.dragging=!1}),this.body.emitter.on("zoom",()=>{this.zooming=!0,window.clearTimeout(this.zoomTimeoutId),this.zoomTimeoutId=window.setTimeout(()=>{this.zooming=!1,this._requestRedraw.bind(this)()},250)}),this.body.emitter.on("_resizeNodes",()=>{this._resizeNodes()}),this.body.emitter.on("_redraw",()=>{!1===this.renderingActive&&this._redraw()}),this.body.emitter.on("_blockRedraw",()=>{this.allowRedraw=!1}),this.body.emitter.on("_allowRedraw",()=>{this.allowRedraw=!0,this.redrawRequested=!1}),this.body.emitter.on("_requestRedraw",this._requestRedraw.bind(this)),this.body.emitter.on("_startRendering",()=>{this.renderRequests+=1,this.renderingActive=!0,this._startRendering()}),this.body.emitter.on("_stopRendering",()=>{this.renderRequests-=1,this.renderingActive=this.renderRequests>0,this.renderTimer=void 0}),this.body.emitter.on("destroy",()=>{this.renderRequests=0,this.allowRedraw=!1,this.renderingActive=!1,!0===this.requiresTimeout?clearTimeout(this.renderTimer):window.cancelAnimationFrame(this.renderTimer),this.body.emitter.off()})}setOptions(e){if(void 0!==e){let t=["hideEdgesOnDrag","hideEdgesOnZoom","hideNodesOnDrag"];i.selectiveDeepExtend(t,this.options,e)}}_requestNextFrame(e,t){if("undefined"==typeof window)return;let i;var o=window;return!0===this.requiresTimeout?i=o.setTimeout(e,t):o.requestAnimationFrame&&(i=o.requestAnimationFrame(e)),i}_startRendering(){!0===this.renderingActive&&void 0===this.renderTimer&&(this.renderTimer=this._requestNextFrame(this._renderStep.bind(this),this.simulationInterval))}_renderStep(){!0===this.renderingActive&&(this.renderTimer=void 0,!0===this.requiresTimeout&&this._startRendering(),this._redraw(),!1===this.requiresTimeout&&this._startRendering())}redraw(){this.body.emitter.emit("setSize"),this._redraw()}_requestRedraw(){!0!==this.redrawRequested&&!1===this.renderingActive&&!0===this.allowRedraw&&(this.redrawRequested=!0,this._requestNextFrame(()=>{this._redraw(!1)},0))}_redraw(e=!1){if(!0===this.allowRedraw){this.body.emitter.emit("initRedraw"),this.redrawRequested=!1,0!==this.canvas.frame.canvas.width&&0!==this.canvas.frame.canvas.height||this.canvas.setSize(),this.canvas.setTransform();let t=this.canvas.getContext(),i=this.canvas.frame.canvas.clientWidth,o=this.canvas.frame.canvas.clientHeight;if(t.clearRect(0,0,i,o),0===this.canvas.frame.clientWidth)return;t.save(),t.translate(this.body.view.translation.x,this.body.view.translation.y),t.scale(this.body.view.scale,this.body.view.scale),t.beginPath(),this.body.emitter.emit("beforeDrawing",t),t.closePath(),!1===e&&(!1===this.dragging||!0===this.dragging&&!1===this.options.hideEdgesOnDrag)&&(!1===this.zooming||!0===this.zooming&&!1===this.options.hideEdgesOnZoom)&&this._drawEdges(t),(!1===this.dragging||!0===this.dragging&&!1===this.options.hideNodesOnDrag)&&this._drawNodes(t,e),!1===e&&(!1===this.dragging||!0===this.dragging&&!1===this.options.hideEdgesOnDrag)&&(!1===this.zooming||!0===this.zooming&&!1===this.options.hideEdgesOnZoom)&&this._drawArrows(t),!1===e&&this._drawSelectionBox(t),t.beginPath(),this.body.emitter.emit("afterDrawing",t),t.closePath(),t.restore(),!0===e&&t.clearRect(0,0,i,o)}}_resizeNodes(){this.canvas.setTransform();let e=this.canvas.getContext();e.save(),e.translate(this.body.view.translation.x,this.body.view.translation.y),e.scale(this.body.view.scale,this.body.view.scale);let t,i=this.body.nodes;for(let o in i)i.hasOwnProperty(o)&&(t=i[o],t.resize(e),t.updateBoundingBox(e,t.selected));e.restore()}_drawNodes(e,t=!1){let i,o,s=this.body.nodes,n=this.body.nodeIndices,r=[],a=[],h=this.canvas.DOMtoCanvas({x:-20,y:-20}),d=this.canvas.DOMtoCanvas({x:this.canvas.frame.canvas.clientWidth+20,y:this.canvas.frame.canvas.clientHeight+20}),l={top:h.y,left:h.x,bottom:d.y,right:d.x};for(let o=0;o<n.length;o++)i=s[n[o]],i.hover?a.push(n[o]):i.isSelected()?r.push(n[o]):!0===t||!0===i.isBoundingBoxOverlappingWith(l)?i.draw(e):i.updateBoundingBox(e,i.selected);const c=r.length,p=a.length;for(o=0;o<c;o++)i=s[r[o]],i.draw(e);for(o=0;o<p;o++)i=s[a[o]],i.draw(e)}_drawEdges(e){let t=this.body.edges,i=this.body.edgeIndices;for(let o=0;o<i.length;o++){const s=t[i[o]];!0===s.connected&&s.draw(e)}}_drawArrows(e){let t=this.body.edges,i=this.body.edgeIndices;for(let o=0;o<i.length;o++){const s=t[i[o]];!0===s.connected&&s.drawArrows(e)}}_determineBrowserMethod(){if("undefined"!=typeof window){let e=navigator.userAgent.toLowerCase();this.requiresTimeout=!1,(-1!=e.indexOf("msie 9.0")||-1!=e.indexOf("safari")&&e.indexOf("chrome")<=-1)&&(this.requiresTimeout=!0)}else this.requiresTimeout=!0}_drawSelectionBox(e){if(this.body.selectionBox.show){e.beginPath();const t=this.body.selectionBox.position.end.x-this.body.selectionBox.position.start.x,i=this.body.selectionBox.position.end.y-this.body.selectionBox.position.start.y;e.rect(this.body.selectionBox.position.start.x,this.body.selectionBox.position.start.y,t,i),e.fillStyle="rgba(151, 194, 252, 0.2)",e.fillRect(this.body.selectionBox.position.start.x,this.body.selectionBox.position.start.y,t,i),e.strokeStyle="rgba(151, 194, 252, 1)",e.stroke()}else e.closePath()}}function lt(e,t){t.inputHandler=function(e){e.isFirst&&t(e)},e.on("hammer.input",t.inputHandler)}function ct(e,t){return t.inputHandler=function(e){e.isFinal&&t(e)},e.on("hammer.input",t.inputHandler)}class pt{constructor(e){this.body=e,this.pixelRatio=1,this.resizeTimer=void 0,this.resizeFunction=this._onResize.bind(this),this.cameraState={},this.initialized=!1,this.canvasViewCenter={},this.options={},this.defaultOptions={autoResize:!0,height:"100%",width:"100%"},Object.assign(this.options,this.defaultOptions),this.bindEventListeners()}bindEventListeners(){this.body.emitter.once("resize",e=>{0!==e.width&&(this.body.view.translation.x=.5*e.width),0!==e.height&&(this.body.view.translation.y=.5*e.height)}),this.body.emitter.on("setSize",this.setSize.bind(this)),this.body.emitter.on("destroy",()=>{this.hammerFrame.destroy(),this.hammer.destroy(),this._cleanUp()})}setOptions(e){if(void 0!==e){let t=["width","height","autoResize"];i.selectiveDeepExtend(t,this.options,e)}!0===this.options.autoResize&&(this._cleanUp(),this.resizeTimer=setInterval(()=>{!0===this.setSize()&&this.body.emitter.emit("_requestRedraw")},1e3),this.resizeFunction=this._onResize.bind(this),i.addEventListener(window,"resize",this.resizeFunction))}_cleanUp(){void 0!==this.resizeTimer&&clearInterval(this.resizeTimer),i.removeEventListener(window,"resize",this.resizeFunction),this.resizeFunction=void 0}_onResize(){this.setSize(),this.body.emitter.emit("_redraw")}_getCameraState(e=this.pixelRatio){!0===this.initialized&&(this.cameraState.previousWidth=this.frame.canvas.width/e,this.cameraState.previousHeight=this.frame.canvas.height/e,this.cameraState.scale=this.body.view.scale,this.cameraState.position=this.DOMtoCanvas({x:.5*this.frame.canvas.width/e,y:.5*this.frame.canvas.height/e}))}_setCameraState(){if(void 0!==this.cameraState.scale&&0!==this.frame.canvas.clientWidth&&0!==this.frame.canvas.clientHeight&&0!==this.pixelRatio&&this.cameraState.previousWidth>0&&this.cameraState.previousHeight>0){let i=this.frame.canvas.width/this.pixelRatio/this.cameraState.previousWidth,o=this.frame.canvas.height/this.pixelRatio/this.cameraState.previousHeight,s=this.cameraState.scale;1!=i&&1!=o?s=.5*this.cameraState.scale*(i+o):1!=i?s=this.cameraState.scale*i:1!=o&&(s=this.cameraState.scale*o),this.body.view.scale=s;var e=this.DOMtoCanvas({x:.5*this.frame.canvas.clientWidth,y:.5*this.frame.canvas.clientHeight}),t={x:e.x-this.cameraState.position.x,y:e.y-this.cameraState.position.y};this.body.view.translation.x+=t.x*this.body.view.scale,this.body.view.translation.y+=t.y*this.body.view.scale}}_prepareValue(e){if("number"==typeof e)return e+"px";if("string"==typeof e){if(-1!==e.indexOf("%")||-1!==e.indexOf("px"))return e;if(-1===e.indexOf("%"))return e+"px"}throw new Error("Could not use the value supplied for width or height:"+e)}_create(){for(;this.body.container.hasChildNodes();)this.body.container.removeChild(this.body.container.firstChild);if(this.frame=document.createElement("div"),this.frame.className="vis-network",this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.tabIndex=900,this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas),this.frame.canvas.getContext)this._setPixelRatio(),this.setTransform();else{let e=document.createElement("DIV");e.style.color="red",e.style.fontWeight="bold",e.style.padding="10px",e.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(e)}this.body.container.appendChild(this.frame),this.body.view.scale=1,this.body.view.translation={x:.5*this.frame.canvas.clientWidth,y:.5*this.frame.canvas.clientHeight},this._bindHammer()}_bindHammer(){void 0!==this.hammer&&this.hammer.destroy(),this.drag={},this.pinch={},this.hammer=new J(this.frame.canvas),this.hammer.get("pinch").set({enable:!0}),this.hammer.get("pan").set({threshold:5,direction:J.DIRECTION_ALL}),lt(this.hammer,e=>{this.body.eventListeners.onTouch(e)}),this.hammer.on("tap",e=>{this.body.eventListeners.onTap(e)}),this.hammer.on("doubletap",e=>{this.body.eventListeners.onDoubleTap(e)}),this.hammer.on("press",e=>{this.body.eventListeners.onHold(e)}),this.hammer.on("panstart",e=>{this.body.eventListeners.onDragStart(e)}),this.hammer.on("panmove",e=>{this.body.eventListeners.onDrag(e)}),this.hammer.on("panend",e=>{this.body.eventListeners.onDragEnd(e)}),this.hammer.on("pinch",e=>{this.body.eventListeners.onPinch(e)}),this.frame.canvas.addEventListener("wheel",e=>{this.body.eventListeners.onMouseWheel(e)}),this.frame.canvas.addEventListener("mousemove",e=>{this.body.eventListeners.onMouseMove(e)}),this.frame.canvas.addEventListener("contextmenu",e=>{this.body.eventListeners.onContext(e)}),this.hammerFrame=new J(this.frame),ct(this.hammerFrame,e=>{this.body.eventListeners.onRelease(e)})}setSize(e=this.options.width,t=this.options.height){e=this._prepareValue(e),t=this._prepareValue(t);let i=!1,o=this.frame.canvas.width,s=this.frame.canvas.height,n=this.pixelRatio;if(this._setPixelRatio(),e!=this.options.width||t!=this.options.height||this.frame.style.width!=e||this.frame.style.height!=t)this._getCameraState(n),this.frame.style.width=e,this.frame.style.height=t,this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=Math.round(this.frame.canvas.clientWidth*this.pixelRatio),this.frame.canvas.height=Math.round(this.frame.canvas.clientHeight*this.pixelRatio),this.options.width=e,this.options.height=t,this.canvasViewCenter={x:.5*this.frame.clientWidth,y:.5*this.frame.clientHeight},i=!0;else{let e=Math.round(this.frame.canvas.clientWidth*this.pixelRatio),t=Math.round(this.frame.canvas.clientHeight*this.pixelRatio);this.frame.canvas.width===e&&this.frame.canvas.height===t||this._getCameraState(n),this.frame.canvas.width!==e&&(this.frame.canvas.width=e,i=!0),this.frame.canvas.height!==t&&(this.frame.canvas.height=t,i=!0)}return!0===i&&(this.body.emitter.emit("resize",{width:Math.round(this.frame.canvas.width/this.pixelRatio),height:Math.round(this.frame.canvas.height/this.pixelRatio),oldWidth:Math.round(o/this.pixelRatio),oldHeight:Math.round(s/this.pixelRatio)}),this._setCameraState()),this.initialized=!0,i}getContext(){return this.frame.canvas.getContext("2d")}_determinePixelRatio(){let e=this.getContext();if(void 0===e)throw new Error("Could not get canvax context");var t=1;return"undefined"!=typeof window&&(t=window.devicePixelRatio||1),t/(e.webkitBackingStorePixelRatio||e.mozBackingStorePixelRatio||e.msBackingStorePixelRatio||e.oBackingStorePixelRatio||e.backingStorePixelRatio||1)}_setPixelRatio(){this.pixelRatio=this._determinePixelRatio()}setTransform(){let e=this.getContext();if(void 0===e)throw new Error("Could not get canvax context");e.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}_XconvertDOMtoCanvas(e){return(e-this.body.view.translation.x)/this.body.view.scale}_XconvertCanvasToDOM(e){return e*this.body.view.scale+this.body.view.translation.x}_YconvertDOMtoCanvas(e){return(e-this.body.view.translation.y)/this.body.view.scale}_YconvertCanvasToDOM(e){return e*this.body.view.scale+this.body.view.translation.y}canvasToDOM(e){return{x:this._XconvertCanvasToDOM(e.x),y:this._YconvertCanvasToDOM(e.y)}}DOMtoCanvas(e){return{x:this._XconvertDOMtoCanvas(e.x),y:this._YconvertDOMtoCanvas(e.y)}}}class ut{constructor(e,t){this.body=e,this.canvas=t,this.animationSpeed=1/this.renderRefreshRate,this.animationEasingFunction="easeInOutQuint",this.easingTime=0,this.sourceScale=0,this.targetScale=0,this.sourceTranslation=0,this.targetTranslation=0,this.lockedOnNodeId=void 0,this.lockedOnNodeOffset=void 0,this.touchTime=0,this.viewFunction=void 0,this.body.emitter.on("fit",this.fit.bind(this)),this.body.emitter.on("animationFinished",()=>{this.body.emitter.emit("_stopRendering")}),this.body.emitter.on("unlockNode",this.releaseNode.bind(this))}setOptions(e={}){this.options=e}fit(e={nodes:[]},t=!1){let i,o;void 0!==(e=Object.assign({},e)).nodes&&0!==e.nodes.length||(e.nodes=this.body.nodeIndices);const s=this.canvas.frame.canvas.clientWidth,n=this.canvas.frame.canvas.clientHeight;if(0===s||0===n)o=1,i=rt.getRange(this.body.nodes,e.nodes);else if(!0===t){let t=0;for(let e in this.body.nodes)if(this.body.nodes.hasOwnProperty(e)){!0===this.body.nodes[e].predefinedPosition&&(t+=1)}if(t>.5*this.body.nodeIndices.length)return void this.fit(e,!1);i=rt.getRange(this.body.nodes,e.nodes),o=12.662/(this.body.nodeIndices.length+7.4147)+.0964822;o*=Math.min(s/600,n/600)}else{this.body.emitter.emit("_resizeNodes"),i=rt.getRange(this.body.nodes,e.nodes);const t=s/(1.1*Math.abs(i.maxX-i.minX)),r=n/(1.1*Math.abs(i.maxY-i.minY));o=t<=r?t:r}(o>1||0===o)&&(o=1);let r={position:rt.findCenter(i),scale:o,animation:e.animation};this.moveTo(r)}focus(e,t={}){if(void 0!==this.body.nodes[e]){let i={x:this.body.nodes[e].x,y:this.body.nodes[e].y};t.position=i,t.lockedOnNode=e,this.moveTo(t)}else console.log("Node: "+e+" cannot be found.")}moveTo(e){if(void 0!==e){if(null!=e.offset){if(null!=e.offset.x){if(e.offset.x=+e.offset.x,!Number.isFinite(e.offset.x))throw new TypeError('The option "offset.x" has to be a finite number.')}else e.offset.x=0;if(null!=e.offset.y){if(e.offset.y=+e.offset.y,!Number.isFinite(e.offset.y))throw new TypeError('The option "offset.y" has to be a finite number.')}else e.offset.x=0}else e.offset={x:0,y:0};if(null!=e.position){if(null!=e.position.x){if(e.position.x=+e.position.x,!Number.isFinite(e.position.x))throw new TypeError('The option "position.x" has to be a finite number.')}else e.position.x=0;if(null!=e.position.y){if(e.position.y=+e.position.y,!Number.isFinite(e.position.y))throw new TypeError('The option "position.y" has to be a finite number.')}else e.position.x=0}else e.position=this.getViewPosition();if(null!=e.scale){if(e.scale=+e.scale,!(e.scale>0))throw new TypeError('The option "scale" has to be a number greater than zero.')}else e.scale=this.body.view.scale;void 0===e.animation&&(e.animation={duration:0}),!1===e.animation&&(e.animation={duration:0}),!0===e.animation&&(e.animation={}),void 0===e.animation.duration&&(e.animation.duration=1e3),void 0===e.animation.easingFunction&&(e.animation.easingFunction="easeInOutQuad"),this.animateView(e)}else e={}}animateView(e){if(void 0===e)return;this.animationEasingFunction=e.animation.easingFunction,this.releaseNode(),!0===e.locked&&(this.lockedOnNodeId=e.lockedOnNode,this.lockedOnNodeOffset=e.offset),0!=this.easingTime&&this._transitionRedraw(!0),this.sourceScale=this.body.view.scale,this.sourceTranslation=this.body.view.translation,this.targetScale=e.scale,this.body.view.scale=this.targetScale;let t=this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight}),i=t.x-e.position.x,o=t.y-e.position.y;this.targetTranslation={x:this.sourceTranslation.x+i*this.targetScale+e.offset.x,y:this.sourceTranslation.y+o*this.targetScale+e.offset.y},0===e.animation.duration?null!=this.lockedOnNodeId?(this.viewFunction=this._lockedRedraw.bind(this),this.body.emitter.on("initRedraw",this.viewFunction)):(this.body.view.scale=this.targetScale,this.body.view.translation=this.targetTranslation,this.body.emitter.emit("_requestRedraw")):(this.animationSpeed=1/(60*e.animation.duration*.001)||1/60,this.animationEasingFunction=e.animation.easingFunction,this.viewFunction=this._transitionRedraw.bind(this),this.body.emitter.on("initRedraw",this.viewFunction),this.body.emitter.emit("_startRendering"))}_lockedRedraw(){let e=this.body.nodes[this.lockedOnNodeId].x,t=this.body.nodes[this.lockedOnNodeId].y,i=this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight}),o=i.x-e,s=i.y-t,n=this.body.view.translation,r={x:n.x+o*this.body.view.scale+this.lockedOnNodeOffset.x,y:n.y+s*this.body.view.scale+this.lockedOnNodeOffset.y};this.body.view.translation=r}releaseNode(){void 0!==this.lockedOnNodeId&&void 0!==this.viewFunction&&(this.body.emitter.off("initRedraw",this.viewFunction),this.lockedOnNodeId=void 0,this.lockedOnNodeOffset=void 0)}_transitionRedraw(e=!1){this.easingTime+=this.animationSpeed,this.easingTime=!0===e?1:this.easingTime;let t=i.easingFunctions[this.animationEasingFunction](this.easingTime);this.body.view.scale=this.sourceScale+(this.targetScale-this.sourceScale)*t,this.body.view.translation={x:this.sourceTranslation.x+(this.targetTranslation.x-this.sourceTranslation.x)*t,y:this.sourceTranslation.y+(this.targetTranslation.y-this.sourceTranslation.y)*t},this.easingTime>=1&&(this.body.emitter.off("initRedraw",this.viewFunction),this.easingTime=0,null!=this.lockedOnNodeId&&(this.viewFunction=this._lockedRedraw.bind(this),this.body.emitter.on("initRedraw",this.viewFunction)),this.body.emitter.emit("animationFinished"))}getScale(){return this.body.view.scale}getViewPosition(){return this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight})}}class gt{constructor(e,t){this.body=e,this.canvas=t,this.iconsCreated=!1,this.navigationHammers=[],this.boundFunctions={},this.touchTime=0,this.activated=!1,this.body.emitter.on("activate",()=>{this.activated=!0,this.configureKeyboardBindings()}),this.body.emitter.on("deactivate",()=>{this.activated=!1,this.configureKeyboardBindings()}),this.body.emitter.on("destroy",()=>{void 0!==this.keycharm&&this.keycharm.destroy()}),this.options={}}setOptions(e){void 0!==e&&(this.options=e,this.create())}create(){!0===this.options.navigationButtons?!1===this.iconsCreated&&this.loadNavigationElements():!0===this.iconsCreated&&this.cleanNavigation(),this.configureKeyboardBindings()}cleanNavigation(){if(0!=this.navigationHammers.length){for(var e=0;e<this.navigationHammers.length;e++)this.navigationHammers[e].destroy();this.navigationHammers=[]}this.navigationDOM&&this.navigationDOM.wrapper&&this.navigationDOM.wrapper.parentNode&&this.navigationDOM.wrapper.parentNode.removeChild(this.navigationDOM.wrapper),this.iconsCreated=!1}loadNavigationElements(){this.cleanNavigation(),this.navigationDOM={};var e=["up","down","left","right","zoomIn","zoomOut","zoomExtends"],t=["_moveUp","_moveDown","_moveLeft","_moveRight","_zoomIn","_zoomOut","_fit"];this.navigationDOM.wrapper=document.createElement("div"),this.navigationDOM.wrapper.className="vis-navigation",this.canvas.frame.appendChild(this.navigationDOM.wrapper);for(var i=0;i<e.length;i++){this.navigationDOM[e[i]]=document.createElement("div"),this.navigationDOM[e[i]].className="vis-button vis-"+e[i],this.navigationDOM.wrapper.appendChild(this.navigationDOM[e[i]]);var o=new J(this.navigationDOM[e[i]]);lt(o,"_fit"===t[i]?this._fit.bind(this):this.bindToRedraw.bind(this,t[i])),this.navigationHammers.push(o)}var s=new J(this.canvas.frame);ct(s,()=>{this._stopMovement()}),this.navigationHammers.push(s),this.iconsCreated=!0}bindToRedraw(e){void 0===this.boundFunctions[e]&&(this.boundFunctions[e]=this[e].bind(this),this.body.emitter.on("initRedraw",this.boundFunctions[e]),this.body.emitter.emit("_startRendering"))}unbindFromRedraw(e){void 0!==this.boundFunctions[e]&&(this.body.emitter.off("initRedraw",this.boundFunctions[e]),this.body.emitter.emit("_stopRendering"),delete this.boundFunctions[e])}_fit(){(new Date).valueOf()-this.touchTime>700&&(this.body.emitter.emit("fit",{duration:700}),this.touchTime=(new Date).valueOf())}_stopMovement(){for(let e in this.boundFunctions)this.boundFunctions.hasOwnProperty(e)&&(this.body.emitter.off("initRedraw",this.boundFunctions[e]),this.body.emitter.emit("_stopRendering"));this.boundFunctions={}}_moveUp(){this.body.view.translation.y+=this.options.keyboard.speed.y}_moveDown(){this.body.view.translation.y-=this.options.keyboard.speed.y}_moveLeft(){this.body.view.translation.x+=this.options.keyboard.speed.x}_moveRight(){this.body.view.translation.x-=this.options.keyboard.speed.x}_zoomIn(){var e=this.body.view.scale,t=this.body.view.scale*(1+this.options.keyboard.speed.zoom),i=this.body.view.translation,o=t/e,s=(1-o)*this.canvas.canvasViewCenter.x+i.x*o,n=(1-o)*this.canvas.canvasViewCenter.y+i.y*o;this.body.view.scale=t,this.body.view.translation={x:s,y:n},this.body.emitter.emit("zoom",{direction:"+",scale:this.body.view.scale,pointer:null})}_zoomOut(){var e=this.body.view.scale,t=this.body.view.scale/(1+this.options.keyboard.speed.zoom),i=this.body.view.translation,o=t/e,s=(1-o)*this.canvas.canvasViewCenter.x+i.x*o,n=(1-o)*this.canvas.canvasViewCenter.y+i.y*o;this.body.view.scale=t,this.body.view.translation={x:s,y:n},this.body.emitter.emit("zoom",{direction:"-",scale:this.body.view.scale,pointer:null})}configureKeyboardBindings(){void 0!==this.keycharm&&this.keycharm.destroy(),!0===this.options.keyboard.enabled&&(!0===this.options.keyboard.bindToWindow?this.keycharm=o({container:window,preventDefault:!0}):this.keycharm=o({container:this.canvas.frame,preventDefault:!0}),this.keycharm.reset(),!0===this.activated&&(this.keycharm.bind("up",()=>{this.bindToRedraw("_moveUp")},"keydown"),this.keycharm.bind("down",()=>{this.bindToRedraw("_moveDown")},"keydown"),this.keycharm.bind("left",()=>{this.bindToRedraw("_moveLeft")},"keydown"),this.keycharm.bind("right",()=>{this.bindToRedraw("_moveRight")},"keydown"),this.keycharm.bind("=",()=>{this.bindToRedraw("_zoomIn")},"keydown"),this.keycharm.bind("num+",()=>{this.bindToRedraw("_zoomIn")},"keydown"),this.keycharm.bind("num-",()=>{this.bindToRedraw("_zoomOut")},"keydown"),this.keycharm.bind("-",()=>{this.bindToRedraw("_zoomOut")},"keydown"),this.keycharm.bind("[",()=>{this.bindToRedraw("_zoomOut")},"keydown"),this.keycharm.bind("]",()=>{this.bindToRedraw("_zoomIn")},"keydown"),this.keycharm.bind("pageup",()=>{this.bindToRedraw("_zoomIn")},"keydown"),this.keycharm.bind("pagedown",()=>{this.bindToRedraw("_zoomOut")},"keydown"),this.keycharm.bind("up",()=>{this.unbindFromRedraw("_moveUp")},"keyup"),this.keycharm.bind("down",()=>{this.unbindFromRedraw("_moveDown")},"keyup"),this.keycharm.bind("left",()=>{this.unbindFromRedraw("_moveLeft")},"keyup"),this.keycharm.bind("right",()=>{this.unbindFromRedraw("_moveRight")},"keyup"),this.keycharm.bind("=",()=>{this.unbindFromRedraw("_zoomIn")},"keyup"),this.keycharm.bind("num+",()=>{this.unbindFromRedraw("_zoomIn")},"keyup"),this.keycharm.bind("num-",()=>{this.unbindFromRedraw("_zoomOut")},"keyup"),this.keycharm.bind("-",()=>{this.unbindFromRedraw("_zoomOut")},"keyup"),this.keycharm.bind("[",()=>{this.unbindFromRedraw("_zoomOut")},"keyup"),this.keycharm.bind("]",()=>{this.unbindFromRedraw("_zoomIn")},"keyup"),this.keycharm.bind("pageup",()=>{this.unbindFromRedraw("_zoomIn")},"keyup"),this.keycharm.bind("pagedown",()=>{this.unbindFromRedraw("_zoomOut")},"keyup")))}}class mt{constructor(e,t){this.container=e,this.overflowMethod=t||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}setPosition(e,t){this.x=parseInt(e),this.y=parseInt(t)}setText(e){e instanceof Element?(this.frame.innerHTML="",this.frame.appendChild(e)):this.frame.innerHTML=e}show(e){if(void 0===e&&(e=!0),!0===e){var t=this.frame.clientHeight,i=this.frame.clientWidth,o=this.frame.parentNode.clientHeight,s=this.frame.parentNode.clientWidth,n=0,r=0;if("flip"==this.overflowMethod){var a=!1,h=!0;this.y-t<this.padding&&(h=!1),this.x+i>s-this.padding&&(a=!0),n=a?this.x-i:this.x,r=h?this.y-t:this.y}else(r=this.y-t)+t+this.padding>o&&(r=o-t-this.padding),r<this.padding&&(r=this.padding),(n=this.x)+i+this.padding>s&&(n=s-i-this.padding),n<this.padding&&(n=this.padding);this.frame.style.left=n+"px",this.frame.style.top=r+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}hide(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}destroy(){this.frame.parentNode.removeChild(this.frame)}}class bt{constructor(e,t,i){this.body=e,this.canvas=t,this.selectionHandler=i,this.navigationHandler=new gt(e,t),this.body.eventListeners.onTap=this.onTap.bind(this),this.body.eventListeners.onTouch=this.onTouch.bind(this),this.body.eventListeners.onDoubleTap=this.onDoubleTap.bind(this),this.body.eventListeners.onHold=this.onHold.bind(this),this.body.eventListeners.onDragStart=this.onDragStart.bind(this),this.body.eventListeners.onDrag=this.onDrag.bind(this),this.body.eventListeners.onDragEnd=this.onDragEnd.bind(this),this.body.eventListeners.onMouseWheel=this.onMouseWheel.bind(this),this.body.eventListeners.onPinch=this.onPinch.bind(this),this.body.eventListeners.onMouseMove=this.onMouseMove.bind(this),this.body.eventListeners.onRelease=this.onRelease.bind(this),this.body.eventListeners.onContext=this.onContext.bind(this),this.touchTime=0,this.drag={},this.pinch={},this.popup=void 0,this.popupObj=void 0,this.popupTimer=void 0,this.body.functions.getPointer=this.getPointer.bind(this),this.options={},this.defaultOptions={dragNodes:!0,dragView:!0,hover:!1,keyboard:{enabled:!1,speed:{x:10,y:10,zoom:.02},bindToWindow:!0},navigationButtons:!1,tooltipDelay:300,zoomView:!0,zoomSpeed:1},Object.assign(this.options,this.defaultOptions),this.bindEventListeners()}bindEventListeners(){this.body.emitter.on("destroy",()=>{clearTimeout(this.popupTimer),delete this.body.functions.getPointer})}setOptions(e){if(void 0!==e){let t=["hideEdgesOnDrag","hideEdgesOnZoom","hideNodesOnDrag","keyboard","multiselect","selectable","selectConnectedEdges"];i.selectiveNotDeepExtend(t,this.options,e),i.mergeOptions(this.options,e,"keyboard"),e.tooltip&&(Object.assign(this.options.tooltip,e.tooltip),e.tooltip.color&&(this.options.tooltip.color=i.parseColor(e.tooltip.color)))}this.navigationHandler.setOptions(this.options)}getPointer(e){return{x:e.x-i.getAbsoluteLeft(this.canvas.frame.canvas),y:e.y-i.getAbsoluteTop(this.canvas.frame.canvas)}}onTouch(e){(new Date).valueOf()-this.touchTime>50&&(this.drag.pointer=this.getPointer(e.center),this.drag.pinched=!1,this.pinch.scale=this.body.view.scale,this.touchTime=(new Date).valueOf())}onTap(e){let t=this.getPointer(e.center),i=this.selectionHandler.options.multiselect&&(e.changedPointers[0].ctrlKey||e.changedPointers[0].metaKey);this.checkSelectionChanges(t,e,i),this.selectionHandler._generateClickEvent("click",e,t)}onDoubleTap(e){let t=this.getPointer(e.center);this.selectionHandler._generateClickEvent("doubleClick",e,t)}onHold(e){let t=this.getPointer(e.center),i=this.selectionHandler.options.multiselect;this.checkSelectionChanges(t,e,i),this.selectionHandler._generateClickEvent("click",e,t),this.selectionHandler._generateClickEvent("hold",e,t)}onRelease(e){if((new Date).valueOf()-this.touchTime>10){let t=this.getPointer(e.center);this.selectionHandler._generateClickEvent("release",e,t),this.touchTime=(new Date).valueOf()}}onContext(e){let t=this.getPointer({x:e.clientX,y:e.clientY});this.selectionHandler._generateClickEvent("oncontext",e,t)}checkSelectionChanges(e,t,i=!1){let o=this.selectionHandler.getSelection(),s=!1;s=!0===i?this.selectionHandler.selectAdditionalOnPoint(e):this.selectionHandler.selectOnPoint(e);let n=this.selectionHandler.getSelection(),r=this._determineDifference(o,n),a=this._determineDifference(n,o);r.edges.length>0&&(this.selectionHandler._generateClickEvent("deselectEdge",t,e,o),s=!0),r.nodes.length>0&&(this.selectionHandler._generateClickEvent("deselectNode",t,e,o),s=!0),a.nodes.length>0&&(this.selectionHandler._generateClickEvent("selectNode",t,e),s=!0),a.edges.length>0&&(this.selectionHandler._generateClickEvent("selectEdge",t,e),s=!0),!0===s&&this.selectionHandler._generateClickEvent("select",t,e)}_determineDifference(e,t){let i=function(e,t){let i=[];for(let o=0;o<e.length;o++){let s=e[o];-1===t.indexOf(s)&&i.push(s)}return i};return{nodes:i(e.nodes,t.nodes),edges:i(e.edges,t.edges)}}onDragStart(e){if(this.drag.dragging)return;void 0===this.drag.pointer&&this.onTouch(e);let t=this.selectionHandler.getNodeAt(this.drag.pointer);if(this.drag.dragging=!0,this.drag.selection=[],this.drag.translation=Object.assign({},this.body.view.translation),this.drag.nodeId=void 0,e.srcEvent.shiftKey){this.body.selectionBox.show=!0;let t=this.getPointer(e.center);this.body.selectionBox.position.start={x:this.canvas._XconvertDOMtoCanvas(t.x),y:this.canvas._YconvertDOMtoCanvas(t.y)},this.body.selectionBox.position.end={x:this.canvas._XconvertDOMtoCanvas(t.x),y:this.canvas._YconvertDOMtoCanvas(t.y)}}if(void 0!==t&&!0===this.options.dragNodes){this.drag.nodeId=t.id,!1===t.isSelected()&&(this.selectionHandler.unselectAll(),this.selectionHandler.selectObject(t)),this.selectionHandler._generateClickEvent("dragStart",e,this.drag.pointer);let i=this.selectionHandler.selectionObj.nodes;for(let e in i)if(i.hasOwnProperty(e)){let t=i[e],o={id:t.id,node:t,x:t.x,y:t.y,xFixed:t.options.fixed.x,yFixed:t.options.fixed.y};t.options.fixed.x=!0,t.options.fixed.y=!0,this.drag.selection.push(o)}}else this.selectionHandler._generateClickEvent("dragStart",e,this.drag.pointer,void 0,!0)}onDrag(e){if(!0===this.drag.pinched)return;this.body.emitter.emit("unlockNode");let t=this.getPointer(e.center),i=this.drag.selection;if(i&&i.length&&!0===this.options.dragNodes){this.selectionHandler._generateClickEvent("dragging",e,t);let o=t.x-this.drag.pointer.x,s=t.y-this.drag.pointer.y;i.forEach(e=>{let t=e.node;!1===e.xFixed&&(t.x=this.canvas._XconvertDOMtoCanvas(this.canvas._XconvertCanvasToDOM(e.x)+o)),!1===e.yFixed&&(t.y=this.canvas._YconvertDOMtoCanvas(this.canvas._YconvertCanvasToDOM(e.y)+s))}),this.body.emitter.emit("startSimulation")}else{if(e.srcEvent.shiftKey){if(this.selectionHandler._generateClickEvent("dragging",e,t,void 0,!0),void 0===this.drag.pointer)return void this.onDragStart(e);this.body.selectionBox.position.end={x:this.canvas._XconvertDOMtoCanvas(t.x),y:this.canvas._YconvertDOMtoCanvas(t.y)},this.body.emitter.emit("_requestRedraw")}if(!0===this.options.dragView&&!e.srcEvent.shiftKey){if(this.selectionHandler._generateClickEvent("dragging",e,t,void 0,!0),void 0===this.drag.pointer)return void this.onDragStart(e);let i=t.x-this.drag.pointer.x,o=t.y-this.drag.pointer.y;this.body.view.translation={x:this.drag.translation.x+i,y:this.drag.translation.y+o},this.body.emitter.emit("_requestRedraw")}}}onDragEnd(e){if(this.drag.dragging=!1,this.body.selectionBox.show){this.body.selectionBox.show=!1;const t=this.body.selectionBox.position,i={minX:Math.min(t.start.x,t.end.x),minY:Math.min(t.start.y,t.end.y),maxX:Math.max(t.start.x,t.end.x),maxY:Math.max(t.start.y,t.end.y)};this.body.nodeIndices.filter(e=>{const t=this.body.nodes[e];return t.x>=i.minX&&t.x<=i.maxX&&t.y>=i.minY&&t.y<=i.maxY}).forEach(e=>this.selectionHandler.selectObject(this.body.nodes[e])),this.selectionHandler._generateClickEvent("dragEnd",e,this.getPointer(e.center),void 0,!0),this.body.emitter.emit("_requestRedraw")}else{let t=this.drag.selection;t&&t.length?(t.forEach((function(e){e.node.options.fixed.x=e.xFixed,e.node.options.fixed.y=e.yFixed})),this.selectionHandler._generateClickEvent("dragEnd",e,this.getPointer(e.center)),this.body.emitter.emit("startSimulation")):(this.selectionHandler._generateClickEvent("dragEnd",e,this.getPointer(e.center),void 0,!0),this.body.emitter.emit("_requestRedraw"))}}onPinch(e){let t=this.getPointer(e.center);this.drag.pinched=!0,void 0===this.pinch.scale&&(this.pinch.scale=1);let i=this.pinch.scale*e.scale;this.zoom(i,t)}zoom(e,t){if(!0===this.options.zoomView){let i=this.body.view.scale;e<1e-5&&(e=1e-5),e>10&&(e=10);let o=void 0;void 0!==this.drag&&!0===this.drag.dragging&&(o=this.canvas.DOMtoCanvas(this.drag.pointer));let s=this.body.view.translation,n=e/i,r=(1-n)*t.x+s.x*n,a=(1-n)*t.y+s.y*n;if(this.body.view.scale=e,this.body.view.translation={x:r,y:a},null!=o){let e=this.canvas.canvasToDOM(o);this.drag.pointer.x=e.x,this.drag.pointer.y=e.y}this.body.emitter.emit("_requestRedraw"),i<e?this.body.emitter.emit("zoom",{direction:"+",scale:this.body.view.scale,pointer:t}):this.body.emitter.emit("zoom",{direction:"-",scale:this.body.view.scale,pointer:t})}}onMouseWheel(e){if(!0===this.options.zoomView){if(0!==e.deltaY){let t=this.body.view.scale;t*=1+(e.deltaY<0?1:-1)*(.1*this.options.zoomSpeed);let i=this.getPointer({x:e.clientX,y:e.clientY});this.zoom(t,i)}e.preventDefault()}}onMouseMove(e){let t=this.getPointer({x:e.clientX,y:e.clientY}),i=!1;void 0!==this.popup&&(!1===this.popup.hidden&&this._checkHidePopup(t),!1===this.popup.hidden&&(i=!0,this.popup.setPosition(t.x+3,t.y-5),this.popup.show())),!1===this.options.keyboard.bindToWindow&&!0===this.options.keyboard.enabled&&this.canvas.frame.focus(),!1===i&&(void 0!==this.popupTimer&&(clearInterval(this.popupTimer),this.popupTimer=void 0),this.drag.dragging||(this.popupTimer=setTimeout(()=>this._checkShowPopup(t),this.options.tooltipDelay))),!0===this.options.hover&&this.selectionHandler.hoverObject(e,t)}_checkShowPopup(e){let t=this.canvas._XconvertDOMtoCanvas(e.x),i=this.canvas._YconvertDOMtoCanvas(e.y),o={left:t,top:i,right:t,bottom:i},s=void 0===this.popupObj?void 0:this.popupObj.id,n=!1,r="node";if(void 0===this.popupObj){let e,t=this.body.nodeIndices,i=this.body.nodes,s=[];for(let r=0;r<t.length;r++)e=i[t[r]],!0===e.isOverlappingWith(o)&&(n=!0,void 0!==e.getTitle()&&s.push(t[r]));s.length>0&&(this.popupObj=i[s[s.length-1]],n=!0)}if(void 0===this.popupObj&&!1===n){let e,t=this.body.edgeIndices,i=this.body.edges,s=[];for(let n=0;n<t.length;n++)e=i[t[n]],!0===e.isOverlappingWith(o)&&!0===e.connected&&void 0!==e.getTitle()&&s.push(t[n]);s.length>0&&(this.popupObj=i[s[s.length-1]],r="edge")}void 0!==this.popupObj?this.popupObj.id!==s&&(void 0===this.popup&&(this.popup=new mt(this.canvas.frame)),this.popup.popupTargetType=r,this.popup.popupTargetId=this.popupObj.id,this.popup.setPosition(e.x+3,e.y-5),this.popup.setText(this.popupObj.getTitle()),this.popup.show(),this.body.emitter.emit("showPopup",this.popupObj.id)):void 0!==this.popup&&(this.popup.hide(),this.body.emitter.emit("hidePopup"))}_checkHidePopup(e){let t=this.selectionHandler._pointerToPositionObject(e),i=!1;if("node"===this.popup.popupTargetType){if(void 0!==this.body.nodes[this.popup.popupTargetId]&&(i=this.body.nodes[this.popup.popupTargetId].isOverlappingWith(t),!0===i)){let t=this.selectionHandler.getNodeAt(e);i=void 0!==t&&t.id===this.popup.popupTargetId}}else void 0===this.selectionHandler.getNodeAt(e)&&void 0!==this.body.edges[this.popup.popupTargetId]&&(i=this.body.edges[this.popup.popupTargetId].isOverlappingWith(t));!1===i&&(this.popupObj=void 0,this.popup.hide(),this.body.emitter.emit("hidePopup"))}}class ft{constructor(e,t){this.body=e,this.canvas=t,this.selectionObj={nodes:[],edges:[]},this.hoverObj={nodes:{},edges:{}},this.options={},this.defaultOptions={multiselect:!1,selectable:!0,selectConnectedEdges:!0,hoverConnectedEdges:!0},Object.assign(this.options,this.defaultOptions),this.body.emitter.on("_dataChanged",()=>{this.updateSelection()})}setOptions(e){if(void 0!==e){let t=["multiselect","hoverConnectedEdges","selectable","selectConnectedEdges"];i.selectiveDeepExtend(t,this.options,e)}}selectOnPoint(e){let t=!1;if(!0===this.options.selectable){let i=this.getNodeAt(e)||this.getEdgeAt(e);this.unselectAll(),void 0!==i&&(t=this.selectObject(i)),this.body.emitter.emit("_requestRedraw")}return t}selectAdditionalOnPoint(e){let t=!1;if(!0===this.options.selectable){let i=this.getNodeAt(e)||this.getEdgeAt(e);void 0!==i&&(t=!0,!0===i.isSelected()?this.deselectObject(i):this.selectObject(i),this.body.emitter.emit("_requestRedraw"))}return t}_initBaseEvent(e,t){let i={};return i.pointer={DOM:{x:t.x,y:t.y},canvas:this.canvas.DOMtoCanvas(t)},i.event=e,i}_generateClickEvent(e,t,i,o,s=!1){let n=this._initBaseEvent(t,i);if(!0===s)n.nodes=[],n.edges=[];else{let e=this.getSelection();n.nodes=e.nodes,n.edges=e.edges}void 0!==o&&(n.previousSelection=o),"click"==e&&(n.items=this.getClickedItems(i)),void 0!==t.controlEdge&&(n.controlEdge=t.controlEdge),this.body.emitter.emit(e,n)}selectObject(e,t=this.options.selectConnectedEdges){return void 0!==e&&(e instanceof Ne&&!0===t&&this._selectConnectedEdges(e),e.select(),this._addToSelection(e),!0)}deselectObject(e){!0===e.isSelected()&&(e.selected=!1,this._removeFromSelection(e))}_getAllNodesOverlappingWith(e){let t=[],i=this.body.nodes;for(let o=0;o<this.body.nodeIndices.length;o++){let s=this.body.nodeIndices[o];i[s].isOverlappingWith(e)&&t.push(s)}return t}_pointerToPositionObject(e){let t=this.canvas.DOMtoCanvas(e);return{left:t.x-1,top:t.y+1,right:t.x+1,bottom:t.y-1}}getNodeAt(e,t=!0){let i=this._pointerToPositionObject(e),o=this._getAllNodesOverlappingWith(i);return o.length>0?!0===t?this.body.nodes[o[o.length-1]]:o[o.length-1]:void 0}_getEdgesOverlappingWith(e,t){let i=this.body.edges;for(let o=0;o<this.body.edgeIndices.length;o++){let s=this.body.edgeIndices[o];i[s].isOverlappingWith(e)&&t.push(s)}}_getAllEdgesOverlappingWith(e){let t=[];return this._getEdgesOverlappingWith(e,t),t}getEdgeAt(e,t=!0){for(var i=this.canvas.DOMtoCanvas(e),o=10,s=null,n=this.body.edges,r=0;r<this.body.edgeIndices.length;r++){var a=this.body.edgeIndices[r],h=n[a];if(h.connected){var d=h.from.x,l=h.from.y,c=h.to.x,p=h.to.y,u=h.edgeType.getDistanceToEdge(d,l,c,p,i.x,i.y);u<o&&(s=a,o=u)}}return null!==s?!0===t?this.body.edges[s]:s:void 0}_addToSelection(e){e instanceof Ne?this.selectionObj.nodes[e.id]=e:this.selectionObj.edges[e.id]=e}_addToHover(e){e instanceof Ne?this.hoverObj.nodes[e.id]=e:this.hoverObj.edges[e.id]=e}_removeFromSelection(e){e instanceof Ne?(delete this.selectionObj.nodes[e.id],this._unselectConnectedEdges(e)):delete this.selectionObj.edges[e.id]}unselectAll(){for(let e in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(e)&&this.selectionObj.nodes[e].unselect();for(let e in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(e)&&this.selectionObj.edges[e].unselect();this.selectionObj={nodes:{},edges:{}}}_getSelectedNodeCount(){let e=0;for(let t in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(t)&&(e+=1);return e}_getSelectedNode(){for(let e in this.selectionObj.nodes)if(this.selectionObj.nodes.hasOwnProperty(e))return this.selectionObj.nodes[e]}_getSelectedEdge(){for(let e in this.selectionObj.edges)if(this.selectionObj.edges.hasOwnProperty(e))return this.selectionObj.edges[e]}_getSelectedEdgeCount(){let e=0;for(let t in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(t)&&(e+=1);return e}_getSelectedObjectCount(){let e=0;for(let t in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(t)&&(e+=1);for(let t in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(t)&&(e+=1);return e}_selectionIsEmpty(){for(let e in this.selectionObj.nodes)if(this.selectionObj.nodes.hasOwnProperty(e))return!1;for(let e in this.selectionObj.edges)if(this.selectionObj.edges.hasOwnProperty(e))return!1;return!0}_clusterInSelection(){for(let e in this.selectionObj.nodes)if(this.selectionObj.nodes.hasOwnProperty(e)&&this.selectionObj.nodes[e].clusterSize>1)return!0;return!1}_selectConnectedEdges(e){for(let t=0;t<e.edges.length;t++){let i=e.edges[t];i.select(),this._addToSelection(i)}}_hoverConnectedEdges(e){for(let t=0;t<e.edges.length;t++){let i=e.edges[t];i.hover=!0,this._addToHover(i)}}_unselectConnectedEdges(e){for(let t=0;t<e.edges.length;t++){let i=e.edges[t];i.unselect(),this._removeFromSelection(i)}}emitBlurEvent(e,t,i){let o=this._initBaseEvent(e,t);!0===i.hover&&(i.hover=!1,i instanceof Ne?(o.node=i.id,this.body.emitter.emit("blurNode",o)):(o.edge=i.id,this.body.emitter.emit("blurEdge",o)))}emitHoverEvent(e,t,i){let o=this._initBaseEvent(e,t),s=!1;return!1===i.hover&&(i.hover=!0,this._addToHover(i),s=!0,i instanceof Ne?(o.node=i.id,this.body.emitter.emit("hoverNode",o)):(o.edge=i.id,this.body.emitter.emit("hoverEdge",o))),s}hoverObject(e,t){let i=this.getNodeAt(t);void 0===i&&(i=this.getEdgeAt(t));let o=!1;for(let s in this.hoverObj.nodes)this.hoverObj.nodes.hasOwnProperty(s)&&(void 0===i||i instanceof Ne&&i.id!=s||i instanceof Ke)&&(this.emitBlurEvent(e,t,this.hoverObj.nodes[s]),delete this.hoverObj.nodes[s],o=!0);for(let s in this.hoverObj.edges)this.hoverObj.edges.hasOwnProperty(s)&&(!0===o?(this.hoverObj.edges[s].hover=!1,delete this.hoverObj.edges[s]):(void 0===i||i instanceof Ke&&i.id!=s||i instanceof Ne&&!i.hover)&&(this.emitBlurEvent(e,t,this.hoverObj.edges[s]),delete this.hoverObj.edges[s],o=!0));if(void 0!==i){const s=Object.keys(this.hoverObj.edges).length,n=Object.keys(this.hoverObj.nodes).length,r=i instanceof Ke&&0===s&&0===n,a=i instanceof Ne&&0===s&&0===n;(o||r||a)&&(o=this.emitHoverEvent(e,t,i)),i instanceof Ne&&!0===this.options.hoverConnectedEdges&&this._hoverConnectedEdges(i)}!0===o&&this.body.emitter.emit("_requestRedraw")}getSelection(){return{nodes:this.getSelectedNodes(),edges:this.getSelectedEdges()}}getSelectedNodes(){let e=[];if(!0===this.options.selectable)for(let t in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(t)&&e.push(this.selectionObj.nodes[t].id);return e}getSelectedEdges(){let e=[];if(!0===this.options.selectable)for(let t in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(t)&&e.push(this.selectionObj.edges[t].id);return e}setSelection(e,t={}){let i,o;if(!e||!e.nodes&&!e.edges)throw"Selection must be an object with nodes and/or edges properties";if((t.unselectAll||void 0===t.unselectAll)&&this.unselectAll(),e.nodes)for(i=0;i<e.nodes.length;i++){o=e.nodes[i];let s=this.body.nodes[o];if(!s)throw new RangeError('Node with id "'+o+'" not found');this.selectObject(s,t.highlightEdges)}if(e.edges)for(i=0;i<e.edges.length;i++){o=e.edges[i];let t=this.body.edges[o];if(!t)throw new RangeError('Edge with id "'+o+'" not found');this.selectObject(t)}this.body.emitter.emit("_requestRedraw")}selectNodes(e,t=!0){if(!e||void 0===e.length)throw"Selection must be an array with ids";this.setSelection({nodes:e},{highlightEdges:t})}selectEdges(e){if(!e||void 0===e.length)throw"Selection must be an array with ids";this.setSelection({edges:e})}updateSelection(){for(let e in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(e)&&(this.body.nodes.hasOwnProperty(e)||delete this.selectionObj.nodes[e]);for(let e in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(e)&&(this.body.edges.hasOwnProperty(e)||delete this.selectionObj.edges[e])}getClickedItems(e){let t=this.canvas.DOMtoCanvas(e);var i=[];let o=this.body.nodeIndices,s=this.body.nodes;for(let e=o.length-1;e>=0;e--){let n=s[o[e]].getItemsOnPoint(t);i.push.apply(i,n)}let n=this.body.edgeIndices,r=this.body.edges;for(let e=n.length-1;e>=0;e--){let o=r[n[e]].getItemsOnPoint(t);i.push.apply(i,o)}return i}}class yt{abstract(){throw new Error("Can't instantiate abstract class!")}fake_use(){}curveType(){return this.abstract()}getPosition(e){return this.fake_use(e),this.abstract()}setPosition(e,t,i){this.fake_use(e,t,i),this.abstract()}getTreeSize(e){return this.fake_use(e),this.abstract()}sort(e){this.fake_use(e),this.abstract()}fix(e,t){this.fake_use(e,t),this.abstract()}shift(e,t){this.fake_use(e,t),this.abstract()}}class vt extends yt{constructor(e){super(),this.layout=e}curveType(){return"horizontal"}getPosition(e){return e.x}setPosition(e,t,i){void 0!==i&&this.layout.hierarchical.addToOrdering(e,i),e.x=t}getTreeSize(e){let t=this.layout.hierarchical.getTreeSize(this.layout.body.nodes,e);return{min:t.min_x,max:t.max_x}}sort(e){a.sort(e,(function(e,t){return e.x-t.x}))}fix(e,t){e.y=this.layout.options.hierarchical.levelSeparation*t,e.options.fixed.y=!0}shift(e,t){this.layout.body.nodes[e].x+=t}}class wt extends yt{constructor(e){super(),this.layout=e}curveType(){return"vertical"}getPosition(e){return e.y}setPosition(e,t,i){void 0!==i&&this.layout.hierarchical.addToOrdering(e,i),e.y=t}getTreeSize(e){let t=this.layout.hierarchical.getTreeSize(this.layout.body.nodes,e);return{min:t.min_y,max:t.max_y}}sort(e){a.sort(e,(function(e,t){return e.y-t.y}))}fix(e,t){e.x=this.layout.options.hierarchical.levelSeparation*t,e.options.fixed.x=!0}shift(e,t){this.layout.body.nodes[e].y+=t}}function _t(e,t){const i=new Set;return e.forEach(e=>{e.edges.forEach(e=>{e.connected&&i.add(e)})}),i.forEach(e=>{const i=e.from.id,o=e.to.id;null==t[i]&&(t[i]=0),(null==t[o]||t[i]>=t[o])&&(t[o]=t[i]+1)}),t}function xt(e,t,i,o,s){const n=o.size,r=i+"Id",a="to"===i?1:-1;for(const[h,d]of o){if(!o.has(h)||!e(d))continue;s[h]=0;const l=[d];let c,p=0;for(;c=l.pop();){if(!o.has(h))continue;const e=s[c.id]+a;if(c.edges.filter(e=>e.connected&&e.to!==e.from&&e[i]!==c&&o.has(e.toId)&&o.has(e.fromId)).forEach(o=>{const n=o[r],a=s[n];(null==a||t(e,a))&&(s[n]=e,l.push(o[i]))}),p>n)return _t(o,s);++p}}return s}class Et{constructor(){this.childrenReference={},this.parentReference={},this.trees={},this.distributionOrdering={},this.levels={},this.distributionIndex={},this.isTree=!1,this.treeIndex=-1}addRelation(e,t){void 0===this.childrenReference[e]&&(this.childrenReference[e]=[]),this.childrenReference[e].push(t),void 0===this.parentReference[t]&&(this.parentReference[t]=[]),this.parentReference[t].push(e)}checkIfTree(){for(let e in this.parentReference)if(this.parentReference[e].length>1)return void(this.isTree=!1);this.isTree=!0}numTrees(){return this.treeIndex+1}setTreeIndex(e,t){void 0!==t&&void 0===this.trees[e.id]&&(this.trees[e.id]=t,this.treeIndex=Math.max(t,this.treeIndex))}ensureLevel(e){void 0===this.levels[e]&&(this.levels[e]=0)}getMaxLevel(e){let t={},i=e=>{if(void 0!==t[e])return t[e];let o=this.levels[e];if(this.childrenReference[e]){let t=this.childrenReference[e];if(t.length>0)for(let e=0;e<t.length;e++)o=Math.max(o,i(t[e]))}return t[e]=o,o};return i(e)}levelDownstream(e,t){void 0===this.levels[t.id]&&(void 0===this.levels[e.id]&&(this.levels[e.id]=0),this.levels[t.id]=this.levels[e.id]+1)}setMinLevelToZero(e){let t=1e9;for(let i in e)e.hasOwnProperty(i)&&void 0!==this.levels[i]&&(t=Math.min(this.levels[i],t));for(let i in e)e.hasOwnProperty(i)&&void 0!==this.levels[i]&&(this.levels[i]-=t)}getTreeSize(e,t){let i=1e9,o=-1e9,s=1e9,n=-1e9;for(let r in this.trees)if(this.trees.hasOwnProperty(r)&&this.trees[r]===t){let t=e[r];i=Math.min(t.x,i),o=Math.max(t.x,o),s=Math.min(t.y,s),n=Math.max(t.y,n)}return{min_x:i,max_x:o,min_y:s,max_y:n}}hasSameParent(e,t){let i=this.parentReference[e.id],o=this.parentReference[t.id];if(void 0===i||void 0===o)return!1;for(let e=0;e<i.length;e++)for(let t=0;t<o.length;t++)if(i[e]==o[t])return!0;return!1}inSameSubNetwork(e,t){return this.trees[e.id]===this.trees[t.id]}getLevels(){return Object.keys(this.distributionOrdering)}addToOrdering(e,t){void 0===this.distributionOrdering[t]&&(this.distributionOrdering[t]=[]);var i=!1,o=this.distributionOrdering[t];for(var s in o)if(o[s]===e){i=!0;break}i||(this.distributionOrdering[t].push(e),this.distributionIndex[e.id]=this.distributionOrdering[t].length-1)}}class Ot{constructor(e){this.body=e,this._resetRNG(Math.random()+":"+Date.now()),this.setPhysics=!1,this.options={},this.optionsBackup={physics:{}},this.defaultOptions={randomSeed:void 0,improvedLayout:!0,clusterThreshold:150,hierarchical:{enabled:!1,levelSeparation:150,nodeSpacing:100,treeSpacing:200,blockShifting:!0,edgeMinimization:!0,parentCentralization:!0,direction:"UD",sortMethod:"hubsize"}},Object.assign(this.options,this.defaultOptions),this.bindEventListeners()}bindEventListeners(){this.body.emitter.on("_dataChanged",()=>{this.setupHierarchicalLayout()}),this.body.emitter.on("_dataLoaded",()=>{this.layoutNetwork()}),this.body.emitter.on("_resetHierarchicalLayout",()=>{this.setupHierarchicalLayout()}),this.body.emitter.on("_adjustEdgesForHierarchicalLayout",()=>{if(!0!==this.options.hierarchical.enabled)return;let e=this.direction.curveType();this.body.emitter.emit("_forceDisableDynamicCurves",e,!1)})}setOptions(e,t){if(void 0!==e){let o=this.options.hierarchical,s=o.enabled;if(i.selectiveDeepExtend(["randomSeed","improvedLayout","clusterThreshold"],this.options,e),i.mergeOptions(this.options,e,"hierarchical"),void 0!==e.randomSeed&&this._resetRNG(e.randomSeed),!0===o.enabled)return!0===s&&this.body.emitter.emit("refresh",!0),"RL"===o.direction||"DU"===o.direction?o.levelSeparation>0&&(o.levelSeparation*=-1):o.levelSeparation<0&&(o.levelSeparation*=-1),this.setDirectionStrategy(),this.body.emitter.emit("_resetHierarchicalLayout"),this.adaptAllOptionsForHierarchicalLayout(t);if(!0===s)return this.body.emitter.emit("refresh"),i.deepExtend(t,this.optionsBackup)}return t}_resetRNG(e){this.initialRandomSeed=e,this._rng=i.Alea(this.initialRandomSeed)}adaptAllOptionsForHierarchicalLayout(e){if(!0===this.options.hierarchical.enabled){let t=this.optionsBackup.physics;void 0===e.physics||!0===e.physics?(e.physics={enabled:void 0===t.enabled||t.enabled,solver:"hierarchicalRepulsion"},t.enabled=void 0===t.enabled||t.enabled,t.solver=t.solver||"barnesHut"):"object"==typeof e.physics?(t.enabled=void 0===e.physics.enabled||e.physics.enabled,t.solver=e.physics.solver||"barnesHut",e.physics.solver="hierarchicalRepulsion"):!1!==e.physics&&(t.solver="barnesHut",e.physics={solver:"hierarchicalRepulsion"});let i=this.direction.curveType();if(void 0===e.edges)this.optionsBackup.edges={smooth:{enabled:!0,type:"dynamic"}},e.edges={smooth:!1};else if(void 0===e.edges.smooth)this.optionsBackup.edges={smooth:{enabled:!0,type:"dynamic"}},e.edges.smooth=!1;else if("boolean"==typeof e.edges.smooth)this.optionsBackup.edges={smooth:e.edges.smooth},e.edges.smooth={enabled:e.edges.smooth,type:i};else{let t=e.edges.smooth;void 0!==t.type&&"dynamic"!==t.type&&(i=t.type),this.optionsBackup.edges={smooth:{enabled:void 0===t.enabled||t.enabled,type:void 0===t.type?"dynamic":t.type,roundness:void 0===t.roundness?.5:t.roundness,forceDirection:void 0!==t.forceDirection&&t.forceDirection}},e.edges.smooth={enabled:void 0===t.enabled||t.enabled,type:i,roundness:void 0===t.roundness?.5:t.roundness,forceDirection:void 0!==t.forceDirection&&t.forceDirection}}this.body.emitter.emit("_forceDisableDynamicCurves",i)}return e}positionInitially(e){if(!0!==this.options.hierarchical.enabled){this._resetRNG(this.initialRandomSeed);let t=e.length+50;for(let i=0;i<e.length;i++){let o=e[i],s=2*Math.PI*this._rng();void 0===o.x&&(o.x=t*Math.cos(s)),void 0===o.y&&(o.y=t*Math.sin(s))}}}layoutNetwork(){if(!0!==this.options.hierarchical.enabled&&!0===this.options.improvedLayout){let e=this.body.nodeIndices,t=0;for(let i=0;i<e.length;i++){!0===this.body.nodes[e[i]].predefinedPosition&&(t+=1)}if(t<.5*e.length){let t=10,i=0,o=this.options.clusterThreshold,s={clusterNodeProperties:{shape:"ellipse",label:"",group:"",font:{multi:!1}},clusterEdgeProperties:{label:"",font:{multi:!1},smooth:{enabled:!1}}};if(e.length>o){let n=e.length;for(;e.length>o&&i<=t;){i+=1;let t=e.length;if(i%3==0?this.body.modules.clustering.clusterBridges(s):this.body.modules.clustering.clusterOutliers(s),t==e.length&&i%3!=0)return this._declusterAll(),this.body.emitter.emit("_layoutFailed"),void console.info("This network could not be positioned by this version of the improved layout algorithm. Please disable improvedLayout for better performance.")}this.body.modules.kamadaKawai.setOptions({springLength:Math.max(150,2*n)})}i>t&&console.info("The clustering didn't succeed within the amount of interations allowed, progressing with partial result."),this.body.modules.kamadaKawai.solve(e,this.body.edgeIndices,!0),this._shiftToCenter();let n=70;for(let t=0;t<e.length;t++){let i=this.body.nodes[e[t]];!1===i.predefinedPosition&&(i.x+=(.5-this._rng())*n,i.y+=(.5-this._rng())*n)}this._declusterAll(),this.body.emitter.emit("_repositionBezierNodes")}}}_shiftToCenter(){let e=rt.getRangeCore(this.body.nodes,this.body.nodeIndices),t=rt.findCenter(e);for(let e=0;e<this.body.nodeIndices.length;e++){let i=this.body.nodes[this.body.nodeIndices[e]];i.x-=t.x,i.y-=t.y}}_declusterAll(){let e=!0;for(;!0===e;){e=!1;for(let t=0;t<this.body.nodeIndices.length;t++)!0===this.body.nodes[this.body.nodeIndices[t]].isCluster&&(e=!0,this.body.modules.clustering.openCluster(this.body.nodeIndices[t],{},!1));!0===e&&this.body.emitter.emit("_dataChanged")}}getSeed(){return this.initialRandomSeed}setupHierarchicalLayout(){if(!0===this.options.hierarchical.enabled&&this.body.nodeIndices.length>0){let e,t,i=!1,o=!1;for(t in this.lastNodeOnLevel={},this.hierarchical=new Et,this.body.nodes)this.body.nodes.hasOwnProperty(t)&&(e=this.body.nodes[t],void 0!==e.options.level?(i=!0,this.hierarchical.levels[t]=e.options.level):o=!0);if(!0===o&&!0===i)throw new Error("To use the hierarchical layout, nodes require either no predefined levels or levels have to be defined for all nodes.");{if(!0===o){let e=this.options.hierarchical.sortMethod;"hubsize"===e?this._determineLevelsByHubsize():"directed"===e?this._determineLevelsDirected():"custom"===e&&this._determineLevelsCustomCallback()}for(let e in this.body.nodes)this.body.nodes.hasOwnProperty(e)&&this.hierarchical.ensureLevel(e);let e=this._getDistribution();this._generateMap(),this._placeNodesByHierarchy(e),this._condenseHierarchy(),this._shiftToCenter()}}}_condenseHierarchy(){let e=!1,t={},i=(e,t)=>{let i=this.hierarchical.trees;for(let o in i)i.hasOwnProperty(o)&&i[o]===e&&this.direction.shift(o,t)},o=()=>{let e=[];for(let t=0;t<this.hierarchical.numTrees();t++)e.push(this.direction.getTreeSize(t));return e},s=(e,t)=>{if(!t[e.id]&&(t[e.id]=!0,this.hierarchical.childrenReference[e.id])){let i=this.hierarchical.childrenReference[e.id];if(i.length>0)for(let e=0;e<i.length;e++)s(this.body.nodes[i[e]],t)}},n=(e,t=1e9)=>{let i=1e9,o=1e9,s=1e9,n=-1e9;for(let r in e)if(e.hasOwnProperty(r)){let a=this.body.nodes[r],h=this.hierarchical.levels[a.id],d=this.direction.getPosition(a),[l,c]=this._getSpaceAroundNode(a,e);i=Math.min(l,i),o=Math.min(c,o),h<=t&&(s=Math.min(d,s),n=Math.max(d,n))}return[s,n,i,o]},r=(e,t)=>{let i=this.hierarchical.getMaxLevel(e.id),o=this.hierarchical.getMaxLevel(t.id);return Math.min(i,o)},a=(e,t,i)=>{let o=this.hierarchical;for(let s=0;s<t.length;s++){let n=t[s],r=o.distributionOrdering[n];if(r.length>1)for(let t=0;t<r.length-1;t++){let s=r[t],n=r[t+1];o.hasSameParent(s,n)&&o.inSameSubNetwork(s,n)&&e(s,n,i)}}},h=(t,i,o=!1)=>{let a=this.direction.getPosition(t),h=this.direction.getPosition(i),d=Math.abs(h-a),l=this.options.hierarchical.nodeSpacing;if(d>l){let a={},h={};s(t,a),s(i,h);let d=r(t,i),c=n(a,d),p=n(h,d),u=c[1],g=p[0],m=p[2];if(Math.abs(u-g)>l){let t=u-g+l;t<-m+l&&(t=-m+l),t<0&&(this._shiftBlock(i.id,t),e=!0,!0===o&&this._centerParent(i))}}},d=(i,o)=>{let r=o.id,a=o.edges,h=this.hierarchical.levels[o.id],d=this.options.hierarchical.levelSeparation*this.options.hierarchical.levelSeparation,l={},c=[];for(let e=0;e<a.length;e++){let t=a[e];if(t.toId!=t.fromId){let i=t.toId==r?t.from:t.to;l[a[e].id]=i,this.hierarchical.levels[i.id]<h&&c.push(t)}}let p=(e,t)=>{let i=0;for(let o=0;o<t.length;o++)if(void 0!==l[t[o].id]){let s=this.direction.getPosition(l[t[o].id])-e;i+=s/Math.sqrt(s*s+d)}return i},u=(e,t)=>{let i=0;for(let o=0;o<t.length;o++)if(void 0!==l[t[o].id]){let s=this.direction.getPosition(l[t[o].id])-e;i-=d*Math.pow(s*s+d,-1.5)}return i},g=(e,t)=>{let i=this.direction.getPosition(o),s={};for(let o=0;o<e;o++){let e=p(i,t),n=u(i,t),r=40;if(i-=Math.max(-r,Math.min(r,Math.round(e/n))),void 0!==s[i])break;s[i]=o}return i},m=g(i,c);(i=>{let r=this.direction.getPosition(o);if(void 0===t[o.id]){let e={};s(o,e),t[o.id]=e}let a=n(t[o.id]),h=a[2],d=a[3],l=i-r,c=0;l>0?c=Math.min(l,d-this.options.hierarchical.nodeSpacing):l<0&&(c=-Math.min(-l,h-this.options.hierarchical.nodeSpacing)),0!=c&&(this._shiftBlock(o.id,c),e=!0)})(m),m=g(i,a),(t=>{let i=this.direction.getPosition(o),[s,n]=this._getSpaceAroundNode(o),r=t-i,a=i;r>0?a=Math.min(i+(n-this.options.hierarchical.nodeSpacing),t):r<0&&(a=Math.max(i-(s-this.options.hierarchical.nodeSpacing),t)),a!==i&&(this.direction.setPosition(o,a),e=!0)})(m)},l=t=>{let i=this.hierarchical.getLevels();i=i.reverse();for(let o=0;o<t;o++){e=!1;for(let e=0;e<i.length;e++){let t=i[e],o=this.hierarchical.distributionOrdering[t];for(let e=0;e<o.length;e++)d(1e3,o[e])}if(!0!==e)break}},c=t=>{let i=this.hierarchical.getLevels();i=i.reverse();for(let o=0;o<t&&(e=!1,a(h,i,!0),!0===e);o++);},p=()=>{for(let e in this.body.nodes)this.body.nodes.hasOwnProperty(e)&&this._centerParent(this.body.nodes[e])},u=()=>{let e=this.hierarchical.getLevels();e=e.reverse();for(let t=0;t<e.length;t++){let i=e[t],o=this.hierarchical.distributionOrdering[i];for(let e=0;e<o.length;e++)this._centerParent(o[e])}};!0===this.options.hierarchical.blockShifting&&(c(5),p()),!0===this.options.hierarchical.edgeMinimization&&l(20),!0===this.options.hierarchical.parentCentralization&&u(),(()=>{let e=o(),t=0;for(let o=0;o<e.length-1;o++){t+=e[o].max-e[o+1].min+this.options.hierarchical.treeSpacing,i(o+1,t)}})()}_getSpaceAroundNode(e,t){let i=!0;void 0===t&&(i=!1);let o=this.hierarchical.levels[e.id];if(void 0!==o){let s=this.hierarchical.distributionIndex[e.id],n=this.direction.getPosition(e),r=this.hierarchical.distributionOrdering[o],a=1e9,h=1e9;if(0!==s){let e=r[s-1];if(!0===i&&void 0===t[e.id]||!1===i){a=n-this.direction.getPosition(e)}}if(s!=r.length-1){let e=r[s+1];if(!0===i&&void 0===t[e.id]||!1===i){let t=this.direction.getPosition(e);h=Math.min(h,t-n)}}return[a,h]}return[0,0]}_centerParent(e){if(this.hierarchical.parentReference[e.id]){let i=this.hierarchical.parentReference[e.id];for(var t=0;t<i.length;t++){let e=i[t],o=this.body.nodes[e],s=this.hierarchical.childrenReference[e];if(void 0!==s){let e=this._getCenterPosition(s),t=this.direction.getPosition(o),[i,n]=this._getSpaceAroundNode(o),r=t-e;(r<0&&Math.abs(r)<n-this.options.hierarchical.nodeSpacing||r>0&&Math.abs(r)<i-this.options.hierarchical.nodeSpacing)&&this.direction.setPosition(o,e)}}}}_placeNodesByHierarchy(e){this.positionedNodes={};for(let t in e)if(e.hasOwnProperty(t)){let i=Object.keys(e[t]);i=this._indexArrayToNodes(i),this.direction.sort(i);let o=0;for(let e=0;e<i.length;e++){let s=i[e];if(void 0===this.positionedNodes[s.id]){let n=this.options.hierarchical.nodeSpacing,r=n*o;o>0&&(r=this.direction.getPosition(i[e-1])+n),this.direction.setPosition(s,r,t),this._validatePositionAndContinue(s,t,r),o++}}}}_placeBranchNodes(e,t){let i=this.hierarchical.childrenReference[e];if(void 0===i)return;let o=[];for(let e=0;e<i.length;e++)o.push(this.body.nodes[i[e]]);this.direction.sort(o);for(let i=0;i<o.length;i++){let s=o[i],n=this.hierarchical.levels[s.id];if(!(n>t&&void 0===this.positionedNodes[s.id]))return;{let t,r=this.options.hierarchical.nodeSpacing;t=0===i?this.direction.getPosition(this.body.nodes[e]):this.direction.getPosition(o[i-1])+r,this.direction.setPosition(s,t,n),this._validatePositionAndContinue(s,n,t)}}let s=this._getCenterPosition(o);this.direction.setPosition(this.body.nodes[e],s,t)}_validatePositionAndContinue(e,t,i){if(this.hierarchical.isTree){if(void 0!==this.lastNodeOnLevel[t]){let o=this.direction.getPosition(this.body.nodes[this.lastNodeOnLevel[t]]);if(i-o<this.options.hierarchical.nodeSpacing){let s=o+this.options.hierarchical.nodeSpacing-i,n=this._findCommonParent(this.lastNodeOnLevel[t],e.id);this._shiftBlock(n.withChild,s)}}this.lastNodeOnLevel[t]=e.id,this.positionedNodes[e.id]=!0,this._placeBranchNodes(e.id,t)}}_indexArrayToNodes(e){let t=[];for(let i=0;i<e.length;i++)t.push(this.body.nodes[e[i]]);return t}_getDistribution(){let e,t,i={};for(e in this.body.nodes)if(this.body.nodes.hasOwnProperty(e)){t=this.body.nodes[e];let o=void 0===this.hierarchical.levels[e]?0:this.hierarchical.levels[e];this.direction.fix(t,o),void 0===i[o]&&(i[o]={}),i[o][e]=t}return i}_getActiveEdges(e){let t=[];return i.forEach(e.edges,e=>{-1!==this.body.edgeIndices.indexOf(e.id)&&t.push(e)}),t}_getHubSizes(){let e={},t=this.body.nodeIndices;i.forEach(t,t=>{let i=this.body.nodes[t],o=this._getActiveEdges(i).length;e[o]=!0});let o=[];return i.forEach(e,e=>{o.push(Number(e))}),h.sort(o,(function(e,t){return t-e})),o}_determineLevelsByHubsize(){let e=(e,t)=>{this.hierarchical.levelDownstream(e,t)},t=this._getHubSizes();for(let o=0;o<t.length;++o){let s=t[o];if(0===s)break;i.forEach(this.body.nodeIndices,t=>{let i=this.body.nodes[t];s===this._getActiveEdges(i).length&&this._crawlNetwork(e,t)})}}_determineLevelsCustomCallback(){this._crawlNetwork((e,t,i)=>{let o=this.hierarchical.levels[e.id];void 0===o&&(o=this.hierarchical.levels[e.id]=1e5);let s=(rt.cloneOptions(e,"node"),rt.cloneOptions(t,"node"),void rt.cloneOptions(i,"edge"));this.hierarchical.levels[t.id]=o+s}),this.hierarchical.setMinLevelToZero(this.body.nodes)}_determineLevelsDirected(){const e=this.body.nodeIndices.reduce((e,t)=>(e.set(t,this.body.nodes[t]),e),new Map),t=this.hierarchical.levels;"roots"===this.options.hierarchical.shakeTowards?this.hierarchical.levels=function(e,t=Object.create(null)){return xt(t=>t.edges.filter(t=>e.has(t.toId)).every(e=>e.from===t),(e,t)=>t<e,"to",e,t)}(e,t):this.hierarchical.levels=function(e,t=Object.create(null)){return xt(t=>t.edges.filter(t=>e.has(t.toId)).every(e=>e.to===t),(e,t)=>t>e,"from",e,t)}(e,t),this.hierarchical.setMinLevelToZero(this.body.nodes)}_generateMap(){this._crawlNetwork((e,t)=>{this.hierarchical.levels[t.id]>this.hierarchical.levels[e.id]&&this.hierarchical.addRelation(e.id,t.id)}),this.hierarchical.checkIfTree()}_crawlNetwork(e=function(){},t){let i={},o=(t,s)=>{if(void 0===i[t.id]){let n;this.hierarchical.setTreeIndex(t,s),i[t.id]=!0;let r=this._getActiveEdges(t);for(let i=0;i<r.length;i++){let a=r[i];!0===a.connected&&(n=a.toId==t.id?a.from:a.to,t.id!=n.id&&(e(t,n,a),o(n,s)))}}};if(void 0===t){let e=0;for(let t=0;t<this.body.nodeIndices.length;t++){let s=this.body.nodeIndices[t];if(void 0===i[s]){let t=this.body.nodes[s];o(t,e),e+=1}}}else{let e=this.body.nodes[t];if(void 0===e)return void console.error("Node not found:",t);o(e)}}_shiftBlock(e,t){let i={},o=e=>{if(i[e])return;i[e]=!0,this.direction.shift(e,t);let s=this.hierarchical.childrenReference[e];if(void 0!==s)for(let e=0;e<s.length;e++)o(s[e])};o(e)}_findCommonParent(e,t){let i={},o=(e,t)=>{let i=this.hierarchical.parentReference[t];if(void 0!==i)for(let t=0;t<i.length;t++){let s=i[t];e[s]=!0,o(e,s)}},s=(e,t)=>{let i=this.hierarchical.parentReference[t];if(void 0!==i)for(let o=0;o<i.length;o++){let n=i[o];if(void 0!==e[n])return{foundParent:n,withChild:t};let r=s(e,n);if(null!==r.foundParent)return r}return{foundParent:null,withChild:t}};return o(i,e),s(i,t)}setDirectionStrategy(){var e="UD"===this.options.hierarchical.direction||"DU"===this.options.hierarchical.direction;this.direction=e?new vt(this):new wt(this)}_getCenterPosition(e){let t=1e9,i=-1e9;for(let o=0;o<e.length;o++){let s;if(void 0!==e[o].id)s=e[o];else{let t=e[o];s=this.body.nodes[t]}let n=this.direction.getPosition(s);t=Math.min(t,n),i=Math.max(i,n)}return.5*(t+i)}}class Ct{constructor(e,t,i,o){this.body=e,this.canvas=t,this.selectionHandler=i,this.interactionHandler=o,this.editMode=!1,this.manipulationDiv=void 0,this.editModeDiv=void 0,this.closeDiv=void 0,this.manipulationHammers=[],this.temporaryUIFunctions={},this.temporaryEventFunctions=[],this.touchTime=0,this.temporaryIds={nodes:[],edges:[]},this.guiEnabled=!1,this.inMode=!1,this.selectedControlNode=void 0,this.options={},this.defaultOptions={enabled:!1,initiallyActive:!1,addNode:!0,addEdge:!0,editNode:void 0,editEdge:!0,deleteNode:!0,deleteEdge:!0,controlNodeStyle:{shape:"dot",size:6,color:{background:"#ff0000",border:"#3c3c3c",highlight:{background:"#07f968",border:"#3c3c3c"}},borderWidth:2,borderWidthSelected:2}},Object.assign(this.options,this.defaultOptions),this.body.emitter.on("destroy",()=>{this._clean()}),this.body.emitter.on("_dataChanged",this._restore.bind(this)),this.body.emitter.on("_resetData",this._restore.bind(this))}_restore(){!1!==this.inMode&&(!0===this.options.initiallyActive?this.enableEditMode():this.disableEditMode())}setOptions(e,t,o){void 0!==t&&(void 0!==t.locale?this.options.locale=t.locale:this.options.locale=o.locale,void 0!==t.locales?this.options.locales=t.locales:this.options.locales=o.locales),void 0!==e&&("boolean"==typeof e?this.options.enabled=e:(this.options.enabled=!0,i.deepExtend(this.options,e)),!0===this.options.initiallyActive&&(this.editMode=!0),this._setup())}toggleEditMode(){!0===this.editMode?this.disableEditMode():this.enableEditMode()}enableEditMode(){this.editMode=!0,this._clean(),!0===this.guiEnabled&&(this.manipulationDiv.style.display="block",this.closeDiv.style.display="block",this.editModeDiv.style.display="none",this.showManipulatorToolbar())}disableEditMode(){this.editMode=!1,this._clean(),!0===this.guiEnabled&&(this.manipulationDiv.style.display="none",this.closeDiv.style.display="none",this.editModeDiv.style.display="block",this._createEditButton())}showManipulatorToolbar(){if(this._clean(),this.manipulationDOM={},!0===this.guiEnabled){this.editMode=!0,this.manipulationDiv.style.display="block",this.closeDiv.style.display="block";let e=this.selectionHandler._getSelectedNodeCount(),t=this.selectionHandler._getSelectedEdgeCount(),i=e+t,o=this.options.locales[this.options.locale],s=!1;!1!==this.options.addNode&&(this._createAddNodeButton(o),s=!0),!1!==this.options.addEdge&&(!0===s?this._createSeperator(1):s=!0,this._createAddEdgeButton(o)),1===e&&"function"==typeof this.options.editNode?(!0===s?this._createSeperator(2):s=!0,this._createEditNodeButton(o)):1===t&&0===e&&!1!==this.options.editEdge&&(!0===s?this._createSeperator(3):s=!0,this._createEditEdgeButton(o)),0!==i&&(e>0&&!1!==this.options.deleteNode||0===e&&!1!==this.options.deleteEdge)&&(!0===s&&this._createSeperator(4),this._createDeleteButton(o)),this._bindHammerToDiv(this.closeDiv,this.toggleEditMode.bind(this)),this._temporaryBindEvent("select",this.showManipulatorToolbar.bind(this))}this.body.emitter.emit("_redraw")}addNodeMode(){if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="addNode",!0===this.guiEnabled){let e=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(e),this._createSeperator(),this._createDescription(e.addDescription||this.options.locales.en.addDescription),this._bindHammerToDiv(this.closeDiv,this.toggleEditMode.bind(this))}this._temporaryBindEvent("click",this._performAddNode.bind(this))}editNode(){!0!==this.editMode&&this.enableEditMode(),this._clean();let e=this.selectionHandler._getSelectedNode();if(void 0!==e){if(this.inMode="editNode","function"!=typeof this.options.editNode)throw new Error("No function has been configured to handle the editing of nodes.");if(!0!==e.isCluster){let t=i.deepExtend({},e.options,!1);if(t.x=e.x,t.y=e.y,2!==this.options.editNode.length)throw new Error("The function for edit does not support two arguments (data, callback)");this.options.editNode(t,e=>{null!=e&&"editNode"===this.inMode&&this.body.data.nodes.getDataSet().update(e),this.showManipulatorToolbar()})}else alert(this.options.locales[this.options.locale].editClusterError||this.options.locales.en.editClusterError)}else this.showManipulatorToolbar()}addEdgeMode(){if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="addEdge",!0===this.guiEnabled){let e=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(e),this._createSeperator(),this._createDescription(e.edgeDescription||this.options.locales.en.edgeDescription),this._bindHammerToDiv(this.closeDiv,this.toggleEditMode.bind(this))}this._temporaryBindUI("onTouch",this._handleConnect.bind(this)),this._temporaryBindUI("onDragEnd",this._finishConnect.bind(this)),this._temporaryBindUI("onDrag",this._dragControlNode.bind(this)),this._temporaryBindUI("onRelease",this._finishConnect.bind(this)),this._temporaryBindUI("onDragStart",this._dragStartEdge.bind(this)),this._temporaryBindUI("onHold",()=>{})}editEdgeMode(){if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="editEdge","object"!=typeof this.options.editEdge||"function"!=typeof this.options.editEdge.editWithoutDrag||(this.edgeBeingEditedId=this.selectionHandler.getSelectedEdges()[0],void 0===this.edgeBeingEditedId)){if(!0===this.guiEnabled){let e=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(e),this._createSeperator(),this._createDescription(e.editEdgeDescription||this.options.locales.en.editEdgeDescription),this._bindHammerToDiv(this.closeDiv,this.toggleEditMode.bind(this))}if(this.edgeBeingEditedId=this.selectionHandler.getSelectedEdges()[0],void 0!==this.edgeBeingEditedId){let e=this.body.edges[this.edgeBeingEditedId],t=this._getNewTargetNode(e.from.x,e.from.y),i=this._getNewTargetNode(e.to.x,e.to.y);this.temporaryIds.nodes.push(t.id),this.temporaryIds.nodes.push(i.id),this.body.nodes[t.id]=t,this.body.nodeIndices.push(t.id),this.body.nodes[i.id]=i,this.body.nodeIndices.push(i.id),this._temporaryBindUI("onTouch",this._controlNodeTouch.bind(this)),this._temporaryBindUI("onTap",()=>{}),this._temporaryBindUI("onHold",()=>{}),this._temporaryBindUI("onDragStart",this._controlNodeDragStart.bind(this)),this._temporaryBindUI("onDrag",this._controlNodeDrag.bind(this)),this._temporaryBindUI("onDragEnd",this._controlNodeDragEnd.bind(this)),this._temporaryBindUI("onMouseMove",()=>{}),this._temporaryBindEvent("beforeDrawing",o=>{let s=e.edgeType.findBorderPositions(o);!1===t.selected&&(t.x=s.from.x,t.y=s.from.y),!1===i.selected&&(i.x=s.to.x,i.y=s.to.y)}),this.body.emitter.emit("_redraw")}else this.showManipulatorToolbar()}else{var e=this.body.edges[this.edgeBeingEditedId];this._performEditEdge(e.from.id,e.to.id)}}deleteSelected(){!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="delete";let e=this.selectionHandler.getSelectedNodes(),t=this.selectionHandler.getSelectedEdges(),i=void 0;if(e.length>0){for(let t=0;t<e.length;t++)if(!0===this.body.nodes[e[t]].isCluster)return void alert(this.options.locales[this.options.locale].deleteClusterError||this.options.locales.en.deleteClusterError);"function"==typeof this.options.deleteNode&&(i=this.options.deleteNode)}else t.length>0&&"function"==typeof this.options.deleteEdge&&(i=this.options.deleteEdge);if("function"==typeof i){let o={nodes:e,edges:t};if(2!==i.length)throw new Error("The function for delete does not support two arguments (data, callback)");i(o,e=>{null!=e&&"delete"===this.inMode?(this.body.data.edges.getDataSet().remove(e.edges),this.body.data.nodes.getDataSet().remove(e.nodes),this.body.emitter.emit("startSimulation"),this.showManipulatorToolbar()):(this.body.emitter.emit("startSimulation"),this.showManipulatorToolbar())})}else this.body.data.edges.getDataSet().remove(t),this.body.data.nodes.getDataSet().remove(e),this.body.emitter.emit("startSimulation"),this.showManipulatorToolbar()}_setup(){!0===this.options.enabled?(this.guiEnabled=!0,this._createWrappers(),!1===this.editMode?this._createEditButton():this.showManipulatorToolbar()):(this._removeManipulationDOM(),this.guiEnabled=!1)}_createWrappers(){void 0===this.manipulationDiv&&(this.manipulationDiv=document.createElement("div"),this.manipulationDiv.className="vis-manipulation",!0===this.editMode?this.manipulationDiv.style.display="block":this.manipulationDiv.style.display="none",this.canvas.frame.appendChild(this.manipulationDiv)),void 0===this.editModeDiv&&(this.editModeDiv=document.createElement("div"),this.editModeDiv.className="vis-edit-mode",!0===this.editMode?this.editModeDiv.style.display="none":this.editModeDiv.style.display="block",this.canvas.frame.appendChild(this.editModeDiv)),void 0===this.closeDiv&&(this.closeDiv=document.createElement("div"),this.closeDiv.className="vis-close",this.closeDiv.style.display=this.manipulationDiv.style.display,this.canvas.frame.appendChild(this.closeDiv))}_getNewTargetNode(e,t){let o=i.deepExtend({},this.options.controlNodeStyle);o.id="targetNode"+r.v4(),o.hidden=!1,o.physics=!1,o.x=e,o.y=t;let s=this.body.functions.createNode(o);return s.shape.boundingBox={left:e,right:e,top:t,bottom:t},s}_createEditButton(){this._clean(),this.manipulationDOM={},i.recursiveDOMDelete(this.editModeDiv);let e=this.options.locales[this.options.locale],t=this._createButton("editMode","vis-button vis-edit vis-edit-mode",e.edit||this.options.locales.en.edit);this.editModeDiv.appendChild(t),this._bindHammerToDiv(t,this.toggleEditMode.bind(this))}_clean(){this.inMode=!1,!0===this.guiEnabled&&(i.recursiveDOMDelete(this.editModeDiv),i.recursiveDOMDelete(this.manipulationDiv),this._cleanManipulatorHammers()),this._cleanupTemporaryNodesAndEdges(),this._unbindTemporaryUIs(),this._unbindTemporaryEvents(),this.body.emitter.emit("restorePhysics")}_cleanManipulatorHammers(){if(0!=this.manipulationHammers.length){for(let e=0;e<this.manipulationHammers.length;e++)this.manipulationHammers[e].destroy();this.manipulationHammers=[]}}_removeManipulationDOM(){this._clean(),i.recursiveDOMDelete(this.manipulationDiv),i.recursiveDOMDelete(this.editModeDiv),i.recursiveDOMDelete(this.closeDiv),this.manipulationDiv&&this.canvas.frame.removeChild(this.manipulationDiv),this.editModeDiv&&this.canvas.frame.removeChild(this.editModeDiv),this.closeDiv&&this.canvas.frame.removeChild(this.closeDiv),this.manipulationDiv=void 0,this.editModeDiv=void 0,this.closeDiv=void 0}_createSeperator(e=1){this.manipulationDOM["seperatorLineDiv"+e]=document.createElement("div"),this.manipulationDOM["seperatorLineDiv"+e].className="vis-separator-line",this.manipulationDiv.appendChild(this.manipulationDOM["seperatorLineDiv"+e])}_createAddNodeButton(e){let t=this._createButton("addNode","vis-button vis-add",e.addNode||this.options.locales.en.addNode);this.manipulationDiv.appendChild(t),this._bindHammerToDiv(t,this.addNodeMode.bind(this))}_createAddEdgeButton(e){let t=this._createButton("addEdge","vis-button vis-connect",e.addEdge||this.options.locales.en.addEdge);this.manipulationDiv.appendChild(t),this._bindHammerToDiv(t,this.addEdgeMode.bind(this))}_createEditNodeButton(e){let t=this._createButton("editNode","vis-button vis-edit",e.editNode||this.options.locales.en.editNode);this.manipulationDiv.appendChild(t),this._bindHammerToDiv(t,this.editNode.bind(this))}_createEditEdgeButton(e){let t=this._createButton("editEdge","vis-button vis-edit",e.editEdge||this.options.locales.en.editEdge);this.manipulationDiv.appendChild(t),this._bindHammerToDiv(t,this.editEdgeMode.bind(this))}_createDeleteButton(e){var t;t=this.options.rtl?"vis-button vis-delete-rtl":"vis-button vis-delete";let i=this._createButton("delete",t,e.del||this.options.locales.en.del);this.manipulationDiv.appendChild(i),this._bindHammerToDiv(i,this.deleteSelected.bind(this))}_createBackButton(e){let t=this._createButton("back","vis-button vis-back",e.back||this.options.locales.en.back);this.manipulationDiv.appendChild(t),this._bindHammerToDiv(t,this.showManipulatorToolbar.bind(this))}_createButton(e,t,i,o="vis-label"){return this.manipulationDOM[e+"Div"]=document.createElement("div"),this.manipulationDOM[e+"Div"].className=t,this.manipulationDOM[e+"Label"]=document.createElement("div"),this.manipulationDOM[e+"Label"].className=o,this.manipulationDOM[e+"Label"].innerHTML=i,this.manipulationDOM[e+"Div"].appendChild(this.manipulationDOM[e+"Label"]),this.manipulationDOM[e+"Div"]}_createDescription(e){this.manipulationDiv.appendChild(this._createButton("description","vis-button vis-none",e))}_temporaryBindEvent(e,t){this.temporaryEventFunctions.push({event:e,boundFunction:t}),this.body.emitter.on(e,t)}_temporaryBindUI(e,t){if(void 0===this.body.eventListeners[e])throw new Error("This UI function does not exist. Typo? You tried: "+e+" possible are: "+JSON.stringify(Object.keys(this.body.eventListeners)));this.temporaryUIFunctions[e]=this.body.eventListeners[e],this.body.eventListeners[e]=t}_unbindTemporaryUIs(){for(let e in this.temporaryUIFunctions)this.temporaryUIFunctions.hasOwnProperty(e)&&(this.body.eventListeners[e]=this.temporaryUIFunctions[e],delete this.temporaryUIFunctions[e]);this.temporaryUIFunctions={}}_unbindTemporaryEvents(){for(let e=0;e<this.temporaryEventFunctions.length;e++){let t=this.temporaryEventFunctions[e].event,i=this.temporaryEventFunctions[e].boundFunction;this.body.emitter.off(t,i)}this.temporaryEventFunctions=[]}_bindHammerToDiv(e,t){let i=new J(e,{});lt(i,t),this.manipulationHammers.push(i)}_cleanupTemporaryNodesAndEdges(){for(let e=0;e<this.temporaryIds.edges.length;e++){this.body.edges[this.temporaryIds.edges[e]].disconnect(),delete this.body.edges[this.temporaryIds.edges[e]];let t=this.body.edgeIndices.indexOf(this.temporaryIds.edges[e]);-1!==t&&this.body.edgeIndices.splice(t,1)}for(let e=0;e<this.temporaryIds.nodes.length;e++){delete this.body.nodes[this.temporaryIds.nodes[e]];let t=this.body.nodeIndices.indexOf(this.temporaryIds.nodes[e]);-1!==t&&this.body.nodeIndices.splice(t,1)}this.temporaryIds={nodes:[],edges:[]}}_controlNodeTouch(e){this.selectionHandler.unselectAll(),this.lastTouch=this.body.functions.getPointer(e.center),this.lastTouch.translation=Object.assign({},this.body.view.translation)}_controlNodeDragStart(e){let t=this.lastTouch,i=this.selectionHandler._pointerToPositionObject(t),o=this.body.nodes[this.temporaryIds.nodes[0]],s=this.body.nodes[this.temporaryIds.nodes[1]],n=this.body.edges[this.edgeBeingEditedId];this.selectedControlNode=void 0;let r=o.isOverlappingWith(i),a=s.isOverlappingWith(i);!0===r?(this.selectedControlNode=o,n.edgeType.from=o):!0===a&&(this.selectedControlNode=s,n.edgeType.to=s),void 0!==this.selectedControlNode&&this.selectionHandler.selectObject(this.selectedControlNode),this.body.emitter.emit("_redraw")}_controlNodeDrag(e){this.body.emitter.emit("disablePhysics");let t=this.body.functions.getPointer(e.center),i=this.canvas.DOMtoCanvas(t);void 0!==this.selectedControlNode?(this.selectedControlNode.x=i.x,this.selectedControlNode.y=i.y):this.interactionHandler.onDrag(e),this.body.emitter.emit("_redraw")}_controlNodeDragEnd(e){let t=this.body.functions.getPointer(e.center),i=this.selectionHandler._pointerToPositionObject(t),o=this.body.edges[this.edgeBeingEditedId];if(void 0===this.selectedControlNode)return;this.selectionHandler.unselectAll();let s=this.selectionHandler._getAllNodesOverlappingWith(i),n=void 0;for(let e=s.length-1;e>=0;e--)if(s[e]!==this.selectedControlNode.id){n=this.body.nodes[s[e]];break}if(void 0!==n&&void 0!==this.selectedControlNode)if(!0===n.isCluster)alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError);else{let e=this.body.nodes[this.temporaryIds.nodes[0]];this.selectedControlNode.id===e.id?this._performEditEdge(n.id,o.to.id):this._performEditEdge(o.from.id,n.id)}else o.updateEdgeType(),this.body.emitter.emit("restorePhysics");this.body.emitter.emit("_redraw")}_handleConnect(e){if((new Date).valueOf()-this.touchTime>100){this.lastTouch=this.body.functions.getPointer(e.center),this.lastTouch.translation=Object.assign({},this.body.view.translation),this.interactionHandler.drag.pointer=this.lastTouch,this.interactionHandler.drag.translation=this.lastTouch.translation;let t=this.lastTouch,i=this.selectionHandler.getNodeAt(t);if(void 0!==i)if(!0===i.isCluster)alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError);else{let e=this._getNewTargetNode(i.x,i.y);this.body.nodes[e.id]=e,this.body.nodeIndices.push(e.id);let t=this.body.functions.createEdge({id:"connectionEdge"+r.v4(),from:i.id,to:e.id,physics:!1,smooth:{enabled:!0,type:"continuous",roundness:.5}});this.body.edges[t.id]=t,this.body.edgeIndices.push(t.id),this.temporaryIds.nodes.push(e.id),this.temporaryIds.edges.push(t.id)}this.touchTime=(new Date).valueOf()}}_dragControlNode(e){let t=this.body.functions.getPointer(e.center);var i=this.selectionHandler._pointerToPositionObject(t),o=void 0;void 0!==this.temporaryIds.edges[0]&&(o=this.body.edges[this.temporaryIds.edges[0]].fromId);for(var s=this.selectionHandler._getAllNodesOverlappingWith(i),n=void 0,r=s.length-1;r>=0;r--)if(-1===this.temporaryIds.nodes.indexOf(s[r])){n=this.body.nodes[s[r]];break}if(e.controlEdge={from:o,to:n?n.id:void 0},this.selectionHandler._generateClickEvent("controlNodeDragging",e,t),void 0!==this.temporaryIds.nodes[0]){let e=this.body.nodes[this.temporaryIds.nodes[0]];e.x=this.canvas._XconvertDOMtoCanvas(t.x),e.y=this.canvas._YconvertDOMtoCanvas(t.y),this.body.emitter.emit("_redraw")}else this.interactionHandler.onDrag(e)}_finishConnect(e){let t=this.body.functions.getPointer(e.center),i=this.selectionHandler._pointerToPositionObject(t),o=void 0;void 0!==this.temporaryIds.edges[0]&&(o=this.body.edges[this.temporaryIds.edges[0]].fromId);let s=this.selectionHandler._getAllNodesOverlappingWith(i),n=void 0;for(let e=s.length-1;e>=0;e--)if(-1===this.temporaryIds.nodes.indexOf(s[e])){n=this.body.nodes[s[e]];break}this._cleanupTemporaryNodesAndEdges(),void 0!==n&&(!0===n.isCluster?alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError):void 0!==this.body.nodes[o]&&void 0!==this.body.nodes[n.id]&&this._performAddEdge(o,n.id)),e.controlEdge={from:o,to:n?n.id:void 0},this.selectionHandler._generateClickEvent("controlNodeDragEnd",e,t),this.body.emitter.emit("_redraw")}_dragStartEdge(e){let t=this.lastTouch;this.selectionHandler._generateClickEvent("dragStart",e,t,void 0,!0)}_performAddNode(e){let t={id:r.v4(),x:e.pointer.canvas.x,y:e.pointer.canvas.y,label:"new"};if("function"==typeof this.options.addNode){if(2!==this.options.addNode.length)throw this.showManipulatorToolbar(),new Error("The function for add does not support two arguments (data,callback)");this.options.addNode(t,e=>{null!=e&&"addNode"===this.inMode&&this.body.data.nodes.getDataSet().add(e),this.showManipulatorToolbar()})}else this.body.data.nodes.getDataSet().add(t),this.showManipulatorToolbar()}_performAddEdge(e,t){let i={from:e,to:t};if("function"==typeof this.options.addEdge){if(2!==this.options.addEdge.length)throw new Error("The function for connect does not support two arguments (data,callback)");this.options.addEdge(i,e=>{null!=e&&"addEdge"===this.inMode&&(this.body.data.edges.getDataSet().add(e),this.selectionHandler.unselectAll(),this.showManipulatorToolbar())})}else this.body.data.edges.getDataSet().add(i),this.selectionHandler.unselectAll(),this.showManipulatorToolbar()}_performEditEdge(e,t){const i={id:this.edgeBeingEditedId,from:e,to:t,label:this.body.data.edges.get(this.edgeBeingEditedId).label};let o=this.options.editEdge;if("object"==typeof o&&(o=o.editWithoutDrag),"function"==typeof o){if(2!==o.length)throw new Error("The function for edit does not support two arguments (data, callback)");o(i,e=>{null==e||"editEdge"!==this.inMode?(this.body.edges[i.id].updateEdgeType(),this.body.emitter.emit("_redraw"),this.showManipulatorToolbar()):(this.body.data.edges.getDataSet().update(e),this.selectionHandler.unselectAll(),this.showManipulatorToolbar())})}else this.body.data.edges.getDataSet().update(i),this.selectionHandler.unselectAll(),this.showManipulatorToolbar()}}var kt={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"};class Mt{constructor(e=1){this.pixelRatio=e,this.generated=!1,this.centerCoordinates={x:144.5,y:144.5},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=()=>{},this.closeCallback=()=>{},this._create()}insertTo(e){void 0!==this.hammer&&(this.hammer.destroy(),this.hammer=void 0),this.container=e,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}setUpdateCallback(e){if("function"!=typeof e)throw new Error("Function attempted to set as colorPicker update callback is not a function.");this.updateCallback=e}setCloseCallback(e){if("function"!=typeof e)throw new Error("Function attempted to set as colorPicker closing callback is not a function.");this.closeCallback=e}_isColorString(e){if("string"==typeof e)return kt[e]}setColor(e,t=!0){if("none"===e)return;let o;var s=this._isColorString(e);if(void 0!==s&&(e=s),!0===i.isString(e)){if(!0===i.isValidRGB(e)){let t=e.substr(4).substr(0,e.length-5).split(",");o={r:t[0],g:t[1],b:t[2],a:1}}else if(!0===i.isValidRGBA(e)){let t=e.substr(5).substr(0,e.length-6).split(",");o={r:t[0],g:t[1],b:t[2],a:t[3]}}else if(!0===i.isValidHex(e)){let t=i.hexToRGB(e);o={r:t.r,g:t.g,b:t.b,a:1}}}else if(e instanceof Object&&void 0!==e.r&&void 0!==e.g&&void 0!==e.b){let t=void 0!==e.a?e.a:"1.0";o={r:e.r,g:e.g,b:e.b,a:t}}if(void 0===o)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+JSON.stringify(e));this._setColor(o,t)}show(){void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}_hide(e=!0){!0===e&&(this.previousColor=Object.assign({},this.color)),!0===this.applied&&this.updateCallback(this.initialColor),this.frame.style.display="none",setTimeout(()=>{void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0)},0)}_save(){this.updateCallback(this.color),this.applied=!1,this._hide()}_apply(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}_loadLast(){void 0!==this.previousColor?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}_setColor(e,t=!0){!0===t&&(this.initialColor=Object.assign({},e)),this.color=e;let o=i.RGBToHSV(e.r,e.g,e.b),s=2*Math.PI,n=this.r*o.s,r=this.centerCoordinates.x+n*Math.sin(s*o.h),a=this.centerCoordinates.y+n*Math.cos(s*o.h);this.colorPickerSelector.style.left=r-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=a-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(e)}_setOpacity(e){this.color.a=e/100,this._updatePicker(this.color)}_setBrightness(e){let t=i.RGBToHSV(this.color.r,this.color.g,this.color.b);t.v=e/100;let o=i.HSVToRGB(t.h,t.s,t.v);o.a=this.color.a,this.color=o,this._updatePicker()}_updatePicker(e=this.color){let t=i.RGBToHSV(e.r,e.g,e.b),o=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(o.webkitBackingStorePixelRatio||o.mozBackingStorePixelRatio||o.msBackingStorePixelRatio||o.oBackingStorePixelRatio||o.backingStorePixelRatio||1)),o.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);let s=this.colorPickerCanvas.clientWidth,n=this.colorPickerCanvas.clientHeight;o.clearRect(0,0,s,n),o.putImageData(this.hueCircle,0,0),o.fillStyle="rgba(0,0,0,"+(1-t.v)+")",o.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),o.fill(),this.brightnessRange.value=100*t.v,this.opacityRange.value=100*e.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}_setSize(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}_create(){if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){let e=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(e.webkitBackingStorePixelRatio||e.mozBackingStorePixelRatio||e.msBackingStorePixelRatio||e.oBackingStorePixelRatio||e.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{let e=document.createElement("DIV");e.style.color="red",e.style.fontWeight="bold",e.style.padding="10px",e.innerHTML="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(e)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch(e){}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch(e){}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var e=this;this.opacityRange.onchange=function(){e._setOpacity(this.value)},this.opacityRange.oninput=function(){e._setOpacity(this.value)},this.brightnessRange.onchange=function(){e._setBrightness(this.value)},this.brightnessRange.oninput=function(){e._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerHTML="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerHTML="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerHTML="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerHTML="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerHTML="cancel",this.cancelButton.onclick=this._hide.bind(this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerHTML="apply",this.applyButton.onclick=this._apply.bind(this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerHTML="save",this.saveButton.onclick=this._save.bind(this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerHTML="load last",this.loadButton.onclick=this._loadLast.bind(this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}_bindHammer(){this.drag={},this.pinch={},this.hammer=new J(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),lt(this.hammer,e=>{this._moveSelector(e)}),this.hammer.on("tap",e=>{this._moveSelector(e)}),this.hammer.on("panstart",e=>{this._moveSelector(e)}),this.hammer.on("panmove",e=>{this._moveSelector(e)}),this.hammer.on("panend",e=>{this._moveSelector(e)})}_generateHueCircle(){if(!1===this.generated){let e=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(e.webkitBackingStorePixelRatio||e.mozBackingStorePixelRatio||e.msBackingStorePixelRatio||e.oBackingStorePixelRatio||e.backingStorePixelRatio||1)),e.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);let t,o,s,n,r=this.colorPickerCanvas.clientWidth,a=this.colorPickerCanvas.clientHeight;e.clearRect(0,0,r,a),this.centerCoordinates={x:.5*r,y:.5*a},this.r=.49*r;let h,d=2*Math.PI/360,l=1/360,c=1/this.r;for(s=0;s<360;s++)for(n=0;n<this.r;n++)t=this.centerCoordinates.x+n*Math.sin(d*s),o=this.centerCoordinates.y+n*Math.cos(d*s),h=i.HSVToRGB(s*l,n*c,1),e.fillStyle="rgb("+h.r+","+h.g+","+h.b+")",e.fillRect(t-.5,o-.5,2,2);e.strokeStyle="rgba(0,0,0,1)",e.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),e.stroke(),this.hueCircle=e.getImageData(0,0,r,a)}this.generated=!0}_moveSelector(e){let t=this.colorPickerDiv.getBoundingClientRect(),o=e.center.x-t.left,s=e.center.y-t.top,n=.5*this.colorPickerDiv.clientHeight,r=.5*this.colorPickerDiv.clientWidth,a=o-r,h=s-n,d=Math.atan2(a,h),l=.98*Math.min(Math.sqrt(a*a+h*h),r),c=Math.cos(d)*l+n,p=Math.sin(d)*l+r;this.colorPickerSelector.style.top=c-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=p-.5*this.colorPickerSelector.clientWidth+"px";let u=d/(2*Math.PI);u=u<0?u+1:u;let g=l/this.r,m=i.RGBToHSV(this.color.r,this.color.g,this.color.b);m.h=u,m.s=g;let b=i.HSVToRGB(m.h,m.s,m.v);b.a=this.color.a,this.color=b,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}class St{constructor(e,t,i,o=1){this.parent=e,this.changedOptions=[],this.container=t,this.allowCreation=!1,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},Object.assign(this.options,this.defaultOptions),this.configureOptions=i,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new Mt(o),this.wrapper=void 0}setOptions(e){if(void 0!==e){this.popupHistory={},this._removePopup();let t=!0;if("string"==typeof e)this.options.filter=e;else if(e instanceof Array)this.options.filter=e.join();else if("object"==typeof e){if(null==e)throw new TypeError("options cannot be null");void 0!==e.container&&(this.options.container=e.container),void 0!==e.filter&&(this.options.filter=e.filter),void 0!==e.showButton&&(this.options.showButton=e.showButton),void 0!==e.enabled&&(t=e.enabled)}else"boolean"==typeof e?(this.options.filter=!0,t=e):"function"==typeof e&&(this.options.filter=e,t=!0);!1===this.options.filter&&(t=!1),this.options.enabled=t}this._clean()}setModuleOptions(e){this.moduleOptions=e,!0===this.options.enabled&&(this._clean(),void 0!==this.options.container&&(this.container=this.options.container),this._create())}_create(){this._clean(),this.changedOptions=[];let e=this.options.filter,t=0,i=!1;for(let o in this.configureOptions)this.configureOptions.hasOwnProperty(o)&&(this.allowCreation=!1,i=!1,"function"==typeof e?(i=e(o,[]),i=i||this._handleObject(this.configureOptions[o],[o],!0)):!0!==e&&-1===e.indexOf(o)||(i=!0),!1!==i&&(this.allowCreation=!0,t>0&&this._makeItem([]),this._makeHeader(o),this._handleObject(this.configureOptions[o],[o])),t++);this._makeButton(),this._push()}_push(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var e=0;e<this.domElements.length;e++)this.wrapper.appendChild(this.domElements[e]);this._showPopupIfNeeded()}_clean(){for(var e=0;e<this.domElements.length;e++)this.wrapper.removeChild(this.domElements[e]);void 0!==this.wrapper&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}_getValue(e){let t=this.moduleOptions;for(let i=0;i<e.length;i++){if(void 0===t[e[i]]){t=void 0;break}t=t[e[i]]}return t}_makeItem(e,...t){if(!0===this.allowCreation){let i=document.createElement("div");return i.className="vis-configuration vis-config-item vis-config-s"+e.length,t.forEach(e=>{i.appendChild(e)}),this.domElements.push(i),this.domElements.length}return 0}_makeHeader(e){let t=document.createElement("div");t.className="vis-configuration vis-config-header",t.innerHTML=e,this._makeItem([],t)}_makeLabel(e,t,i=!1){let o=document.createElement("div");return o.className="vis-configuration vis-config-label vis-config-s"+t.length,o.innerHTML=!0===i?"<i><b>"+e+":</b></i>":e+":",o}_makeDropdown(e,t,i){let o=document.createElement("select");o.className="vis-configuration vis-config-select";let s=0;void 0!==t&&-1!==e.indexOf(t)&&(s=e.indexOf(t));for(let t=0;t<e.length;t++){let i=document.createElement("option");i.value=e[t],t===s&&(i.selected="selected"),i.innerHTML=e[t],o.appendChild(i)}let n=this;o.onchange=function(){n._update(this.value,i)};let r=this._makeLabel(i[i.length-1],i);this._makeItem(i,r,o)}_makeRange(e,t,i){let o=e[0],s=e[1],n=e[2],r=e[3],a=document.createElement("input");a.className="vis-configuration vis-config-range";try{a.type="range",a.min=s,a.max=n}catch(e){}a.step=r;let h="",d=0;if(void 0!==t){let e=1.2;t<0&&t*e<s?(a.min=Math.ceil(t*e),d=a.min,h="range increased"):t/e<s&&(a.min=Math.ceil(t/e),d=a.min,h="range increased"),t*e>n&&1!==n&&(a.max=Math.ceil(t*e),d=a.max,h="range increased"),a.value=t}else a.value=o;let l=document.createElement("input");l.className="vis-configuration vis-config-rangeinput",l.value=a.value;var c=this;a.onchange=function(){l.value=this.value,c._update(Number(this.value),i)},a.oninput=function(){l.value=this.value};let p=this._makeLabel(i[i.length-1],i),u=this._makeItem(i,p,a,l);""!==h&&this.popupHistory[u]!==d&&(this.popupHistory[u]=d,this._setupPopup(h,u))}_makeButton(){if(!0===this.options.showButton){let e=document.createElement("div");e.className="vis-configuration vis-config-button",e.innerHTML="generate options",e.onclick=()=>{this._printOptions()},e.onmouseover=()=>{e.className="vis-configuration vis-config-button hover"},e.onmouseout=()=>{e.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(e)}}_setupPopup(e,t){if(!0===this.initialized&&!0===this.allowCreation&&this.popupCounter<this.popupLimit){let i=document.createElement("div");i.id="vis-configuration-popup",i.className="vis-configuration-popup",i.innerHTML=e,i.onclick=()=>{this._removePopup()},this.popupCounter+=1,this.popupDiv={html:i,index:t}}}_removePopup(){void 0!==this.popupDiv.html&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}_showPopupIfNeeded(){if(void 0!==this.popupDiv.html){let e=this.domElements[this.popupDiv.index].getBoundingClientRect();this.popupDiv.html.style.left=e.left+"px",this.popupDiv.html.style.top=e.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=setTimeout(()=>{this.popupDiv.html.style.opacity=0},1500),this.popupDiv.deleteTimeout=setTimeout(()=>{this._removePopup()},1800)}}_makeCheckbox(e,t,i){var o=document.createElement("input");o.type="checkbox",o.className="vis-configuration vis-config-checkbox",o.checked=e,void 0!==t&&(o.checked=t,t!==e&&("object"==typeof e?t!==e.enabled&&this.changedOptions.push({path:i,value:t}):this.changedOptions.push({path:i,value:t})));let s=this;o.onchange=function(){s._update(this.checked,i)};let n=this._makeLabel(i[i.length-1],i);this._makeItem(i,n,o)}_makeTextInput(e,t,i){var o=document.createElement("input");o.type="text",o.className="vis-configuration vis-config-text",o.value=t,t!==e&&this.changedOptions.push({path:i,value:t});let s=this;o.onchange=function(){s._update(this.value,i)};let n=this._makeLabel(i[i.length-1],i);this._makeItem(i,n,o)}_makeColorField(e,t,i){let o=e[1],s=document.createElement("div");"none"!==(t=void 0===t?o:t)?(s.className="vis-configuration vis-config-colorBlock",s.style.backgroundColor=t):s.className="vis-configuration vis-config-colorBlock none",t=void 0===t?o:t,s.onclick=()=>{this._showColorPicker(t,s,i)};let n=this._makeLabel(i[i.length-1],i);this._makeItem(i,n,s)}_showColorPicker(e,t,i){t.onclick=function(){},this.colorPicker.insertTo(t),this.colorPicker.show(),this.colorPicker.setColor(e),this.colorPicker.setUpdateCallback(e=>{let o="rgba("+e.r+","+e.g+","+e.b+","+e.a+")";t.style.backgroundColor=o,this._update(o,i)}),this.colorPicker.setCloseCallback(()=>{t.onclick=()=>{this._showColorPicker(e,t,i)}})}_handleObject(e,t=[],o=!1){let s=!1,n=this.options.filter,r=!1;for(let a in e)if(e.hasOwnProperty(a)){s=!0;let h=e[a],d=i.copyAndExtendArray(t,a);if("function"==typeof n&&(s=n(a,t),!1===s&&!(h instanceof Array)&&"string"!=typeof h&&"boolean"!=typeof h&&h instanceof Object&&(this.allowCreation=!1,s=this._handleObject(h,d,!0),this.allowCreation=!1===o)),!1!==s){r=!0;let e=this._getValue(d);if(h instanceof Array)this._handleArray(h,e,d);else if("string"==typeof h)this._makeTextInput(h,e,d);else if("boolean"==typeof h)this._makeCheckbox(h,e,d);else if(h instanceof Object){let e=!0;if(-1!==t.indexOf("physics")&&this.moduleOptions.physics.solver!==a&&"wind"!==a&&(e=!1),!0===e)if(void 0!==h.enabled){let e=i.copyAndExtendArray(d,"enabled"),t=this._getValue(e);if(!0===t){let e=this._makeLabel(a,d,!0);this._makeItem(d,e),r=this._handleObject(h,d)||r}else this._makeCheckbox(h,t,d)}else{let e=this._makeLabel(a,d,!0);this._makeItem(d,e),r=this._handleObject(h,d)||r}}else console.error("dont know how to handle",h,a,d)}}return r}_handleArray(e,t,i){"string"==typeof e[0]&&"color"===e[0]?(this._makeColorField(e,t,i),e[1]!==t&&this.changedOptions.push({path:i,value:t})):"string"==typeof e[0]?(this._makeDropdown(e,t,i),e[0]!==t&&this.changedOptions.push({path:i,value:t})):"number"==typeof e[0]&&(this._makeRange(e,t,i),e[0]!==t&&this.changedOptions.push({path:i,value:Number(t)}))}_update(e,t){let i=this._constructOptions(e,t);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",i),this.initialized=!0,this.parent.setOptions(i)}_constructOptions(e,t,i={}){let o=i;e="false"!==(e="true"===e||e)&&e;for(let i=0;i<t.length;i++)"global"!==t[i]&&(void 0===o[t[i]]&&(o[t[i]]={}),i!==t.length-1?o=o[t[i]]:o[t[i]]=e);return i}_printOptions(){let e=this.getOptions();this.optionsContainer.innerHTML="<pre>var options = "+JSON.stringify(e,null,2)+"</pre>"}getOptions(){let e={};for(var t=0;t<this.changedOptions.length;t++)this._constructOptions(this.changedOptions[t].value,this.changedOptions[t].path,e);return e}}let Dt="string",Bt="boolean",Tt="number",Pt="object",zt=["arrow","bar","box","circle","crow","curve","diamond","image","inv_curve","inv_triangle","triangle","vee"],Ft={configure:{enabled:{boolean:Bt},filter:{boolean:Bt,string:Dt,array:"array",function:"function"},container:{dom:"dom"},showButton:{boolean:Bt},__type__:{object:Pt,boolean:Bt,string:Dt,array:"array",function:"function"}},edges:{arrows:{to:{enabled:{boolean:Bt},scaleFactor:{number:Tt},type:{string:zt},imageHeight:{number:Tt},imageWidth:{number:Tt},src:{string:Dt},__type__:{object:Pt,boolean:Bt}},middle:{enabled:{boolean:Bt},scaleFactor:{number:Tt},type:{string:zt},imageWidth:{number:Tt},imageHeight:{number:Tt},src:{string:Dt},__type__:{object:Pt,boolean:Bt}},from:{enabled:{boolean:Bt},scaleFactor:{number:Tt},type:{string:zt},imageWidth:{number:Tt},imageHeight:{number:Tt},src:{string:Dt},__type__:{object:Pt,boolean:Bt}},__type__:{string:["from","to","middle"],object:Pt}},endPointOffset:{from:{number:Tt},to:{number:Tt},__type__:{object:Pt,number:Tt}},arrowStrikethrough:{boolean:Bt},background:{enabled:{boolean:Bt},color:{string:Dt},size:{number:Tt},dashes:{boolean:Bt,array:"array"},__type__:{object:Pt,boolean:Bt}},chosen:{label:{boolean:Bt,function:"function"},edge:{boolean:Bt,function:"function"},__type__:{object:Pt,boolean:Bt}},color:{color:{string:Dt},highlight:{string:Dt},hover:{string:Dt},inherit:{string:["from","to","both"],boolean:Bt},opacity:{number:Tt},__type__:{object:Pt,string:Dt}},dashes:{boolean:Bt,array:"array"},font:{color:{string:Dt},size:{number:Tt},face:{string:Dt},background:{string:Dt},strokeWidth:{number:Tt},strokeColor:{string:Dt},align:{string:["horizontal","top","middle","bottom"]},vadjust:{number:Tt},multi:{boolean:Bt,string:Dt},bold:{color:{string:Dt},size:{number:Tt},face:{string:Dt},mod:{string:Dt},vadjust:{number:Tt},__type__:{object:Pt,string:Dt}},boldital:{color:{string:Dt},size:{number:Tt},face:{string:Dt},mod:{string:Dt},vadjust:{number:Tt},__type__:{object:Pt,string:Dt}},ital:{color:{string:Dt},size:{number:Tt},face:{string:Dt},mod:{string:Dt},vadjust:{number:Tt},__type__:{object:Pt,string:Dt}},mono:{color:{string:Dt},size:{number:Tt},face:{string:Dt},mod:{string:Dt},vadjust:{number:Tt},__type__:{object:Pt,string:Dt}},__type__:{object:Pt,string:Dt}},hidden:{boolean:Bt},hoverWidth:{function:"function",number:Tt},label:{string:Dt,undefined:"undefined"},labelHighlightBold:{boolean:Bt},length:{number:Tt,undefined:"undefined"},physics:{boolean:Bt},scaling:{min:{number:Tt},max:{number:Tt},label:{enabled:{boolean:Bt},min:{number:Tt},max:{number:Tt},maxVisible:{number:Tt},drawThreshold:{number:Tt},__type__:{object:Pt,boolean:Bt}},customScalingFunction:{function:"function"},__type__:{object:Pt}},selectionWidth:{function:"function",number:Tt},selfReferenceSize:{number:Tt},selfReference:{size:{number:Tt},angle:{number:Tt},renderBehindTheNode:{boolean:Bt},__type__:{object:Pt}},shadow:{enabled:{boolean:Bt},color:{string:Dt},size:{number:Tt},x:{number:Tt},y:{number:Tt},__type__:{object:Pt,boolean:Bt}},smooth:{enabled:{boolean:Bt},type:{string:["dynamic","continuous","discrete","diagonalCross","straightCross","horizontal","vertical","curvedCW","curvedCCW","cubicBezier"]},roundness:{number:Tt},forceDirection:{string:["horizontal","vertical","none"],boolean:Bt},__type__:{object:Pt,boolean:Bt}},title:{string:Dt,undefined:"undefined"},width:{number:Tt},widthConstraint:{maximum:{number:Tt},__type__:{object:Pt,boolean:Bt,number:Tt}},value:{number:Tt,undefined:"undefined"},__type__:{object:Pt}},groups:{useDefaultGroups:{boolean:Bt},__any__:"get from nodes, will be overwritten below",__type__:{object:Pt}},interaction:{dragNodes:{boolean:Bt},dragView:{boolean:Bt},hideEdgesOnDrag:{boolean:Bt},hideEdgesOnZoom:{boolean:Bt},hideNodesOnDrag:{boolean:Bt},hover:{boolean:Bt},keyboard:{enabled:{boolean:Bt},speed:{x:{number:Tt},y:{number:Tt},zoom:{number:Tt},__type__:{object:Pt}},bindToWindow:{boolean:Bt},__type__:{object:Pt,boolean:Bt}},multiselect:{boolean:Bt},navigationButtons:{boolean:Bt},selectable:{boolean:Bt},selectConnectedEdges:{boolean:Bt},hoverConnectedEdges:{boolean:Bt},tooltipDelay:{number:Tt},zoomView:{boolean:Bt},zoomSpeed:{number:Tt},__type__:{object:Pt}},layout:{randomSeed:{undefined:"undefined",number:Tt,string:Dt},improvedLayout:{boolean:Bt},clusterThreshold:{number:Tt},hierarchical:{enabled:{boolean:Bt},levelSeparation:{number:Tt},nodeSpacing:{number:Tt},treeSpacing:{number:Tt},blockShifting:{boolean:Bt},edgeMinimization:{boolean:Bt},parentCentralization:{boolean:Bt},direction:{string:["UD","DU","LR","RL"]},sortMethod:{string:["hubsize","directed"]},shakeTowards:{string:["leaves","roots"]},__type__:{object:Pt,boolean:Bt}},__type__:{object:Pt}},manipulation:{enabled:{boolean:Bt},initiallyActive:{boolean:Bt},addNode:{boolean:Bt,function:"function"},addEdge:{boolean:Bt,function:"function"},editNode:{function:"function"},editEdge:{editWithoutDrag:{function:"function"},__type__:{object:Pt,boolean:Bt,function:"function"}},deleteNode:{boolean:Bt,function:"function"},deleteEdge:{boolean:Bt,function:"function"},controlNodeStyle:"get from nodes, will be overwritten below",__type__:{object:Pt,boolean:Bt}},nodes:{borderWidth:{number:Tt},borderWidthSelected:{number:Tt,undefined:"undefined"},brokenImage:{string:Dt,undefined:"undefined"},chosen:{label:{boolean:Bt,function:"function"},node:{boolean:Bt,function:"function"},__type__:{object:Pt,boolean:Bt}},color:{border:{string:Dt},background:{string:Dt},highlight:{border:{string:Dt},background:{string:Dt},__type__:{object:Pt,string:Dt}},hover:{border:{string:Dt},background:{string:Dt},__type__:{object:Pt,string:Dt}},__type__:{object:Pt,string:Dt}},opacity:{number:Tt,undefined:"undefined"},fixed:{x:{boolean:Bt},y:{boolean:Bt},__type__:{object:Pt,boolean:Bt}},font:{align:{string:Dt},color:{string:Dt},size:{number:Tt},face:{string:Dt},background:{string:Dt},strokeWidth:{number:Tt},strokeColor:{string:Dt},vadjust:{number:Tt},multi:{boolean:Bt,string:Dt},bold:{color:{string:Dt},size:{number:Tt},face:{string:Dt},mod:{string:Dt},vadjust:{number:Tt},__type__:{object:Pt,string:Dt}},boldital:{color:{string:Dt},size:{number:Tt},face:{string:Dt},mod:{string:Dt},vadjust:{number:Tt},__type__:{object:Pt,string:Dt}},ital:{color:{string:Dt},size:{number:Tt},face:{string:Dt},mod:{string:Dt},vadjust:{number:Tt},__type__:{object:Pt,string:Dt}},mono:{color:{string:Dt},size:{number:Tt},face:{string:Dt},mod:{string:Dt},vadjust:{number:Tt},__type__:{object:Pt,string:Dt}},__type__:{object:Pt,string:Dt}},group:{string:Dt,number:Tt,undefined:"undefined"},heightConstraint:{minimum:{number:Tt},valign:{string:Dt},__type__:{object:Pt,boolean:Bt,number:Tt}},hidden:{boolean:Bt},icon:{face:{string:Dt},code:{string:Dt},size:{number:Tt},color:{string:Dt},weight:{string:Dt,number:Tt},__type__:{object:Pt}},id:{string:Dt,number:Tt},image:{selected:{string:Dt,undefined:"undefined"},unselected:{string:Dt,undefined:"undefined"},__type__:{object:Pt,string:Dt}},imagePadding:{top:{number:Tt},right:{number:Tt},bottom:{number:Tt},left:{number:Tt},__type__:{object:Pt,number:Tt}},label:{string:Dt,undefined:"undefined"},labelHighlightBold:{boolean:Bt},level:{number:Tt,undefined:"undefined"},margin:{top:{number:Tt},right:{number:Tt},bottom:{number:Tt},left:{number:Tt},__type__:{object:Pt,number:Tt}},mass:{number:Tt},physics:{boolean:Bt},scaling:{min:{number:Tt},max:{number:Tt},label:{enabled:{boolean:Bt},min:{number:Tt},max:{number:Tt},maxVisible:{number:Tt},drawThreshold:{number:Tt},__type__:{object:Pt,boolean:Bt}},customScalingFunction:{function:"function"},__type__:{object:Pt}},shadow:{enabled:{boolean:Bt},color:{string:Dt},size:{number:Tt},x:{number:Tt},y:{number:Tt},__type__:{object:Pt,boolean:Bt}},shape:{string:["ellipse","circle","database","box","text","image","circularImage","diamond","dot","star","triangle","triangleDown","square","icon","hexagon"]},shapeProperties:{borderDashes:{boolean:Bt,array:"array"},borderRadius:{number:Tt},interpolation:{boolean:Bt},useImageSize:{boolean:Bt},useBorderWithImage:{boolean:Bt},coordinateOrigin:{string:["center","top-left"]},__type__:{object:Pt}},size:{number:Tt},title:{string:Dt,dom:"dom",undefined:"undefined"},value:{number:Tt,undefined:"undefined"},widthConstraint:{minimum:{number:Tt},maximum:{number:Tt},__type__:{object:Pt,boolean:Bt,number:Tt}},x:{number:Tt},y:{number:Tt},__type__:{object:Pt}},physics:{enabled:{boolean:Bt},barnesHut:{theta:{number:Tt},gravitationalConstant:{number:Tt},centralGravity:{number:Tt},springLength:{number:Tt},springConstant:{number:Tt},damping:{number:Tt},avoidOverlap:{number:Tt},__type__:{object:Pt}},forceAtlas2Based:{theta:{number:Tt},gravitationalConstant:{number:Tt},centralGravity:{number:Tt},springLength:{number:Tt},springConstant:{number:Tt},damping:{number:Tt},avoidOverlap:{number:Tt},__type__:{object:Pt}},repulsion:{centralGravity:{number:Tt},springLength:{number:Tt},springConstant:{number:Tt},nodeDistance:{number:Tt},damping:{number:Tt},__type__:{object:Pt}},hierarchicalRepulsion:{centralGravity:{number:Tt},springLength:{number:Tt},springConstant:{number:Tt},nodeDistance:{number:Tt},damping:{number:Tt},avoidOverlap:{number:Tt},__type__:{object:Pt}},maxVelocity:{number:Tt},minVelocity:{number:Tt},solver:{string:["barnesHut","repulsion","hierarchicalRepulsion","forceAtlas2Based"]},stabilization:{enabled:{boolean:Bt},iterations:{number:Tt},updateInterval:{number:Tt},onlyDynamicEdges:{boolean:Bt},fit:{boolean:Bt},__type__:{object:Pt,boolean:Bt}},timestep:{number:Tt},adaptiveTimestep:{boolean:Bt},wind:{x:{number:Tt},y:{number:Tt},__type__:{object:Pt}},__type__:{object:Pt,boolean:Bt}},autoResize:{boolean:Bt},clickToUse:{boolean:Bt},locale:{string:Dt},locales:{__any__:{any:"any"},__type__:{object:Pt}},height:{string:Dt},width:{string:Dt},__type__:{object:Pt}};Ft.groups.__any__=Ft.nodes,Ft.manipulation.controlNodeStyle=Ft.nodes;let It={nodes:{borderWidth:[1,0,10,1],borderWidthSelected:[2,0,10,1],color:{border:["color","#2B7CE9"],background:["color","#97C2FC"],highlight:{border:["color","#2B7CE9"],background:["color","#D2E5FF"]},hover:{border:["color","#2B7CE9"],background:["color","#D2E5FF"]}},opacity:[0,0,1,.1],fixed:{x:!1,y:!1},font:{color:["color","#343434"],size:[14,0,100,1],face:["arial","verdana","tahoma"],background:["color","none"],strokeWidth:[0,0,50,1],strokeColor:["color","#ffffff"]},hidden:!1,labelHighlightBold:!0,physics:!0,scaling:{min:[10,0,200,1],max:[30,0,200,1],label:{enabled:!1,min:[14,0,200,1],max:[30,0,200,1],maxVisible:[30,0,200,1],drawThreshold:[5,0,20,1]}},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:[10,0,20,1],x:[5,-30,30,1],y:[5,-30,30,1]},shape:["ellipse","box","circle","database","diamond","dot","square","star","text","triangle","triangleDown","hexagon"],shapeProperties:{borderDashes:!1,borderRadius:[6,0,20,1],interpolation:!0,useImageSize:!1},size:[25,0,200,1]},edges:{arrows:{to:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"},middle:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"},from:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"}},endPointOffset:{from:[0,-10,10,1],to:[0,-10,10,1]},arrowStrikethrough:!0,color:{color:["color","#848484"],highlight:["color","#848484"],hover:["color","#848484"],inherit:["from","to","both",!0,!1],opacity:[1,0,1,.05]},dashes:!1,font:{color:["color","#343434"],size:[14,0,100,1],face:["arial","verdana","tahoma"],background:["color","none"],strokeWidth:[2,0,50,1],strokeColor:["color","#ffffff"],align:["horizontal","top","middle","bottom"]},hidden:!1,hoverWidth:[1.5,0,5,.1],labelHighlightBold:!0,physics:!0,scaling:{min:[1,0,100,1],max:[15,0,100,1],label:{enabled:!0,min:[14,0,200,1],max:[30,0,200,1],maxVisible:[30,0,200,1],drawThreshold:[5,0,20,1]}},selectionWidth:[1.5,0,5,.1],selfReferenceSize:[20,0,200,1],selfReference:{size:[20,0,200,1],angle:[Math.PI/2,-6*Math.PI,6*Math.PI,Math.PI/8],renderBehindTheNode:!0},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:[10,0,20,1],x:[5,-30,30,1],y:[5,-30,30,1]},smooth:{enabled:!0,type:["dynamic","continuous","discrete","diagonalCross","straightCross","horizontal","vertical","curvedCW","curvedCCW","cubicBezier"],forceDirection:["horizontal","vertical","none"],roundness:[.5,0,1,.05]},width:[1,0,30,1]},layout:{hierarchical:{enabled:!1,levelSeparation:[150,20,500,5],nodeSpacing:[100,20,500,5],treeSpacing:[200,20,500,5],blockShifting:!0,edgeMinimization:!0,parentCentralization:!0,direction:["UD","DU","LR","RL"],sortMethod:["hubsize","directed"],shakeTowards:["leaves","roots"]}},interaction:{dragNodes:!0,dragView:!0,hideEdgesOnDrag:!1,hideEdgesOnZoom:!1,hideNodesOnDrag:!1,hover:!1,keyboard:{enabled:!1,speed:{x:[10,0,40,1],y:[10,0,40,1],zoom:[.02,0,.1,.005]},bindToWindow:!0},multiselect:!1,navigationButtons:!1,selectable:!0,selectConnectedEdges:!0,hoverConnectedEdges:!0,tooltipDelay:[300,0,1e3,25],zoomView:!0,zoomSpeed:[1,.1,2,.1]},manipulation:{enabled:!1,initiallyActive:!1},physics:{enabled:!0,barnesHut:{theta:[.5,.1,1,.05],gravitationalConstant:[-2e3,-3e4,0,50],centralGravity:[.3,0,10,.05],springLength:[95,0,500,5],springConstant:[.04,0,1.2,.005],damping:[.09,0,1,.01],avoidOverlap:[0,0,1,.01]},forceAtlas2Based:{theta:[.5,.1,1,.05],gravitationalConstant:[-50,-500,0,1],centralGravity:[.01,0,1,.005],springLength:[95,0,500,5],springConstant:[.08,0,1.2,.005],damping:[.4,0,1,.01],avoidOverlap:[0,0,1,.01]},repulsion:{centralGravity:[.2,0,10,.05],springLength:[200,0,500,5],springConstant:[.05,0,1.2,.005],nodeDistance:[100,0,500,5],damping:[.09,0,1,.01]},hierarchicalRepulsion:{centralGravity:[.2,0,10,.05],springLength:[100,0,500,5],springConstant:[.01,0,1.2,.005],nodeDistance:[120,0,500,5],damping:[.09,0,1,.01],avoidOverlap:[0,0,1,.01]},maxVelocity:[50,0,150,1],minVelocity:[.1,.01,.5,.01],solver:["barnesHut","forceAtlas2Based","repulsion","hierarchicalRepulsion"],timestep:[.5,.01,1,.01],wind:{x:[0,-10,10,.1],y:[0,-10,10,.1]}}};var Nt=Object.freeze({__proto__:null,allOptions:Ft,configureOptions:It});class Rt{constructor(){}getDistances(e,t,i){let o={},s=e.edges;for(let e=0;e<t.length;e++){let i={};o[t[e]]=i;for(let o=0;o<t.length;o++)i[t[o]]=e==o?0:1e9}for(let e=0;e<i.length;e++){let t=s[i[e]];!0===t.connected&&void 0!==o[t.fromId]&&void 0!==o[t.toId]&&(o[t.fromId][t.toId]=1,o[t.toId][t.fromId]=1)}let n=t.length;for(let e=0;e<n;e++){let i=t[e],s=o[i];for(let e=0;e<n-1;e++){let r=t[e],a=o[r];for(let h=e+1;h<n;h++){let e=t[h],n=o[e],d=Math.min(a[e],a[i]+s[e]);a[e]=d,n[r]=d}}}return o}}class At{constructor(e,t,i){this.body=e,this.springLength=t,this.springConstant=i,this.distanceSolver=new Rt}setOptions(e){e&&(e.springLength&&(this.springLength=e.springLength),e.springConstant&&(this.springConstant=e.springConstant))}solve(e,t,i=!1){let o=this.distanceSolver.getDistances(this.body,e,t);this._createL_matrix(o),this._createK_matrix(o),this._createE_matrix();let s=0,n=Math.max(1e3,Math.min(10*this.body.nodeIndices.length,6e3)),r=1e9,a=0,h=0,d=0,l=0,c=0;for(;r>.01&&s<n;)for(s+=1,[a,r,h,d]=this._getHighestEnergyNode(i),l=r,c=0;l>1&&c<5;)c+=1,this._moveNode(a,h,d),[l,h,d]=this._getEnergy(a)}_getHighestEnergyNode(e){let t=this.body.nodeIndices,i=this.body.nodes,o=0,s=t[0],n=0,r=0;for(let a=0;a<t.length;a++){let h=t[a];if(!1===i[h].predefinedPosition||!0===i[h].isCluster&&!0===e||!0===i[h].options.fixed.x||!0===i[h].options.fixed.y){let[e,t,i]=this._getEnergy(h);o<e&&(o=e,s=h,n=t,r=i)}}return[s,o,n,r]}_getEnergy(e){let[t,i]=this.E_sums[e];return[Math.sqrt(t**2+i**2),t,i]}_moveNode(e,t,i){let o=this.body.nodeIndices,s=this.body.nodes,n=0,r=0,a=0,h=s[e].x,d=s[e].y,l=this.K_matrix[e],c=this.L_matrix[e];for(let t=0;t<o.length;t++){let i=o[t];if(i!==e){let e=s[i].x,t=s[i].y,o=l[i],p=c[i],u=1/((h-e)**2+(d-t)**2)**1.5;n+=o*(1-p*(d-t)**2*u),r+=o*(p*(h-e)*(d-t)*u),a+=o*(1-p*(h-e)**2*u)}}let p=(t/n+i/r)/(r/n-a/r),u=-(r*p+t)/n;s[e].x+=u,s[e].y+=p,this._updateE_matrix(e)}_createL_matrix(e){let t=this.body.nodeIndices,i=this.springLength;this.L_matrix=[];for(let o=0;o<t.length;o++){this.L_matrix[t[o]]={};for(let s=0;s<t.length;s++)this.L_matrix[t[o]][t[s]]=i*e[t[o]][t[s]]}}_createK_matrix(e){let t=this.body.nodeIndices,i=this.springConstant;this.K_matrix=[];for(let o=0;o<t.length;o++){this.K_matrix[t[o]]={};for(let s=0;s<t.length;s++)this.K_matrix[t[o]][t[s]]=i*e[t[o]][t[s]]**-2}}_createE_matrix(){let e=this.body.nodeIndices,t=this.body.nodes;this.E_matrix={},this.E_sums={};for(let t=0;t<e.length;t++)this.E_matrix[e[t]]=[];for(let i=0;i<e.length;i++){let o=e[i],s=t[o].x,n=t[o].y,r=0,a=0;for(let h=i;h<e.length;h++){let d=e[h];if(d!==o){let e=t[d].x,l=t[d].y,c=1/Math.sqrt((s-e)**2+(n-l)**2);this.E_matrix[o][h]=[this.K_matrix[o][d]*(s-e-this.L_matrix[o][d]*(s-e)*c),this.K_matrix[o][d]*(n-l-this.L_matrix[o][d]*(n-l)*c)],this.E_matrix[d][i]=this.E_matrix[o][h],r+=this.E_matrix[o][h][0],a+=this.E_matrix[o][h][1]}}this.E_sums[o]=[r,a]}}_updateE_matrix(e){let t=this.body.nodeIndices,i=this.body.nodes,o=this.E_matrix[e],s=this.K_matrix[e],n=this.L_matrix[e],r=i[e].x,a=i[e].y,h=0,d=0;for(let l=0;l<t.length;l++){let c=t[l];if(c!==e){let e=o[l],t=e[0],p=e[1],u=i[c].x,g=i[c].y,m=1/Math.sqrt((r-u)**2+(a-g)**2),b=s[c]*(r-u-n[c]*(r-u)*m),f=s[c]*(a-g-n[c]*(a-g)*m);o[l]=[b,f],h+=b,d+=f;let y=this.E_sums[c];y[0]+=b-t,y[1]+=f-p}}this.E_sums[e]=[h,d]}}function jt(e,t,i){if(!(this instanceof jt))throw new SyntaxError("Constructor must be called with the new operator");this.options={},this.defaultOptions={locale:"en",locales:Q,clickToUse:!1},Object.assign(this.options,this.defaultOptions),this.body={container:e,nodes:{},nodeIndices:[],edges:{},edgeIndices:[],emitter:{on:this.on.bind(this),off:this.off.bind(this),emit:this.emit.bind(this),once:this.once.bind(this)},eventListeners:{onTap:function(){},onTouch:function(){},onDoubleTap:function(){},onHold:function(){},onDragStart:function(){},onDrag:function(){},onDragEnd:function(){},onMouseWheel:function(){},onPinch:function(){},onMouseMove:function(){},onRelease:function(){},onContext:function(){}},data:{nodes:null,edges:null},functions:{createNode:function(){},createEdge:function(){},getPointer:function(){}},modules:{},view:{scale:1,translation:{x:0,y:0}},selectionBox:{show:!1,position:{start:{x:0,y:0},end:{x:0,y:0}}}},this.bindEventListeners(),this.images=new te(()=>this.body.emitter.emit("_requestRedraw")),this.groups=new ie,this.canvas=new pt(this.body),this.selectionHandler=new ft(this.body,this.canvas),this.interactionHandler=new bt(this.body,this.canvas,this.selectionHandler),this.view=new ut(this.body,this.canvas),this.renderer=new dt(this.body,this.canvas),this.physics=new nt(this.body),this.layoutEngine=new Ot(this.body),this.clustering=new ht(this.body),this.manipulation=new Ct(this.body,this.canvas,this.selectionHandler,this.interactionHandler),this.nodesHandler=new Re(this.body,this.images,this.groups,this.layoutEngine),this.edgesHandler=new Ze(this.body,this.images,this.groups),this.body.modules.kamadaKawai=new At(this.body,150,.05),this.body.modules.clustering=this.clustering,this.canvas._create(),this.setOptions(i),this.setData(t)}t(jt.prototype),jt.prototype.setOptions=function(e){if(null===e&&(e=void 0),void 0!==e){!0===Ie.validate(e,Ft)&&console.log("%cErrors have been found in the supplied options object.",Fe);let t=["locale","locales","clickToUse"];if(i.selectiveDeepExtend(t,this.options,e),void 0!==e.locale&&(e.locale=function(e,t){try{const[i,o]=t.split(/[-_ \/]/,2),s=null!=i?i.toLowerCase():null,n=null!=o?o.toUpperCase():null;if(s&&n){const t=s+"-"+n;if(Object.prototype.hasOwnProperty.call(e,t))return t;console.warn(`Unknown variant ${n} of language ${s}.`)}if(s){const t=s;if(Object.prototype.hasOwnProperty.call(e,t))return t;console.warn("Unknown language "+s)}return console.warn(`Unknown locale ${t}, falling back to English.`),"en"}catch(e){return console.error(e),console.warn(`Unexpected error while normalizing locale ${t}, falling back to English.`),"en"}}(e.locales||this.options.locales,e.locale)),e=this.layoutEngine.setOptions(e.layout,e),this.canvas.setOptions(e),this.groups.setOptions(e.groups),this.nodesHandler.setOptions(e.nodes),this.edgesHandler.setOptions(e.edges),this.physics.setOptions(e.physics),this.manipulation.setOptions(e.manipulation,e,this.options),this.interactionHandler.setOptions(e.interaction),this.renderer.setOptions(e.interaction),this.selectionHandler.setOptions(e.interaction),void 0!==e.groups&&this.body.emitter.emit("refreshNodes"),"configure"in e&&(this.configurator||(this.configurator=new St(this,this.body.container,It,this.canvas.pixelRatio)),this.configurator.setOptions(e.configure)),this.configurator&&!0===this.configurator.options.enabled){let e={nodes:{},edges:{},layout:{},interaction:{},manipulation:{},physics:{},global:{}};i.deepExtend(e.nodes,this.nodesHandler.options),i.deepExtend(e.edges,this.edgesHandler.options),i.deepExtend(e.layout,this.layoutEngine.options),i.deepExtend(e.interaction,this.selectionHandler.options),i.deepExtend(e.interaction,this.renderer.options),i.deepExtend(e.interaction,this.interactionHandler.options),i.deepExtend(e.manipulation,this.manipulation.options),i.deepExtend(e.physics,this.physics.options),i.deepExtend(e.global,this.canvas.options),i.deepExtend(e.global,this.options),this.configurator.setModuleOptions(e)}void 0!==e.clickToUse?!0===e.clickToUse?void 0===this.activator&&(this.activator=new $(this.canvas.frame),this.activator.on("change",()=>{this.body.emitter.emit("activate")})):(void 0!==this.activator&&(this.activator.destroy(),delete this.activator),this.body.emitter.emit("activate")):this.body.emitter.emit("activate"),this.canvas.setSize(),this.body.emitter.emit("startSimulation")}},jt.prototype._updateVisibleIndices=function(){let e=this.body.nodes,t=this.body.edges;this.body.nodeIndices=[],this.body.edgeIndices=[];for(let t in e)e.hasOwnProperty(t)&&(this.clustering._isClusteredNode(t)||!1!==e[t].options.hidden||this.body.nodeIndices.push(e[t].id));for(let i in t)if(t.hasOwnProperty(i)){let o=t[i],s=e[o.fromId],n=e[o.toId],r=void 0!==s&&void 0!==n;!this.clustering._isClusteredEdge(i)&&!1===o.options.hidden&&r&&!1===s.options.hidden&&!1===n.options.hidden&&this.body.edgeIndices.push(o.id)}},jt.prototype.bindEventListeners=function(){this.body.emitter.on("_dataChanged",()=>{this.edgesHandler._updateState(),this.body.emitter.emit("_dataUpdated")}),this.body.emitter.on("_dataUpdated",()=>{this.clustering._updateState(),this._updateVisibleIndices(),this._updateValueRange(this.body.nodes),this._updateValueRange(this.body.edges),this.body.emitter.emit("startSimulation"),this.body.emitter.emit("_requestRedraw")})},jt.prototype.setData=function(e){if(this.body.emitter.emit("resetPhysics"),this.body.emitter.emit("_resetData"),this.selectionHandler.unselectAll(),e&&e.dot&&(e.nodes||e.edges))throw new SyntaxError('Data must contain either parameter "dot" or  parameter pair "nodes" and "edges", but not both.');if(this.setOptions(e&&e.options),e&&e.dot){console.log("The dot property has been deprecated. Please use the static convertDot method to convert DOT into vis.network format and use the normal data format with nodes and edges. This converter is used like this: var data = vis.network.convertDot(dotString);");var t=X(e.dot);this.setData(t)}else if(e&&e.gephi){console.log("The gephi property has been deprecated. Please use the static convertGephi method to convert gephi into vis.network format and use the normal data format with nodes and edges. This converter is used like this: var data = vis.network.convertGephi(gephiJson);");var i=K(e.gephi);this.setData(i)}else this.nodesHandler.setData(e&&e.nodes,!0),this.edgesHandler.setData(e&&e.edges,!0),this.body.emitter.emit("_dataChanged"),this.body.emitter.emit("_dataLoaded"),this.body.emitter.emit("initPhysics")},jt.prototype.destroy=function(){for(var e in this.body.emitter.emit("destroy"),this.body.emitter.off(),this.off(),delete this.groups,delete this.canvas,delete this.selectionHandler,delete this.interactionHandler,delete this.view,delete this.renderer,delete this.physics,delete this.layoutEngine,delete this.clustering,delete this.manipulation,delete this.nodesHandler,delete this.edgesHandler,delete this.configurator,delete this.images,this.body.nodes)this.body.nodes.hasOwnProperty(e)&&delete this.body.nodes[e];for(var t in this.body.edges)this.body.edges.hasOwnProperty(t)&&delete this.body.edges[t];i.recursiveDOMDelete(this.body.container)},jt.prototype._updateValueRange=function(e){var t,i=void 0,o=void 0,s=0;for(t in e)if(e.hasOwnProperty(t)){var n=e[t].getValue();void 0!==n&&(i=void 0===i?n:Math.min(n,i),o=void 0===o?n:Math.max(n,o),s+=n)}if(void 0!==i&&void 0!==o)for(t in e)e.hasOwnProperty(t)&&e[t].setValueRange(i,o,s)},jt.prototype.isActive=function(){return!this.activator||this.activator.active},jt.prototype.setSize=function(){return this.canvas.setSize.apply(this.canvas,arguments)},jt.prototype.canvasToDOM=function(){return this.canvas.canvasToDOM.apply(this.canvas,arguments)},jt.prototype.DOMtoCanvas=function(){return this.canvas.DOMtoCanvas.apply(this.canvas,arguments)},jt.prototype.findNode=function(){return this.clustering.findNode.apply(this.clustering,arguments)},jt.prototype.isCluster=function(){return this.clustering.isCluster.apply(this.clustering,arguments)},jt.prototype.openCluster=function(){return this.clustering.openCluster.apply(this.clustering,arguments)},jt.prototype.cluster=function(){return this.clustering.cluster.apply(this.clustering,arguments)},jt.prototype.getNodesInCluster=function(){return this.clustering.getNodesInCluster.apply(this.clustering,arguments)},jt.prototype.clusterByConnection=function(){return this.clustering.clusterByConnection.apply(this.clustering,arguments)},jt.prototype.clusterByHubsize=function(){return this.clustering.clusterByHubsize.apply(this.clustering,arguments)},jt.prototype.updateClusteredNode=function(){return this.clustering.updateClusteredNode.apply(this.clustering,arguments)},jt.prototype.getClusteredEdges=function(){return this.clustering.getClusteredEdges.apply(this.clustering,arguments)},jt.prototype.getBaseEdge=function(){return this.clustering.getBaseEdge.apply(this.clustering,arguments)},jt.prototype.getBaseEdges=function(){return this.clustering.getBaseEdges.apply(this.clustering,arguments)},jt.prototype.updateEdge=function(){return this.clustering.updateEdge.apply(this.clustering,arguments)},jt.prototype.clusterOutliers=function(){return this.clustering.clusterOutliers.apply(this.clustering,arguments)},jt.prototype.getSeed=function(){return this.layoutEngine.getSeed.apply(this.layoutEngine,arguments)},jt.prototype.enableEditMode=function(){return this.manipulation.enableEditMode.apply(this.manipulation,arguments)},jt.prototype.disableEditMode=function(){return this.manipulation.disableEditMode.apply(this.manipulation,arguments)},jt.prototype.addNodeMode=function(){return this.manipulation.addNodeMode.apply(this.manipulation,arguments)},jt.prototype.editNode=function(){return this.manipulation.editNode.apply(this.manipulation,arguments)},jt.prototype.editNodeMode=function(){return console.log("Deprecated: Please use editNode instead of editNodeMode."),this.manipulation.editNode.apply(this.manipulation,arguments)},jt.prototype.addEdgeMode=function(){return this.manipulation.addEdgeMode.apply(this.manipulation,arguments)},jt.prototype.editEdgeMode=function(){return this.manipulation.editEdgeMode.apply(this.manipulation,arguments)},jt.prototype.deleteSelected=function(){return this.manipulation.deleteSelected.apply(this.manipulation,arguments)},jt.prototype.getPositions=function(){return this.nodesHandler.getPositions.apply(this.nodesHandler,arguments)},jt.prototype.getPosition=function(){return this.nodesHandler.getPosition.apply(this.nodesHandler,arguments)},jt.prototype.storePositions=function(){return this.nodesHandler.storePositions.apply(this.nodesHandler,arguments)},jt.prototype.moveNode=function(){return this.nodesHandler.moveNode.apply(this.nodesHandler,arguments)},jt.prototype.getBoundingBox=function(){return this.nodesHandler.getBoundingBox.apply(this.nodesHandler,arguments)},jt.prototype.getConnectedNodes=function(e){return void 0!==this.body.nodes[e]?this.nodesHandler.getConnectedNodes.apply(this.nodesHandler,arguments):this.edgesHandler.getConnectedNodes.apply(this.edgesHandler,arguments)},jt.prototype.getConnectedEdges=function(){return this.nodesHandler.getConnectedEdges.apply(this.nodesHandler,arguments)},jt.prototype.startSimulation=function(){return this.physics.startSimulation.apply(this.physics,arguments)},jt.prototype.stopSimulation=function(){return this.physics.stopSimulation.apply(this.physics,arguments)},jt.prototype.stabilize=function(){return this.physics.stabilize.apply(this.physics,arguments)},jt.prototype.getSelection=function(){return this.selectionHandler.getSelection.apply(this.selectionHandler,arguments)},jt.prototype.setSelection=function(){return this.selectionHandler.setSelection.apply(this.selectionHandler,arguments)},jt.prototype.getSelectedNodes=function(){return this.selectionHandler.getSelectedNodes.apply(this.selectionHandler,arguments)},jt.prototype.getSelectedEdges=function(){return this.selectionHandler.getSelectedEdges.apply(this.selectionHandler,arguments)},jt.prototype.getNodeAt=function(){var e=this.selectionHandler.getNodeAt.apply(this.selectionHandler,arguments);return void 0!==e&&void 0!==e.id?e.id:e},jt.prototype.getEdgeAt=function(){var e=this.selectionHandler.getEdgeAt.apply(this.selectionHandler,arguments);return void 0!==e&&void 0!==e.id?e.id:e},jt.prototype.selectNodes=function(){return this.selectionHandler.selectNodes.apply(this.selectionHandler,arguments)},jt.prototype.selectEdges=function(){return this.selectionHandler.selectEdges.apply(this.selectionHandler,arguments)},jt.prototype.unselectAll=function(){this.selectionHandler.unselectAll.apply(this.selectionHandler,arguments),this.redraw()},jt.prototype.redraw=function(){return this.renderer.redraw.apply(this.renderer,arguments)},jt.prototype.getScale=function(){return this.view.getScale.apply(this.view,arguments)},jt.prototype.getViewPosition=function(){return this.view.getViewPosition.apply(this.view,arguments)},jt.prototype.fit=function(){return this.view.fit.apply(this.view,arguments)},jt.prototype.moveTo=function(){return this.view.moveTo.apply(this.view,arguments)},jt.prototype.focus=function(){return this.view.focus.apply(this.view,arguments)},jt.prototype.releaseNode=function(){return this.view.releaseNode.apply(this.view,arguments)},jt.prototype.getOptionsFromConfigurator=function(){let e={};return this.configurator&&(e=this.configurator.getOptions.apply(this.configurator)),e};const Ht=X;e.Network=jt,e.NetworkImages=te,e.networkDOTParser=G,e.networkGephiParser=Z,e.networkOptions=Nt,e.parseDOTNetwork=Ht,e.parseGephiNetwork=K,Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=vis-network.min.js.map
